# Node.js 11 ChangeLog

<!--lint disable prohibited-strings-->
<!--lint disable maximum-line-length-->

<table>
<tr>
<th>Current</th>
</tr>
<tr>
<td>
<a href="#11.6.0">11.6.0</a><br/>
<a href="#11.5.0">11.5.0</a><br/>
<a href="#11.4.0">11.4.0</a><br/>
<a href="#11.3.0">11.3.0</a><br/>
<a href="#11.2.0">11.2.0</a><br/>
<a href="#11.1.0">11.1.0</a><br/>
<a href="#11.0.0">11.0.0</a><br/>
</td>
</tr>
</table>

* Other Versions
  * [10.x](CHANGELOG_V10.md)
  * [9.x](CHANGELOG_V9.md)
  * [8.x](CHANGELOG_V8.md)
  * [7.x](CHANGELOG_V7.md)
  * [6.x](CHANGELOG_V6.md)
  * [5.x](CHANGELOG_V5.md)
  * [4.x](CHANGELOG_V4.md)
  * [0.12.x](CHANGELOG_V012.md)
  * [0.10.x](CHANGELOG_V010.md)
  * [io.js](CHANGELOG_IOJS.md)
  * [Archive](CHANGELOG_ARCHIVE.md)

<a id="11.6.0"></a>
## 2018-12-26, Version 11.6.0 (Current), @MylesBorins

This is a special release to add a CLI flag to set the max http header size.
This should have been included in the 11.3.0 security release.

### Notable Changes

* **cli**: add --max-http-header-size flag (cjihrig) [#24811](https://github.com/nodejs/node/pull/24811)

### Commits

* [[`edd8bd0ee0`](https://github.com/nodejs/node/commit/edd8bd0ee0)] - **cli**: add --max-http-header-size flag (cjihrig) [#24811](https://github.com/nodejs/node/pull/24811)
* [[`0057af293a`](https://github.com/nodejs/node/commit/0057af293a)] - **deps**: cherry-pick http\_parser\_set\_max\_header\_size (cjihrig) [#24811](https://github.com/nodejs/node/pull/24811)
* [[`c80ac7fae3`](https://github.com/nodejs/node/commit/c80ac7fae3)] - **src**: add kUInteger parsing (Matteo Collina) [#24811](https://github.com/nodejs/node/pull/24811)

<a id="11.5.0"></a>
## 2018-12-18, Version 11.5.0 (Current), @BethGriggs

### Notable Changes

* **tls**:
  * support "BEGIN TRUSTED CERTIFICATE" for ca: (Sam Roberts) [#24733](https://github.com/nodejs/node/pull/24733)
* **util**:
  * add inspection getter option (Ruben Bridgewater) [#24852](https://github.com/nodejs/node/pull/24852)

### Commits
  * [[`bf4faf3ffc`](https://github.com/nodejs/node/commit/bf4faf3ffc)] - **assert,util**: harden comparison (Ruben Bridgewater) [#24831](https://github.com/nodejs/node/pull/24831)
  * [[`302081bafc`](https://github.com/nodejs/node/commit/302081bafc)] - **build**: make lint-addon-docs run only if needed (Daniel Bevenius) [#24993](https://github.com/nodejs/node/pull/24993)
  * [[`cc8a805e31`](https://github.com/nodejs/node/commit/cc8a805e31)] - **build**: fix compiler version detection (Richard Lau) [#24879](https://github.com/nodejs/node/pull/24879)
  * [[`bde5df20d6`](https://github.com/nodejs/node/commit/bde5df20d6)] - **doc**: fix node.1 --http-parser sort order (cjihrig) [#25045](https://github.com/nodejs/node/pull/25045)
  * [[`a9f239fb60`](https://github.com/nodejs/node/commit/a9f239fb60)] - **doc**: add EventTarget link to worker\_threads (Azard) [#25058](https://github.com/nodejs/node/pull/25058)
  * [[`00ce972305`](https://github.com/nodejs/node/commit/00ce972305)] - **doc**: make README formatting more consistent (wenjun ye) [#25003](https://github.com/nodejs/node/pull/25003)
  * [[`dbdea36190`](https://github.com/nodejs/node/commit/dbdea36190)] - **doc**: add codebytere's info to release team (Shelley Vohr) [#25022](https://github.com/nodejs/node/pull/25022)
  * [[`877f8a0094`](https://github.com/nodejs/node/commit/877f8a0094)] - **doc**: revise internal vs. public API in Collaborator Guide (Rich Trott) [#24975](https://github.com/nodejs/node/pull/24975)
  * [[`f0bcacdcc6`](https://github.com/nodejs/node/commit/f0bcacdcc6)] - **doc**: update a link of npm repository (Daijiro Wachi) [#24969](https://github.com/nodejs/node/pull/24969)
  * [[`1e096291d6`](https://github.com/nodejs/node/commit/1e096291d6)] - **doc**: fix author-ready conflict (Ruben Bridgewater) [#25015](https://github.com/nodejs/node/pull/25015)
  * [[`b2e6cbddd8`](https://github.com/nodejs/node/commit/b2e6cbddd8)] - **doc**: update Useful CI Jobs section of Collaborator Guide (Rich Trott) [#24916](https://github.com/nodejs/node/pull/24916)
  * [[`9bfbb6822b`](https://github.com/nodejs/node/commit/9bfbb6822b)] - **doc**: add class worker documentation (yoshimoto koki) [#24849](https://github.com/nodejs/node/pull/24849)
  * [[`0220cd3260`](https://github.com/nodejs/node/commit/0220cd3260)] - **doc**: remove bad link to irc info (Richard Lau) [#24967](https://github.com/nodejs/node/pull/24967)
  * [[`a6a3829962`](https://github.com/nodejs/node/commit/a6a3829962)] - **doc**: simplify author ready (Ruben Bridgewater) [#24893](https://github.com/nodejs/node/pull/24893)
  * [[`cda1da9200`](https://github.com/nodejs/node/commit/cda1da9200)] - **doc**: update "Testing and CI" in Collaborator Guide (Rich Trott) [#24884](https://github.com/nodejs/node/pull/24884)
  * [[`81dce68a9d`](https://github.com/nodejs/node/commit/81dce68a9d)] - **doc**: update http doc for new Agent()/support options in socket.connect() (Beni von Cheni) [#24846](https://github.com/nodejs/node/pull/24846)
  * [[`643ca14d2c`](https://github.com/nodejs/node/commit/643ca14d2c)] - **doc**: fix order of events when request is aborted (Luigi Pinca) [#24779](https://github.com/nodejs/node/pull/24779)
  * [[`c300aaa208`](https://github.com/nodejs/node/commit/c300aaa208)] - **doc**: update LICENSE file (Anna Henningsen) [#24898](https://github.com/nodejs/node/pull/24898)
  * [[`c4f3cf9759`](https://github.com/nodejs/node/commit/c4f3cf9759)] - **doc**: revise Waiting for Approvals documentation (Rich Trott) [#24845](https://github.com/nodejs/node/pull/24845)
  * [[`56b2a7274c`](https://github.com/nodejs/node/commit/56b2a7274c)] - **inspector**: split the HostPort being used and the one parsed from CLI (Joyee Cheung) [#24772](https://github.com/nodejs/node/pull/24772)
  * [[`2456a545a6`](https://github.com/nodejs/node/commit/2456a545a6)] - **lib**: ensure readable stream flows to end (Mikko Rantanen) [#24918](https://github.com/nodejs/node/pull/24918)
  * [[`79c52a9f88`](https://github.com/nodejs/node/commit/79c52a9f88)] - **lib**: improve error creation performance (Ruben Bridgewater) [#24747](https://github.com/nodejs/node/pull/24747)
  * [[`25dae6cffd`](https://github.com/nodejs/node/commit/25dae6cffd)] - **module**: use validateString in modules/esm (ZYSzys) [#24868](https://github.com/nodejs/node/pull/24868)
  * [[`2a11e6aaf3`](https://github.com/nodejs/node/commit/2a11e6aaf3)] - **module**: use validateString in modules/cjs (ZYSzys) [#24863](https://github.com/nodejs/node/pull/24863)
  * [[`f4d5c358d9`](https://github.com/nodejs/node/commit/f4d5c358d9)] - **net**: use strict comparisons for fd (cjihrig) [#25014](https://github.com/nodejs/node/pull/25014)
  * [[`5f60ed7647`](https://github.com/nodejs/node/commit/5f60ed7647)] - **path**: replace assertPath() with validator (cjihrig) [#24840](https://github.com/nodejs/node/pull/24840)
  * [[`f43f45a26c`](https://github.com/nodejs/node/commit/f43f45a26c)] - **process**: properly close file descriptor on exit (Ruben Bridgewater) [#24972](https://github.com/nodejs/node/pull/24972)
  * [[`8b109f05d9`](https://github.com/nodejs/node/commit/8b109f05d9)] - **process**: simplify check in previousValueIsValid() (cjihrig) [#24836](https://github.com/nodejs/node/pull/24836)
  * [[`2e94f3b798`](https://github.com/nodejs/node/commit/2e94f3b798)] - **querystring**: remove eslint-disable (cjihrig) [#24995](https://github.com/nodejs/node/pull/24995)
  * [[`5f8950b652`](https://github.com/nodejs/node/commit/5f8950b652)] - **src**: emit 'params' instead of 'data' for NodeTracing.dataCollected (Kelvin Jin) [#24949](https://github.com/nodejs/node/pull/24949)
  * [[`d0270f3a5c`](https://github.com/nodejs/node/commit/d0270f3a5c)] - **src**: add GetLoadedLibraries routine (Gireesh Punathil) [#24825](https://github.com/nodejs/node/pull/24825)
  * [[`f8547019c7`](https://github.com/nodejs/node/commit/f8547019c7)] - **src**: include node\_internals.h in node\_metadata.cc (Daniel Bevenius) [#24933](https://github.com/nodejs/node/pull/24933)
  * [[`5a1289d128`](https://github.com/nodejs/node/commit/5a1289d128)] - **src**: create env-\>inspector\_console\_api\_object earlier (Joyee Cheung) [#24906](https://github.com/nodejs/node/pull/24906)
  * [[`d7605725df`](https://github.com/nodejs/node/commit/d7605725df)] - **src**: remove use of CallOnForegroundThread() (cjihrig) [#24925](https://github.com/nodejs/node/pull/24925)
  * [[`08c6b2126c`](https://github.com/nodejs/node/commit/08c6b2126c)] - **src**: use Local version of ToBoolean() (cjihrig) [#24924](https://github.com/nodejs/node/pull/24924)
  * [[`5206f3add5`](https://github.com/nodejs/node/commit/5206f3add5)] - **src**: do not alias new and old signal masks (Sam Roberts) [#24810](https://github.com/nodejs/node/pull/24810)
  * [[`94d02cabb9`](https://github.com/nodejs/node/commit/94d02cabb9)] - **src**: fix warning for potential snprintf truncation (Sam Roberts) [#24810](https://github.com/nodejs/node/pull/24810)
  * [[`9b000e5088`](https://github.com/nodejs/node/commit/9b000e5088)] - **src**: remove finalized\_ member from Hash class (Daniel Bevenius) [#24822](https://github.com/nodejs/node/pull/24822)
  * [[`90d481ea45`](https://github.com/nodejs/node/commit/90d481ea45)] - **src**: remove unused env variables in node\_util (Daniel Bevenius) [#24820](https://github.com/nodejs/node/pull/24820)
  * [[`d449c36500`](https://github.com/nodejs/node/commit/d449c36500)] - **stream**: re-use existing `once()` implementation (Anna Henningsen) [#24991](https://github.com/nodejs/node/pull/24991)
  * [[`39af61faa2`](https://github.com/nodejs/node/commit/39af61faa2)] - **stream**: fix end-of-stream for HTTP/2 (Anna Henningsen) [#24926](https://github.com/nodejs/node/pull/24926)
  * [[`4f0d17b019`](https://github.com/nodejs/node/commit/4f0d17b019)] - **test**: remove unnecessary linter comment (cjihrig) [#25013](https://github.com/nodejs/node/pull/25013)
  * [[`ab1801b8ad`](https://github.com/nodejs/node/commit/ab1801b8ad)] - **test**: use global.gc() instead of gc() (cjihrig) [#25012](https://github.com/nodejs/node/pull/25012)
  * [[`ddff644172`](https://github.com/nodejs/node/commit/ddff644172)] - **test**: run eslint on test file and fix errors (Ruben Bridgewater) [#25009](https://github.com/nodejs/node/pull/25009)
  * [[`110fd39dfe`](https://github.com/nodejs/node/commit/110fd39dfe)] - **test**: remove dead code (Ruben Bridgewater) [#25009](https://github.com/nodejs/node/pull/25009)
  * [[`e04e85460f`](https://github.com/nodejs/node/commit/e04e85460f)] - **test**: use blocks instead of async IIFE (Anna Henningsen) [#24989](https://github.com/nodejs/node/pull/24989)
  * [[`eb9e6e6576`](https://github.com/nodejs/node/commit/eb9e6e6576)] - **test**: adding history regression test case (Anto Aravinth) [#24843](https://github.com/nodejs/node/pull/24843)
  * [[`ac919efbaf`](https://github.com/nodejs/node/commit/ac919efbaf)] - **test**: mark test-child-process-execfile flaky (Rich Trott) [#25051](https://github.com/nodejs/node/pull/25051)
  * [[`1e3fb0ae03`](https://github.com/nodejs/node/commit/1e3fb0ae03)] - **test**: mark test-child-process-exit-code flaky (Rich Trott) [#25050](https://github.com/nodejs/node/pull/25050)
  * [[`7e0dbc6e01`](https://github.com/nodejs/node/commit/7e0dbc6e01)] - **test**: improve WPT runner name matching (Joyee Cheung) [#24826](https://github.com/nodejs/node/pull/24826)
  * [[`da984be0a3`](https://github.com/nodejs/node/commit/da984be0a3)] - **test**: remove reference to whatwg in file names under test/wpt (Joyee Cheung) [#24826](https://github.com/nodejs/node/pull/24826)
  * [[`282589456c`](https://github.com/nodejs/node/commit/282589456c)] - **test**: mark test-worker-memory flaky on Windows CI (Rich Trott) [#25042](https://github.com/nodejs/node/pull/25042)
  * [[`9bd42671c9`](https://github.com/nodejs/node/commit/9bd42671c9)] - **test**: mark test-cli-node-options flaky on arm (Rich Trott) [#25032](https://github.com/nodejs/node/pull/25032)
  * [[`a4ef54a0a6`](https://github.com/nodejs/node/commit/a4ef54a0a6)] - **test**: mark test-child-process-execsync flaky on AIX (Rich Trott) [#25031](https://github.com/nodejs/node/pull/25031)
  * [[`900a412f3f`](https://github.com/nodejs/node/commit/900a412f3f)] - **test**: increase error information in test-cli-syntax-\* (Rich Trott) [#25021](https://github.com/nodejs/node/pull/25021)
  * [[`d5b0ce15d3`](https://github.com/nodejs/node/commit/d5b0ce15d3)] - **test**: refactor test-enable-in-init (Mitch Hankins) [#24976](https://github.com/nodejs/node/pull/24976)
  * [[`649a7289dc`](https://github.com/nodejs/node/commit/649a7289dc)] - **test**: from functools import reduce in test/testpy/\_\_init\_\_.py (cclauss) [#24954](https://github.com/nodejs/node/pull/24954)
  * [[`d366676cc5`](https://github.com/nodejs/node/commit/d366676cc5)] - **test**: split test-cli-syntax into multiple tests (Rich Trott) [#24922](https://github.com/nodejs/node/pull/24922)
  * [[`e61bbda85d`](https://github.com/nodejs/node/commit/e61bbda85d)] - **test**: improve internet/test-dns (Ilarion Halushka) [#24927](https://github.com/nodejs/node/pull/24927)
  * [[`016e35210c`](https://github.com/nodejs/node/commit/016e35210c)] - **(SEMVER-MINOR)** **test**: test TLS client authentication (Sam Roberts) [#24733](https://github.com/nodejs/node/pull/24733)
  * [[`e050a5756f`](https://github.com/nodejs/node/commit/e050a5756f)] - **test**: replace callback with arrows (Shubham Urkade) [#24866](https://github.com/nodejs/node/pull/24866)
  * [[`22b6befa14`](https://github.com/nodejs/node/commit/22b6befa14)] - **test**: mark test-cli-syntax as flaky/unreliable (Rich Trott) [#24957](https://github.com/nodejs/node/pull/24957)
  * [[`56fd127ef0`](https://github.com/nodejs/node/commit/56fd127ef0)] - **test**: do not lint macros files (again) (cclauss) [#24886](https://github.com/nodejs/node/pull/24886)
  * [[`bc71e9e0d6`](https://github.com/nodejs/node/commit/bc71e9e0d6)] - **test**: prepare test/pseudo-tty/testcfg.py Python 3 (cclauss) [#24887](https://github.com/nodejs/node/pull/24887)
  * [[`f41443cc5c`](https://github.com/nodejs/node/commit/f41443cc5c)] - **test**: move test-cli-syntax to sequential (Rich Trott) [#24907](https://github.com/nodejs/node/pull/24907)
  * [[`592bad1b0b`](https://github.com/nodejs/node/commit/592bad1b0b)] - **test**: move http2 test to parallel (Rich Trott) [#24877](https://github.com/nodejs/node/pull/24877)
  * [[`91ce957037`](https://github.com/nodejs/node/commit/91ce957037)] - **test**: make http2 timeout test robust (Rich Trott) [#24877](https://github.com/nodejs/node/pull/24877)
  * [[`3d87688fba`](https://github.com/nodejs/node/commit/3d87688fba)] - **test**: fix wrong parameter (zhmushan) [#24844](https://github.com/nodejs/node/pull/24844)
  * [[`6db760c231`](https://github.com/nodejs/node/commit/6db760c231)] - **test**: improve test-net-socket-timeout (Rich Trott) [#24859](https://github.com/nodejs/node/pull/24859)
  * [[`526ff1d1d2`](https://github.com/nodejs/node/commit/526ff1d1d2)] - **test**: prepare test/pseudo-tty/testcfg.py for Python 3 (cclauss) [#24791](https://github.com/nodejs/node/pull/24791)
  * [[`a5c57861a9`](https://github.com/nodejs/node/commit/a5c57861a9)] - **test**: refactor test-fs-write-file-sync.js (cjihrig) [#24834](https://github.com/nodejs/node/pull/24834)
  * [[`a5c8af7af4`](https://github.com/nodejs/node/commit/a5c8af7af4)] - **test**: prepare test/message/testcfg.py for Python 3 (cclauss) [#24793](https://github.com/nodejs/node/pull/24793)
  * [[`390e050ae0`](https://github.com/nodejs/node/commit/390e050ae0)] - **(SEMVER-MINOR)** **tls**: support "BEGIN TRUSTED CERTIFICATE" for ca: (Sam Roberts) [#24733](https://github.com/nodejs/node/pull/24733)
  * [[`16a75beffc`](https://github.com/nodejs/node/commit/16a75beffc)] - **tools**: prepare ./tools/compress\_json.py for Python 3 (cclauss) [#24889](https://github.com/nodejs/node/pull/24889)
  * [[`b60808a2da`](https://github.com/nodejs/node/commit/b60808a2da)] - **tools**: prepare tools/testp.py for Python 3 (cclauss) [#24890](https://github.com/nodejs/node/pull/24890)
  * [[`1f61c89a7f`](https://github.com/nodejs/node/commit/1f61c89a7f)] - **tools**: prepare tools/icu/icutrim.py for Python 3 (cclauss) [#24888](https://github.com/nodejs/node/pull/24888)
  * [[`e140d41789`](https://github.com/nodejs/node/commit/e140d41789)] - **tools**: capitalize sentences (Ruben Bridgewater) [#24808](https://github.com/nodejs/node/pull/24808)
  * [[`ad6104dbac`](https://github.com/nodejs/node/commit/ad6104dbac)] - **tools**: update ESLint to 5.10.0 (cjihrig) [#24903](https://github.com/nodejs/node/pull/24903)
  * [[`ac46e27714`](https://github.com/nodejs/node/commit/ac46e27714)] - **tools**: do not lint tools/inspector\_protocol or tools/markupsafe (cclauss) [#24882](https://github.com/nodejs/node/pull/24882)
  * [[`c3dda00e48`](https://github.com/nodejs/node/commit/c3dda00e48)] - **tools**: prepare tools/js2c.py for Python 3 (cclauss) [#24798](https://github.com/nodejs/node/pull/24798)
  * [[`7cac76cdd5`](https://github.com/nodejs/node/commit/7cac76cdd5)] - **tools**: prepare tools/specialize\_node\_d.py for Python 3 (cclauss) [#24797](https://github.com/nodejs/node/pull/24797)
  * [[`15632c3867`](https://github.com/nodejs/node/commit/15632c3867)] - **tools**: prepare tools/test.py for Python 3 (cclauss) [#24799](https://github.com/nodejs/node/pull/24799)
  * [[`022599c0e1`](https://github.com/nodejs/node/commit/022599c0e1)] - **tools**: prepare tools/genv8constants.py for Python 3 (cclauss) [#24801](https://github.com/nodejs/node/pull/24801)
  * [[`e7b77ead74`](https://github.com/nodejs/node/commit/e7b77ead74)] - **url**: remove an eslint-disable comment (cjihrig) [#24995](https://github.com/nodejs/node/pull/24995)
  * [[`59317470e3`](https://github.com/nodejs/node/commit/59317470e3)] - **util**: inspect all prototypes (Ruben Bridgewater) [#24974](https://github.com/nodejs/node/pull/24974)
  * [[`a1f0da1d40`](https://github.com/nodejs/node/commit/a1f0da1d40)] - **util**: remove todo (Ruben Bridgewater) [#24982](https://github.com/nodejs/node/pull/24982)
  * [[`117e99121c`](https://github.com/nodejs/node/commit/117e99121c)] - **(SEMVER-MINOR)** **util**: add inspection getter option (Ruben Bridgewater) [#24852](https://github.com/nodejs/node/pull/24852)
  * [[`331f6044b9`](https://github.com/nodejs/node/commit/331f6044b9)] - **worker**: drain messages from internal message port (Yael Hermon) [#24932](https://github.com/nodejs/node/pull/24932)

<a id="11.4.0"></a>
## 2018-12-07, Version 11.4.0 (Current), @BridgeAR

### Notable Changes

* **console,util**:
  * `console` functions now handle symbols as defined in the spec. https://github.com/nodejs/node/pull/23708
  * The inspection `depth` default is now back at 2. https://github.com/nodejs/node/pull/24326
* **dgram,net**:
  * Added ipv6Only option for `net` and `dgram`. https://github.com/nodejs/node/pull/23798
* **http**:
  * Chosing between the http parser is now possible per runtime flag. https://github.com/nodejs/node/pull/24739
* **readline**:
  * The `readline` module now supports async iterators. https://github.com/nodejs/node/pull/23916
* **repl**:
  * The multiline history feature is removed. https://github.com/nodejs/node/pull/24804
* **tls**:
  * Added min/max protocol version options. https://github.com/nodejs/node/pull/24405
  * The X.509 public key info now includes the RSA bit size and the elliptic curve. https://github.com/nodejs/node/pull/24358
* **url**:
  * `pathToFileURL()` now supports LF, CR and TAB. https://github.com/nodejs/node/pull/23720
* **Windows**:
  * Tools are not installed using Boxstarter anymore. https://github.com/nodejs/node/pull/24677
  * The install-tools scripts or now included in the dist. https://github.com/nodejs/node/pull/24233
* **Added new collaborator**:
  * [antsmartian](https://github.com/antsmartian) - Anto Aravinth. https://github.com/nodejs/node/pull/24655

### Commits

* [[`7fb8d319fa`](https://github.com/nodejs/node/commit/7fb8d319fa)] - **assert**: fix loose deepEqual map comparison (Ruben Bridgewater) [#24749](https://github.com/nodejs/node/pull/24749)
* [[`8905518650`](https://github.com/nodejs/node/commit/8905518650)] - **assert,util**: fix sparse array comparison (Ruben Bridgewater) [#24749](https://github.com/nodejs/node/pull/24749)
* [[`ef63bb287d`](https://github.com/nodejs/node/commit/ef63bb287d)] - **benchmark**: support URL inputs in create-clientrequest (Joyee Cheung) [#24302](https://github.com/nodejs/node/pull/24302)
* [[`f5d4db1e9c`](https://github.com/nodejs/node/commit/f5d4db1e9c)] - **benchmark**: pre-generate data set for URL benchmarks (Joyee Cheung) [#24302](https://github.com/nodejs/node/pull/24302)
* [[`73786c854a`](https://github.com/nodejs/node/commit/73786c854a)] - **buffer**: remove checkNumberType() (cjihrig) [#24815](https://github.com/nodejs/node/pull/24815)
* [[`a22ac0bb66`](https://github.com/nodejs/node/commit/a22ac0bb66)] - **build**: add '.git' to 'make lint-py' exclude list (cclauss) [#24802](https://github.com/nodejs/node/pull/24802)
* [[`bfec6a4eb3`](https://github.com/nodejs/node/commit/bfec6a4eb3)] - **build**: fix check-xz for platforms defaulting to sh (Rod Vagg) [#24841](https://github.com/nodejs/node/pull/24841)
* [[`3a24c91c7d`](https://github.com/nodejs/node/commit/3a24c91c7d)] - **build**: make tar.xz creation opt-out, fail if no xz (Rod Vagg) [#24551](https://github.com/nodejs/node/pull/24551)
* [[`6b71099303`](https://github.com/nodejs/node/commit/6b71099303)] - **build**: add line break as soon tests are done (Ruben Bridgewater) [#24748](https://github.com/nodejs/node/pull/24748)
* [[`e0e15da6ca`](https://github.com/nodejs/node/commit/e0e15da6ca)] - **build**: fix line length off by one error (Ruben Bridgewater) [#24748](https://github.com/nodejs/node/pull/24748)
* [[`3fe4498fe1`](https://github.com/nodejs/node/commit/3fe4498fe1)] - **build**: fix c++ code coverage on macOS (Refael Ackermann) [#24520](https://github.com/nodejs/node/pull/24520)
* [[`955819e0a3`](https://github.com/nodejs/node/commit/955819e0a3)] - **build**: only check REPLACEME & DEP...X for releases (Rod Vagg) [#24575](https://github.com/nodejs/node/pull/24575)
* [[`3fa4def6ea`](https://github.com/nodejs/node/commit/3fa4def6ea)] - **build**: replace `-not` with `!` in `find` (Rich Trott) [#24635](https://github.com/nodejs/node/pull/24635)
* [[`e37c6182e5`](https://github.com/nodejs/node/commit/e37c6182e5)] - **build**: fix Python detection when depot\_tools are in PATH in Windows (Guy Bedford) [#22539](https://github.com/nodejs/node/pull/22539)
* [[`39614add79`](https://github.com/nodejs/node/commit/39614add79)] - **build**: remove sudo:false from .travis.yml (Rich Trott) [#24511](https://github.com/nodejs/node/pull/24511)
* [[`21e59a68cf`](https://github.com/nodejs/node/commit/21e59a68cf)] - **build**: use print() function in configure.py (cclauss) [#24484](https://github.com/nodejs/node/pull/24484)
* [[`4dc1e785a3`](https://github.com/nodejs/node/commit/4dc1e785a3)] - **build**: check minimum ICU in configure for system-icu (Steven R. Loomis) [#24255](https://github.com/nodejs/node/pull/24255)
* [[`c5e32fdebf`](https://github.com/nodejs/node/commit/c5e32fdebf)] - **build**: remove unnecessary prerequisite in Makefile (Rich Trott) [#24342](https://github.com/nodejs/node/pull/24342)
* [[`383d8092b1`](https://github.com/nodejs/node/commit/383d8092b1)] - **build, tools, win**: add .S files support to GYP (Bartosz Sosnowski) [#24553](https://github.com/nodejs/node/pull/24553)
* [[`bd4df5b326`](https://github.com/nodejs/node/commit/bd4df5b326)] - **build,src**: sync src files with node.gyp (Refael Ackermann) [#24505](https://github.com/nodejs/node/pull/24505)
* [[`331b26eda9`](https://github.com/nodejs/node/commit/331b26eda9)] - **build,tools**: update make-v8.sh for ppc64le (Refael Ackermann) [#24293](https://github.com/nodejs/node/pull/24293)
* [[`706bc414b9`](https://github.com/nodejs/node/commit/706bc414b9)] - **(SEMVER-MINOR)** **build,win**: pack the install-tools scripts for dist (Refael Ackermann) [#24233](https://github.com/nodejs/node/pull/24233)
* [[`b214ae44c8`](https://github.com/nodejs/node/commit/b214ae44c8)] - **cli**: add missing env vars to --help (cjihrig) [#24383](https://github.com/nodejs/node/pull/24383)
* [[`50005e7ddf`](https://github.com/nodejs/node/commit/50005e7ddf)] - **console**: improve code readability (gengjiawen) [#24412](https://github.com/nodejs/node/pull/24412)
* [[`12feb9e492`](https://github.com/nodejs/node/commit/12feb9e492)] - **crypto**: harden bignum-to-binary conversions (Ben Noordhuis) [#24719](https://github.com/nodejs/node/pull/24719)
* [[`c15efcec92`](https://github.com/nodejs/node/commit/c15efcec92)] - **crypto**: convert to arrow function (yosuke ota) [#24597](https://github.com/nodejs/node/pull/24597)
* [[`16d70603a1`](https://github.com/nodejs/node/commit/16d70603a1)] - **crypto**: allow monkey patching of pseudoRandomBytes (Gerhard Stoebich) [#24108](https://github.com/nodejs/node/pull/24108)
* [[`7c29e9b83b`](https://github.com/nodejs/node/commit/7c29e9b83b)] - **crypto**: remove unnecessary fully qualified names (Gagandeep Singh) [#24452](https://github.com/nodejs/node/pull/24452)
* [[`0afcb9ad3a`](https://github.com/nodejs/node/commit/0afcb9ad3a)] - **deps**: cherry-pick 88f8fe1 from upstream V8 (Yang Guo) [#24514](https://github.com/nodejs/node/pull/24514)
* [[`61179e6cfe`](https://github.com/nodejs/node/commit/61179e6cfe)] - **deps**: cherry-pick 073073b from upstream V8 (Yang Guo) [#24515](https://github.com/nodejs/node/pull/24515)
* [[`230eb0dde9`](https://github.com/nodejs/node/commit/230eb0dde9)] - **deps**: update llhttp to 1.0.1 (Fedor Indutny) [#24508](https://github.com/nodejs/node/pull/24508)
* [[`06c28b9d75`](https://github.com/nodejs/node/commit/06c28b9d75)] - **deps**: upgrade to libuv 1.24.0 (cjihrig) [#24332](https://github.com/nodejs/node/pull/24332)
* [[`2dfaa480de`](https://github.com/nodejs/node/commit/2dfaa480de)] - **dns**: simplify dns.promises warning logic (cjihrig) [#24788](https://github.com/nodejs/node/pull/24788)
* [[`5a1fb1e663`](https://github.com/nodejs/node/commit/5a1fb1e663)] - **doc**: mention util depth default change (Ruben Bridgewater) [#24805](https://github.com/nodejs/node/pull/24805)
* [[`d800998161`](https://github.com/nodejs/node/commit/d800998161)] - **doc**: list all versions WHATWG URL api was added (Thomas Watson) [#24847](https://github.com/nodejs/node/pull/24847)
* [[`71e520cfa6`](https://github.com/nodejs/node/commit/71e520cfa6)] - **doc**: add authority and scheme psuedo headers (Kenigbolo Meya Stephen) [#24777](https://github.com/nodejs/node/pull/24777)
* [[`5b78d2c504`](https://github.com/nodejs/node/commit/5b78d2c504)] - **doc**: remove duplicate whitespaces in doc/api (Yusuke Kawasaki)
* [[`162b3a12b6`](https://github.com/nodejs/node/commit/162b3a12b6)] - **doc**: add triaging section to releases.md (Beth Griggs) [#20165](https://github.com/nodejs/node/pull/20165)
* [[`b8611a384a`](https://github.com/nodejs/node/commit/b8611a384a)] - **doc**: use author's titles for linked resources (Rich Trott) [#24837](https://github.com/nodejs/node/pull/24837)
* [[`566046ca4e`](https://github.com/nodejs/node/commit/566046ca4e)] - **doc**: revise code review guidelines (Rich Trott) [#24790](https://github.com/nodejs/node/pull/24790)
* [[`3d1853b178`](https://github.com/nodejs/node/commit/3d1853b178)] - **doc**: add a note on usage scope of AliasedBuffer (Gireesh Punathil) [#24724](https://github.com/nodejs/node/pull/24724)
* [[`997c0e05a4`](https://github.com/nodejs/node/commit/997c0e05a4)] - **doc**: hide undocumented object artifacts in async\_hooks (Gireesh Punathil) [#24741](https://github.com/nodejs/node/pull/24741)
* [[`58e5c00c9b`](https://github.com/nodejs/node/commit/58e5c00c9b)] - **doc**: fix added version of randomFill+randomFillSync (Thomas Watson) [#24812](https://github.com/nodejs/node/pull/24812)
* [[`751d961d29`](https://github.com/nodejs/node/commit/751d961d29)] - **doc**: streamline Accepting Modifications in Collaborator Guide (Rich Trott) [#24807](https://github.com/nodejs/node/pull/24807)
* [[`c09ea83869`](https://github.com/nodejs/node/commit/c09ea83869)] - **doc**: make release README link be consistent with text (ZYSzys) [#24783](https://github.com/nodejs/node/pull/24783)
* [[`06011f501d`](https://github.com/nodejs/node/commit/06011f501d)] - **doc**: fix REPLACEME for tls min/max protocol option (Sam Roberts) [#24759](https://github.com/nodejs/node/pull/24759)
* [[`4d41c8f6d6`](https://github.com/nodejs/node/commit/4d41c8f6d6)] - **doc**: add missing changes entry (Ruben Bridgewater) [#24758](https://github.com/nodejs/node/pull/24758)
* [[`25e5164cf1`](https://github.com/nodejs/node/commit/25e5164cf1)] - **doc**: cookie is joined using '; ' (Gerhard Stoebich) [#24740](https://github.com/nodejs/node/pull/24740)
* [[`66d83305f8`](https://github.com/nodejs/node/commit/66d83305f8)] - **doc**: sort bottom-of-file markdown links (Sam Roberts) [#24679](https://github.com/nodejs/node/pull/24679)
* [[`654bd65464`](https://github.com/nodejs/node/commit/654bd65464)] - **doc**: remove trailing whitespace (Daijiro Wachi) [#24642](https://github.com/nodejs/node/pull/24642)
* [[`68dc100565`](https://github.com/nodejs/node/commit/68dc100565)] - **doc**: describe current HTTP header size limit (Sam Roberts) [#24700](https://github.com/nodejs/node/pull/24700)
* [[`b3e77a5690`](https://github.com/nodejs/node/commit/b3e77a5690)] - **doc**: fix nits in http(s) server.headersTimeout (Vse Mozhet Byt) [#24697](https://github.com/nodejs/node/pull/24697)
* [[`3288c27453`](https://github.com/nodejs/node/commit/3288c27453)] - **doc**: add antsmartian to collaborators (Anto Aravinth) [#24655](https://github.com/nodejs/node/pull/24655)
* [[`85aa03085d`](https://github.com/nodejs/node/commit/85aa03085d)] - **doc**: revise accepting-modifications in guide (Rich Trott) [#24650](https://github.com/nodejs/node/pull/24650)
* [[`2ebb32b480`](https://github.com/nodejs/node/commit/2ebb32b480)] - **doc**: document fs.write limitation with TTY (Matteo Collina) [#24571](https://github.com/nodejs/node/pull/24571)
* [[`5a47c2e7d3`](https://github.com/nodejs/node/commit/5a47c2e7d3)] - **doc**: clarify symlink resolution for \_\_filename (Rich Trott) [#24587](https://github.com/nodejs/node/pull/24587)
* [[`b65ffd5b1d`](https://github.com/nodejs/node/commit/b65ffd5b1d)] - **doc**: use arrow function for anonymous callbacks (koki-oshima) [#24606](https://github.com/nodejs/node/pull/24606)
* [[`d4491a48ba`](https://github.com/nodejs/node/commit/d4491a48ba)] - **doc**: revise handling-own-pull-requests text (Rich Trott) [#24583](https://github.com/nodejs/node/pull/24583)
* [[`663d1c8823`](https://github.com/nodejs/node/commit/663d1c8823)] - **doc**: fix duplicate "this" and "the" on http2.md (Yusuke Kawasaki) [#24611](https://github.com/nodejs/node/pull/24611)
* [[`8d550f7888`](https://github.com/nodejs/node/commit/8d550f7888)] - **doc**: replace anonymous function with arrow function (ka2jun8) [#24617](https://github.com/nodejs/node/pull/24617)
* [[`657d7a5f9d`](https://github.com/nodejs/node/commit/657d7a5f9d)] - **doc**: use arrow function (sadness_ojisan) [#24590](https://github.com/nodejs/node/pull/24590)
* [[`f80e7a13fb`](https://github.com/nodejs/node/commit/f80e7a13fb)] - **doc**: replace anonymous function with arrow function (yuriettys) [#24627](https://github.com/nodejs/node/pull/24627)
* [[`5796c6aba4`](https://github.com/nodejs/node/commit/5796c6aba4)] - **doc**: mark napi\_add\_finalizer experimental (Michael Dawson) [#24572](https://github.com/nodejs/node/pull/24572)
* [[`4da44ada88`](https://github.com/nodejs/node/commit/4da44ada88)] - **doc**: clarify who may land on an LTS staging branch (Myles Borins) [#24465](https://github.com/nodejs/node/pull/24465)
* [[`7463a7f5cf`](https://github.com/nodejs/node/commit/7463a7f5cf)] - **doc**: revise `author ready` explanation (Rich Trott) [#24558](https://github.com/nodejs/node/pull/24558)
* [[`41f2e36046`](https://github.com/nodejs/node/commit/41f2e36046)] - **doc**: add readable and writable property to Readable and Writable (Dexter Leng) [#23933](https://github.com/nodejs/node/pull/23933)
* [[`580eb5ba66`](https://github.com/nodejs/node/commit/580eb5ba66)] - **doc**: move trott to tsc emeritus (Rich Trott) [#24492](https://github.com/nodejs/node/pull/24492)
* [[`1a74fad1cd`](https://github.com/nodejs/node/commit/1a74fad1cd)] - **doc**: add Ruben Bridgewater to release team (Ruben Bridgewater) [#23432](https://github.com/nodejs/node/pull/23432)
* [[`672a31c91b`](https://github.com/nodejs/node/commit/672a31c91b)] - **doc**: edit COLLABORATOR\_GUIDE.md on closing issues (Rich Trott) [#24477](https://github.com/nodejs/node/pull/24477)
* [[`6d147efa92`](https://github.com/nodejs/node/commit/6d147efa92)] - **doc**: move Timothy to TSC emeritus (Timothy Gu) [#24535](https://github.com/nodejs/node/pull/24535)
* [[`91494bf023`](https://github.com/nodejs/node/commit/91494bf023)] - **doc**: add NODE\_DEBUG\_NATIVE to API docs (cjihrig) [#24383](https://github.com/nodejs/node/pull/24383)
* [[`6e4a12062a`](https://github.com/nodejs/node/commit/6e4a12062a)] - **doc**: add missing env variables to man page (cjihrig) [#24383](https://github.com/nodejs/node/pull/24383)
* [[`48852cc51f`](https://github.com/nodejs/node/commit/48852cc51f)] - **doc**: minor cleanup of tls.getProtocol() (Sam Roberts) [#24533](https://github.com/nodejs/node/pull/24533)
* [[`d34527177c`](https://github.com/nodejs/node/commit/d34527177c)] - **doc**: add Beth Griggs to release team (Beth Griggs) [#24532](https://github.com/nodejs/node/pull/24532)
* [[`dadc2eb62d`](https://github.com/nodejs/node/commit/dadc2eb62d)] - **(SEMVER-MINOR)** **doc**: describe certificate object properties (Sam Roberts) [#24358](https://github.com/nodejs/node/pull/24358)
* [[`9ab2bcf97c`](https://github.com/nodejs/node/commit/9ab2bcf97c)] - **doc**: update 11.0.0 changelog with missing commit (Rich Trott) [#24404](https://github.com/nodejs/node/pull/24404)
* [[`a499db714c`](https://github.com/nodejs/node/commit/a499db714c)] - **doc**: add filehandle.write(string\[, position\[, encoding\]\]) (Dara Hayes) [#23224](https://github.com/nodejs/node/pull/23224)
* [[`cf2306d380`](https://github.com/nodejs/node/commit/cf2306d380)] - **doc**: udpate list item spacing in changelogs (Rich Trott) [#24391](https://github.com/nodejs/node/pull/24391)
* [[`ed78339a6b`](https://github.com/nodejs/node/commit/ed78339a6b)] - **doc**: update crypto examples to not use deprecated api (Mayank Asthana) [#24107](https://github.com/nodejs/node/pull/24107)
* [[`5c4f569857`](https://github.com/nodejs/node/commit/5c4f569857)] - **doc**: simplify first-time contributors section of Collaborator Guide (Rich Trott) [#24387](https://github.com/nodejs/node/pull/24387)
* [[`81ec97ba3d`](https://github.com/nodejs/node/commit/81ec97ba3d)] - **doc**: adjusting formatting when printing (Thomas Hunter II) [#24325](https://github.com/nodejs/node/pull/24325)
* [[`a3599a5067`](https://github.com/nodejs/node/commit/a3599a5067)] - **doc**: better linkage to node-addon-api (Michael Dawson) [#24371](https://github.com/nodejs/node/pull/24371)
* [[`5f747f1dc5`](https://github.com/nodejs/node/commit/5f747f1dc5)] - **doc**: add help on fixing IPv6 test failures (Michael Dawson) [#24372](https://github.com/nodejs/node/pull/24372)
* [[`85f9201687`](https://github.com/nodejs/node/commit/85f9201687)] - **doc**: update collaborator guide with LTS labels (Charalampos Fanoulis) [#24379](https://github.com/nodejs/node/pull/24379)
* [[`2245e5e484`](https://github.com/nodejs/node/commit/2245e5e484)] - **doc,meta**: update PR approving info (Vse Mozhet Byt) [#24561](https://github.com/nodejs/node/pull/24561)
* [[`1743568975`](https://github.com/nodejs/node/commit/1743568975)] - **esm**: refactor dynamic modules (Myles Borins) [#24560](https://github.com/nodejs/node/pull/24560)
* [[`dd89cfeb30`](https://github.com/nodejs/node/commit/dd89cfeb30)] - **events**: extract listener check as a function (ZYSzys) [#24303](https://github.com/nodejs/node/pull/24303)
* [[`124fca0267`](https://github.com/nodejs/node/commit/124fca0267)] - **fs**: simplify fs.promises warning logic (cjihrig) [#24788](https://github.com/nodejs/node/pull/24788)
* [[`b1622a2c92`](https://github.com/nodejs/node/commit/b1622a2c92)] - **fs**: inline typeof check (dexterleng) [#24390](https://github.com/nodejs/node/pull/24390)
* [[`c8d5e31db4`](https://github.com/nodejs/node/commit/c8d5e31db4)] - **(SEMVER-MINOR)** **http**: make parser choice a runtime flag (Anna Henningsen) [#24739](https://github.com/nodejs/node/pull/24739)
* [[`1f8787c32d`](https://github.com/nodejs/node/commit/1f8787c32d)] - **http**: destroy the socket on parse error (Luigi Pinca) [#24757](https://github.com/nodejs/node/pull/24757)
* [[`3fe3bc961f`](https://github.com/nodejs/node/commit/3fe3bc961f)] - **http**: fix error return in `Finish()` (Fedor Indutny) [#24738](https://github.com/nodejs/node/pull/24738)
* [[`798504a8c9`](https://github.com/nodejs/node/commit/798504a8c9)] - **http2**: make compat writeHead not crash if the stream is destroyed (Matteo Collina) [#24723](https://github.com/nodejs/node/pull/24723)
* [[`61e0103d60`](https://github.com/nodejs/node/commit/61e0103d60)] - **http2**: add compat support for nested array headers (Sebastiaan Deckers) [#24665](https://github.com/nodejs/node/pull/24665)
* [[`091238a9a7`](https://github.com/nodejs/node/commit/091238a9a7)] - **http2**: fix session\[kSession\] undefined issue (leeight) [#24547](https://github.com/nodejs/node/pull/24547)
* [[`5051e1bdab`](https://github.com/nodejs/node/commit/5051e1bdab)] - **http2**: cleanup endStream logic (James M Snell) [#24063](https://github.com/nodejs/node/pull/24063)
* [[`81a7056378`](https://github.com/nodejs/node/commit/81a7056378)] - **http2**: set js callbacks once (James M Snell) [#24063](https://github.com/nodejs/node/pull/24063)
* [[`cd7df56903`](https://github.com/nodejs/node/commit/cd7df56903)] - **http2**: throw from mapToHeaders (James M Snell) [#24063](https://github.com/nodejs/node/pull/24063)
* [[`f5e9bb1b39`](https://github.com/nodejs/node/commit/f5e9bb1b39)] - **http2**: replace unreachable error with assertion (Rich Trott) [#24407](https://github.com/nodejs/node/pull/24407)
* [[`1f544999af`](https://github.com/nodejs/node/commit/1f544999af)] - **http2**: order declarations in http2.js (ZYSzys) [#24411](https://github.com/nodejs/node/pull/24411)
* [[`454883b6ce`](https://github.com/nodejs/node/commit/454883b6ce)] - **http2**: elevate v8 namespaces of repeated references (Gagandeep Singh) [#24453](https://github.com/nodejs/node/pull/24453)
* [[`73bc5fd39a`](https://github.com/nodejs/node/commit/73bc5fd39a)] - ***Revert*** "**lib**: repl multiline history support" (Ruben Bridgewater) [#24804](https://github.com/nodejs/node/pull/24804)
* [[`6c8a73de33`](https://github.com/nodejs/node/commit/6c8a73de33)] - **lib**: remove some useless assignments (Gus Caplan) [#23199](https://github.com/nodejs/node/pull/23199)
* [[`1ec4f8dc3d`](https://github.com/nodejs/node/commit/1ec4f8dc3d)] - **lib**: remove duplicated noop function (ZYSzys) [#24770](https://github.com/nodejs/node/pull/24770)
* [[`eab981e76f`](https://github.com/nodejs/node/commit/eab981e76f)] - **lib**: do not register DOMException in a module (Joyee Cheung) [#24708](https://github.com/nodejs/node/pull/24708)
* [[`d77cf929cf`](https://github.com/nodejs/node/commit/d77cf929cf)] - **lib**: move setupAllowedFlags() into per\_thread.js (Joyee Cheung) [#24704](https://github.com/nodejs/node/pull/24704)
* [[`b1d3747b5b`](https://github.com/nodejs/node/commit/b1d3747b5b)] - **lib**: convert to arrow function in fs.js (exoego) [#24604](https://github.com/nodejs/node/pull/24604)
* [[`97b803fa13`](https://github.com/nodejs/node/commit/97b803fa13)] - **lib**: change callbacks to arrow function (/Jesse) [#24625](https://github.com/nodejs/node/pull/24625)
* [[`1c4bc86388`](https://github.com/nodejs/node/commit/1c4bc86388)] - **lib**: chenged anonymous function to arrow function (nakashima) [#24605](https://github.com/nodejs/node/pull/24605)
* [[`83ab5f4049`](https://github.com/nodejs/node/commit/83ab5f4049)] - **lib**: rearm pre-existing signal event registrations (Gireesh Punathil) [#24651](https://github.com/nodejs/node/pull/24651)
* [[`6f42b98a1a`](https://github.com/nodejs/node/commit/6f42b98a1a)] - **lib**: convert to arrow function (horihiro) [#24623](https://github.com/nodejs/node/pull/24623)
* [[`e5c85ef886`](https://github.com/nodejs/node/commit/e5c85ef886)] - **lib**: convert to Arrow Function (Daiki Arai) [#24615](https://github.com/nodejs/node/pull/24615)
* [[`1063e0c92c`](https://github.com/nodejs/node/commit/1063e0c92c)] - **lib**: fix comment nits in bootstrap\\loaders.js (Vse Mozhet Byt) [#24641](https://github.com/nodejs/node/pull/24641)
* [[`3df8633b86`](https://github.com/nodejs/node/commit/3df8633b86)] - **lib**: suppress crypto related env vars in help msg (Daniel Bevenius) [#24556](https://github.com/nodejs/node/pull/24556)
* [[`59c2ee0c37`](https://github.com/nodejs/node/commit/59c2ee0c37)] - **lib**: convert to arrow function (Naojirou Hisada) [#24596](https://github.com/nodejs/node/pull/24596)
* [[`a8e93f7691`](https://github.com/nodejs/node/commit/a8e93f7691)] - **lib**: change anonymous function to arrow function (takato) [#24589](https://github.com/nodejs/node/pull/24589)
* [[`b2c243ff8b`](https://github.com/nodejs/node/commit/b2c243ff8b)] - **lib**: simplify own keys retrieval (Vse Mozhet Byt) [#24582](https://github.com/nodejs/node/pull/24582)
* [[`35a76460b8`](https://github.com/nodejs/node/commit/35a76460b8)] - **lib**: fix nits in lib/internal/bootstrap/cache.js (Vse Mozhet Byt) [#24581](https://github.com/nodejs/node/pull/24581)
* [[`daeb34809a`](https://github.com/nodejs/node/commit/daeb34809a)] - **lib**: move encodeStr function to internal for reusable (ZYSzys) [#24242](https://github.com/nodejs/node/pull/24242)
* [[`e14abfe432`](https://github.com/nodejs/node/commit/e14abfe432)] - **lib**: refactor setupInspector in bootstrap/node.js (leeight) [#24446](https://github.com/nodejs/node/pull/24446)
* [[`e16ff521d4`](https://github.com/nodejs/node/commit/e16ff521d4)] - **lib**: set stderr.\_destroy to dummyDestroy (Joyee Cheung) [#24398](https://github.com/nodejs/node/pull/24398)
* [[`bc5a0d3c05`](https://github.com/nodejs/node/commit/bc5a0d3c05)] - **lib**: gather all errors constant in the same place for consistency (ZYSzys) [#24038](https://github.com/nodejs/node/pull/24038)
* [[`0c51fc51b0`](https://github.com/nodejs/node/commit/0c51fc51b0)] - **n-api**: handle reference delete before finalize (Michael Dawson) [#24494](https://github.com/nodejs/node/pull/24494)
* [[`7ef516a9de`](https://github.com/nodejs/node/commit/7ef516a9de)] - **n-api,test**: remove last argument in assert.strictEqual() (susantruong) [#24584](https://github.com/nodejs/node/pull/24584)
* [[`e82f67d710`](https://github.com/nodejs/node/commit/e82f67d710)] - ***Revert*** "**net**: partially revert "simplify Socket.prototype.\_final"" (Anna Henningsen) [#24290](https://github.com/nodejs/node/pull/24290)
* [[`a1254a3e90`](https://github.com/nodejs/node/commit/a1254a3e90)] - **(SEMVER-MINOR)** **net,dgram**: add ipv6Only option for net and dgram (Ouyang Yadong) [#23798](https://github.com/nodejs/node/pull/23798)
* [[`24acd53cc4`](https://github.com/nodejs/node/commit/24acd53cc4)] - **net,http2**: merge after-write code (Anna Henningsen) [#24380](https://github.com/nodejs/node/pull/24380)
* [[`5874a03f39`](https://github.com/nodejs/node/commit/5874a03f39)] - **process**: refactor the bootstrap mode branching for readability (Joyee Cheung) [#24673](https://github.com/nodejs/node/pull/24673)
* [[`effe30777b`](https://github.com/nodejs/node/commit/effe30777b)] - **process**: fix omitting `--` from `process.execArgv` (Anna Henningsen) [#24654](https://github.com/nodejs/node/pull/24654)
* [[`81b42d2258`](https://github.com/nodejs/node/commit/81b42d2258)] - **process**: emit unhandled warning immediately (Anatoli Papirovski) [#24632](https://github.com/nodejs/node/pull/24632)
* [[`b22e95d5ed`](https://github.com/nodejs/node/commit/b22e95d5ed)] - **(SEMVER-MINOR)** **readline**: add support for async iteration (Timothy Gu) [#23916](https://github.com/nodejs/node/pull/23916)
* [[`6fed6f5e1f`](https://github.com/nodejs/node/commit/6fed6f5e1f)] - ***Revert*** "**repl**: handle buffered string logic on finish" (Ruben Bridgewater) [#24804](https://github.com/nodejs/node/pull/24804)
* [[`bd8be407b1`](https://github.com/nodejs/node/commit/bd8be407b1)] - **repl**: handle buffered string logic on finish (Anto Aravinth) [#24389](https://github.com/nodejs/node/pull/24389)
* [[`5bd33f18ea`](https://github.com/nodejs/node/commit/5bd33f18ea)] - **src**: fix type mismatch warnings from missing priv (Sam Roberts) [#24737](https://github.com/nodejs/node/pull/24737)
* [[`7c70b6192b`](https://github.com/nodejs/node/commit/7c70b6192b)] - **src**: move version metadata into node\_metadata{.h, .cc} (Joyee Cheung) [#24774](https://github.com/nodejs/node/pull/24774)
* [[`53b59b4066`](https://github.com/nodejs/node/commit/53b59b4066)] - **src**: move READONLY\_\* macros into util.h (Joyee Cheung) [#24774](https://github.com/nodejs/node/pull/24774)
* [[`c957adb171`](https://github.com/nodejs/node/commit/c957adb171)] - **src**: use custom TryCatch subclass (Gus Caplan) [#24751](https://github.com/nodejs/node/pull/24751)
* [[`ecbe616b9d`](https://github.com/nodejs/node/commit/ecbe616b9d)] - **src**: use arraysize instead of hardcode number (leeight) [#24473](https://github.com/nodejs/node/pull/24473)
* [[`0e88f44547`](https://github.com/nodejs/node/commit/0e88f44547)] - **src**: set HAS\_USERNAME/PASSWORD more strictly (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* [[`193f315560`](https://github.com/nodejs/node/commit/193f315560)] - **src**: elevate v8 namespaces for node\_process.cc (Jayasankar) [#24578](https://github.com/nodejs/node/pull/24578)
* [[`f28fdc96ef`](https://github.com/nodejs/node/commit/f28fdc96ef)] - **src**: remove unused context variable in node\_serdes (Daniel Bevenius) [#24713](https://github.com/nodejs/node/pull/24713)
* [[`0148c1d4f9`](https://github.com/nodejs/node/commit/0148c1d4f9)] - **src**: elevate v8 namespaces referenced (Juan José Arboleda) [#24657](https://github.com/nodejs/node/pull/24657)
* [[`f31292dff3`](https://github.com/nodejs/node/commit/f31292dff3)] - **src**: move C++ binding/addon related code into node\_binding{.h, .cc} (Joyee Cheung) [#24701](https://github.com/nodejs/node/pull/24701)
* [[`87c864cd5e`](https://github.com/nodejs/node/commit/87c864cd5e)] - **src**: remove unused variables in node\_util.cc (Daniel Bevenius) [#24717](https://github.com/nodejs/node/pull/24717)
* [[`a122ba598e`](https://github.com/nodejs/node/commit/a122ba598e)] - **src**: simplify LibuvStreamWrap::DoWrite (Anna Henningsen) [#24588](https://github.com/nodejs/node/pull/24588)
* [[`b554ff7620`](https://github.com/nodejs/node/commit/b554ff7620)] - **src**: replace create new Array (kohta ito) [#24618](https://github.com/nodejs/node/pull/24618)
* [[`c26b10caeb`](https://github.com/nodejs/node/commit/c26b10caeb)] - **src**: migrate to new V8 array API (Yoshiya Hinosawa) [#24613](https://github.com/nodejs/node/pull/24613)
* [[`c708abb3ba`](https://github.com/nodejs/node/commit/c708abb3ba)] - **src**: use NativeModuleLoader to compile per\_context.js (Joyee Cheung) [#24660](https://github.com/nodejs/node/pull/24660)
* [[`9caad06d6f`](https://github.com/nodejs/node/commit/9caad06d6f)] - **src**: simplify uptime and ppid return values (cjihrig) [#24562](https://github.com/nodejs/node/pull/24562)
* [[`dca1ecffbd`](https://github.com/nodejs/node/commit/dca1ecffbd)] - **src**: replace array implementation (kazuya kawaguchi) [#24614](https://github.com/nodejs/node/pull/24614)
* [[`955a8a720a`](https://github.com/nodejs/node/commit/955a8a720a)] - **src**: replace new Array creation (kohta ito) [#24601](https://github.com/nodejs/node/pull/24601)
* [[`8a91fc1af0`](https://github.com/nodejs/node/commit/8a91fc1af0)] - **src**: elevate v8 namespaces for node\_url.cc (Jayasankar) [#24573](https://github.com/nodejs/node/pull/24573)
* [[`aa220cf9d7`](https://github.com/nodejs/node/commit/aa220cf9d7)] - **src**: enable detailed source positions in V8 (Yang Guo) [#24515](https://github.com/nodejs/node/pull/24515)
* [[`b9bd4e9d09`](https://github.com/nodejs/node/commit/b9bd4e9d09)] - **src**: add include for standalone compile (Gary Hsu) [#24498](https://github.com/nodejs/node/pull/24498)
* [[`2565ff0785`](https://github.com/nodejs/node/commit/2565ff0785)] - **src**: elevate namespaces for repeated entities (Sarath Govind K K) [#24475](https://github.com/nodejs/node/pull/24475)
* [[`b8ed930674`](https://github.com/nodejs/node/commit/b8ed930674)] - **src**: elevate namespaces of repeated artifacts (Maya Anilson) [#24429](https://github.com/nodejs/node/pull/24429)
* [[`216f751b2a`](https://github.com/nodejs/node/commit/216f751b2a)] - **src**: elevate v8 namespaces of node\_trace\_events.cc (Jayasankar) [#24469](https://github.com/nodejs/node/pull/24469)
* [[`21e9aa2bf4`](https://github.com/nodejs/node/commit/21e9aa2bf4)] - **src**: use STL containers instead of v8 values for static module data (Joyee Cheung) [#24384](https://github.com/nodejs/node/pull/24384)
* [[`873dee9789`](https://github.com/nodejs/node/commit/873dee9789)] - **src**: elevate v8 namespaces of repeated references (leeight) [#24460](https://github.com/nodejs/node/pull/24460)
* [[`aa481c4198`](https://github.com/nodejs/node/commit/aa481c4198)] - **src**: elevate repeated use of v8 namespaced type (Shubham Urkade) [#24427](https://github.com/nodejs/node/pull/24427)
* [[`ea862acc7a`](https://github.com/nodejs/node/commit/ea862acc7a)] - **src**: use smart pointers in cares\_wrap.cc (Daniel Bevenius) [#23813](https://github.com/nodejs/node/pull/23813)
* [[`53fac5c0d3`](https://github.com/nodejs/node/commit/53fac5c0d3)] - **src**: fix compiler warning (cjihrig) [#23954](https://github.com/nodejs/node/pull/23954)
* [[`c2fde2124f`](https://github.com/nodejs/node/commit/c2fde2124f)] - **src**: remove unused variables (Anna Henningsen) [#23880](https://github.com/nodejs/node/pull/23880)
* [[`dba003cbff`](https://github.com/nodejs/node/commit/dba003cbff)] - **src**: include util-inl.h in worker\_agent.cc (Anna Henningsen) [#23880](https://github.com/nodejs/node/pull/23880)
* [[`25a9eee9fd`](https://github.com/nodejs/node/commit/25a9eee9fd)] - **src**: add direct dependency on `\*-inl.h` file (Refael Ackermann) [#23808](https://github.com/nodejs/node/pull/23808)
* [[`33e7f6e953`](https://github.com/nodejs/node/commit/33e7f6e953)] - **src**: add AliasedBuffer::reserve (Refael Ackermann) [#23808](https://github.com/nodejs/node/pull/23808)
* [[`74c0a97a96`](https://github.com/nodejs/node/commit/74c0a97a96)] - **src**: clean clang-tidy errors in node\_file.h (Refael Ackermann) [#23793](https://github.com/nodejs/node/pull/23793)
* [[`260d77710e`](https://github.com/nodejs/node/commit/260d77710e)] - **src**: fix resource leak in node::fs::FileHandle (Refael Ackermann) [#23793](https://github.com/nodejs/node/pull/23793)
* [[`c0a9a83c51`](https://github.com/nodejs/node/commit/c0a9a83c51)] - **src**: refactor FillStatsArray (Refael Ackermann) [#23793](https://github.com/nodejs/node/pull/23793)
* [[`5061610094`](https://github.com/nodejs/node/commit/5061610094)] - **src**: remove `Environment::tracing\_agent\_writer()` (Anna Henningsen) [#23781](https://github.com/nodejs/node/pull/23781)
* [[`af3c7efffc`](https://github.com/nodejs/node/commit/af3c7efffc)] - **src**: factor out Node.js-agnostic N-APIs (Gabriel Schulhof) [#23786](https://github.com/nodejs/node/pull/23786)
* [[`b44623e776`](https://github.com/nodejs/node/commit/b44623e776)] - **src**: elevate v8 namespaces of referenced artifacts (Kanika Singhal) [#24424](https://github.com/nodejs/node/pull/24424)
* [[`a7f6c043a4`](https://github.com/nodejs/node/commit/a7f6c043a4)] - ***Revert*** "**src**: enable detailed source positions in V8" (Refael Ackermann) [#24394](https://github.com/nodejs/node/pull/24394)
* [[`5d67eeca1a`](https://github.com/nodejs/node/commit/5d67eeca1a)] - **src**: emit warnings from V8 (Gus Caplan) [#24365](https://github.com/nodejs/node/pull/24365)
* [[`fa9e03c1a7`](https://github.com/nodejs/node/commit/fa9e03c1a7)] - **src**: re-sort the symbol macros (Sam Roberts) [#24382](https://github.com/nodejs/node/pull/24382)
* [[`2d885ed0f9`](https://github.com/nodejs/node/commit/2d885ed0f9)] - **src**: fix compiler warning in node\_os (Daniel Bevenius) [#24356](https://github.com/nodejs/node/pull/24356)
* [[`806570d80a`](https://github.com/nodejs/node/commit/806570d80a)] - **src**: remove unused variables (Daniel Bevenius) [#24355](https://github.com/nodejs/node/pull/24355)
* [[`88a54497e5`](https://github.com/nodejs/node/commit/88a54497e5)] - **src,lib**: make process.binding('config') internal (Masashi Hirano) [#23400](https://github.com/nodejs/node/pull/23400)
* [[`b809fa8571`](https://github.com/nodejs/node/commit/b809fa8571)] - **stream**: make async iterator .next() always resolve (Matteo Collina) [#24668](https://github.com/nodejs/node/pull/24668)
* [[`99b018bf48`](https://github.com/nodejs/node/commit/99b018bf48)] - **stream**: use arrow function for callback (DoiChris) [#24609](https://github.com/nodejs/node/pull/24609)
* [[`ba1ebb4a40`](https://github.com/nodejs/node/commit/ba1ebb4a40)] - **stream**: correctly pause and resume after once('readable') (Matteo Collina) [#24366](https://github.com/nodejs/node/pull/24366)
* [[`7bc2011ad9`](https://github.com/nodejs/node/commit/7bc2011ad9)] - **stream**: do not use crypto.DEFAULT\_ENCODING in lazy\_transform.js (Joyee Cheung) [#24396](https://github.com/nodejs/node/pull/24396)
* [[`01e8a3a8d5`](https://github.com/nodejs/node/commit/01e8a3a8d5)] - **stream**: change comment on duplex stream options (Jesse W. Collins) [#24247](https://github.com/nodejs/node/pull/24247)
* [[`0ed669cf65`](https://github.com/nodejs/node/commit/0ed669cf65)] - **test**: remove unused addons-napi directory (Rich Trott) [#24839](https://github.com/nodejs/node/pull/24839)
* [[`7069ed7546`](https://github.com/nodejs/node/commit/7069ed7546)] - **test**: add .gitignore file for node-api (Rich Trott) [#24839](https://github.com/nodejs/node/pull/24839)
* [[`c227b1be16`](https://github.com/nodejs/node/commit/c227b1be16)] - **test**: partition N-API tests (Gabriel Schulhof) [#24557](https://github.com/nodejs/node/pull/24557)
* [[`63b06b55d7`](https://github.com/nodejs/node/commit/63b06b55d7)] - **test**: fix `common.mustNotCall()` usage in HTTP test (Anna Henningsen) [#24750](https://github.com/nodejs/node/pull/24750)
* [[`cc133c4432`](https://github.com/nodejs/node/commit/cc133c4432)] - **test**: use ES2017 syntax in test-fs-open-\* (jy95) [#23031](https://github.com/nodejs/node/pull/23031)
* [[`a7a1cb48f5`](https://github.com/nodejs/node/commit/a7a1cb48f5)] - **test**: check for the correct strict equal arguments order (Ruben Bridgewater) [#24752](https://github.com/nodejs/node/pull/24752)
* [[`95720089d5`](https://github.com/nodejs/node/commit/95720089d5)] - **test**: add flag scenario in test-fs-write-file-sync (Gireesh Punathil) [#24766](https://github.com/nodejs/node/pull/24766)
* [[`5f58928b06`](https://github.com/nodejs/node/commit/5f58928b06)] - **test**: improve comparison coverage to 100% (Ruben Bridgewater) [#24749](https://github.com/nodejs/node/pull/24749)
* [[`7577e754bb`](https://github.com/nodejs/node/commit/7577e754bb)] - **test**: check invalid argument error for option (timothy searcy) [#24736](https://github.com/nodejs/node/pull/24736)
* [[`2916b592d3`](https://github.com/nodejs/node/commit/2916b592d3)] - **test**: increase assert test coverage (Ruben Bridgewater) [#24745](https://github.com/nodejs/node/pull/24745)
* [[`085f5b6366`](https://github.com/nodejs/node/commit/085f5b6366)] - **test**: show stdout and stderr in test-cli-syntax when it fails (Joyee Cheung) [#24720](https://github.com/nodejs/node/pull/24720)
* [[`026e03cf35`](https://github.com/nodejs/node/commit/026e03cf35)] - **test**: minor refactoring of onticketkeycallback (Daniel Bevenius) [#24718](https://github.com/nodejs/node/pull/24718)
* [[`10c2773da8`](https://github.com/nodejs/node/commit/10c2773da8)] - **test**: mark test\_threadsafe\_function/test as flaky (Gireesh Punathil) [#24714](https://github.com/nodejs/node/pull/24714)
* [[`8ffe04f533`](https://github.com/nodejs/node/commit/8ffe04f533)] - **test**: verify order of error in h2 server stream (Myles Borins) [#24685](https://github.com/nodejs/node/pull/24685)
* [[`3c3ebe57f6`](https://github.com/nodejs/node/commit/3c3ebe57f6)] - **test**: cover path empty string case (lakatostamas) [#24569](https://github.com/nodejs/node/pull/24569)
* [[`089489965c`](https://github.com/nodejs/node/commit/089489965c)] - **test**: use arrow syntax for anonymous callbacks (Shubham Urkade) [#24691](https://github.com/nodejs/node/pull/24691)
* [[`d5bf7362b9`](https://github.com/nodejs/node/commit/d5bf7362b9)] - **test**: fix the arguments order in assert.strictEqual (pastak) [#24620](https://github.com/nodejs/node/pull/24620)
* [[`1035e36de6`](https://github.com/nodejs/node/commit/1035e36de6)] - **test**: mark test-vm-timeout-escape-nexttick flaky (Gireesh Punathil) [#24712](https://github.com/nodejs/node/pull/24712)
* [[`603bc2751e`](https://github.com/nodejs/node/commit/603bc2751e)] - **test**: fix the arguments order in assert.strictEqual (sigwyg) [#24624](https://github.com/nodejs/node/pull/24624)
* [[`969ae7a598`](https://github.com/nodejs/node/commit/969ae7a598)] - **test**: fix the arguments order in `assert.strictEqual` (rt33) [#24626](https://github.com/nodejs/node/pull/24626)
* [[`e96c60e472`](https://github.com/nodejs/node/commit/e96c60e472)] - **test**: reach res.\_dump after abort ClientRequest (Tadhg Creedon) [#24191](https://github.com/nodejs/node/pull/24191)
* [[`053f3d6289`](https://github.com/nodejs/node/commit/053f3d6289)] - **test**: validate fs.rename() when NODE\_TEST\_DIR on separate mount (Drew Folta) [#24707](https://github.com/nodejs/node/pull/24707)
* [[`9e1c6eb6aa`](https://github.com/nodejs/node/commit/9e1c6eb6aa)] - **test**: test and docs for detached fork process (timothy searcy) [#24524](https://github.com/nodejs/node/pull/24524)
* [[`992a9040bf`](https://github.com/nodejs/node/commit/992a9040bf)] - **test**: fix arguments order in `assert.strictEqual` (sota1235) [#24607](https://github.com/nodejs/node/pull/24607)
* [[`f8acf73ae7`](https://github.com/nodejs/node/commit/f8acf73ae7)] - **test**: fix arguments order in assert.strictEqual (grimrose) [#24608](https://github.com/nodejs/node/pull/24608)
* [[`84249dfac6`](https://github.com/nodejs/node/commit/84249dfac6)] - **test**: make test-uv-binding-constant JS engine neutral (Rich Trott) [#24666](https://github.com/nodejs/node/pull/24666)
* [[`0a492c730a`](https://github.com/nodejs/node/commit/0a492c730a)] - **test**: use arrow function (sagirk) [#24482](https://github.com/nodejs/node/pull/24482)
* [[`8072a2b85c`](https://github.com/nodejs/node/commit/8072a2b85c)] - **test**: fix arguments order in `assert.strictEqual` (Takahiro Nakamura) [#24621](https://github.com/nodejs/node/pull/24621)
* [[`9d5455515c`](https://github.com/nodejs/node/commit/9d5455515c)] - **test**: use arrow functions in callbacks (apoorvanand) [#24441](https://github.com/nodejs/node/pull/24441)
* [[`99dbdca73b`](https://github.com/nodejs/node/commit/99dbdca73b)] - **test**: update strictEqual argument order (VeysonD) [#24622](https://github.com/nodejs/node/pull/24622)
* [[`3b99191e13`](https://github.com/nodejs/node/commit/3b99191e13)] - **test**: fix argument order in assert.strictEqual (feng jianmei) [#24594](https://github.com/nodejs/node/pull/24594)
* [[`d6fff0e618`](https://github.com/nodejs/node/commit/d6fff0e618)] - **test**: add test for socket.end callback (ajido) [#24087](https://github.com/nodejs/node/pull/24087)
* [[`abb1c64c2d`](https://github.com/nodejs/node/commit/abb1c64c2d)] - **test**: replace anonymous closure functions with arrow functions (tpanthera) [#24443](https://github.com/nodejs/node/pull/24443)
* [[`b7aa312672`](https://github.com/nodejs/node/commit/b7aa312672)] - **test**: fix arguments order in `assert.strictEqual` (tottokotkd) [#24612](https://github.com/nodejs/node/pull/24612)
* [[`a82b420883`](https://github.com/nodejs/node/commit/a82b420883)] - **test**: convert callback to arrow function (jamesgeorge007) [#24513](https://github.com/nodejs/node/pull/24513)
* [[`7edea030af`](https://github.com/nodejs/node/commit/7edea030af)] - **test**: change anonymous function to arrow function (Gagandeep Singh) [#24528](https://github.com/nodejs/node/pull/24528)
* [[`a701dfbb2b`](https://github.com/nodejs/node/commit/a701dfbb2b)] - **test**: split out http2 from test-stream-pipeline (Rich Trott) [#24631](https://github.com/nodejs/node/pull/24631)
* [[`8849d8073a`](https://github.com/nodejs/node/commit/8849d8073a)] - **test**: cover path.basename when path and ext are the same (Laszlo.Moczo) [#24570](https://github.com/nodejs/node/pull/24570)
* [[`12d7107edc`](https://github.com/nodejs/node/commit/12d7107edc)] - **test**: fix assert.strictEqual (mki-skt) [#24619](https://github.com/nodejs/node/pull/24619)
* [[`54778a082a`](https://github.com/nodejs/node/commit/54778a082a)] - **test**: fix arguments order in assert.strictEqual (teppeis) [#24591](https://github.com/nodejs/node/pull/24591)
* [[`cd1aa2b0b5`](https://github.com/nodejs/node/commit/cd1aa2b0b5)] - **test**: fix http2-binding strictEqual order (dominikeinkemmer) [#24616](https://github.com/nodejs/node/pull/24616)
* [[`82ef618e98`](https://github.com/nodejs/node/commit/82ef618e98)] - **test**: fix the arguments order in `assert.strictEqual` (sota1235) [#24595](https://github.com/nodejs/node/pull/24595)
* [[`1067653221`](https://github.com/nodejs/node/commit/1067653221)] - **test**: replace callback with arrow functions (prodroy1) [#24434](https://github.com/nodejs/node/pull/24434)
* [[`363d3c6deb`](https://github.com/nodejs/node/commit/363d3c6deb)] - **test**: use destructuring on require (Juan José Arboleda) [#24455](https://github.com/nodejs/node/pull/24455)
* [[`34b40af5ab`](https://github.com/nodejs/node/commit/34b40af5ab)] - **test**: fix test case in test-child-process-fork-dgram.js (gengjiawen) [#24459](https://github.com/nodejs/node/pull/24459)
* [[`40701520ce`](https://github.com/nodejs/node/commit/40701520ce)] - **test**: replace callback with arrow functions (sreepurnajasti) [#24541](https://github.com/nodejs/node/pull/24541)
* [[`2a67a49053`](https://github.com/nodejs/node/commit/2a67a49053)] - **test**: replace callback with arrow function (potham) [#24531](https://github.com/nodejs/node/pull/24531)
* [[`39adfc8d48`](https://github.com/nodejs/node/commit/39adfc8d48)] - **test**: replace anonymous function with arrow (Gagandeep Singh) [#24527](https://github.com/nodejs/node/pull/24527)
* [[`6b88541fe2`](https://github.com/nodejs/node/commit/6b88541fe2)] - **test**: replace anonymous function with arrow (Gagandeep Singh) [#24526](https://github.com/nodejs/node/pull/24526)
* [[`765a81e32a`](https://github.com/nodejs/node/commit/765a81e32a)] - **test**: add information to assertion (Rich Trott) [#24566](https://github.com/nodejs/node/pull/24566)
* [[`759ed86e5c`](https://github.com/nodejs/node/commit/759ed86e5c)] - **test**: replace anonymous function with arrow func (Gagandeep Singh) [#24525](https://github.com/nodejs/node/pull/24525)
* [[`9bf2659af4`](https://github.com/nodejs/node/commit/9bf2659af4)] - **test**: change anonymous closure function to arrow function (Nethra Ravindran) [#24433](https://github.com/nodejs/node/pull/24433)
* [[`e8c0fcee95`](https://github.com/nodejs/node/commit/e8c0fcee95)] - **test**: replace closure functions with arrow functions (Gagandeep Singh) [#24522](https://github.com/nodejs/node/pull/24522)
* [[`2c8c7b882d`](https://github.com/nodejs/node/commit/2c8c7b882d)] - **test**: replace anonymous function with arrow function (Gagandeep Singh) [#24529](https://github.com/nodejs/node/pull/24529)
* [[`7b0292a839`](https://github.com/nodejs/node/commit/7b0292a839)] - **test**: favor arrow function in callback (Pranay Kothapalli) [#24542](https://github.com/nodejs/node/pull/24542)
* [[`8fcf3b3c59`](https://github.com/nodejs/node/commit/8fcf3b3c59)] - **test**: remove unused reject handlers (Dan Foley) [#24540](https://github.com/nodejs/node/pull/24540)
* [[`46b5df0f1f`](https://github.com/nodejs/node/commit/46b5df0f1f)] - **test**: refactor test to use arrow functions (sagirk) [#24479](https://github.com/nodejs/node/pull/24479)
* [[`c28ec86c90`](https://github.com/nodejs/node/commit/c28ec86c90)] - **test**: replace closure with arrow function (Maya Anilson) [#24489](https://github.com/nodejs/node/pull/24489)
* [[`1cd73a81fa`](https://github.com/nodejs/node/commit/1cd73a81fa)] - **test**: using arrow functions (NoSkillGirl) [#24436](https://github.com/nodejs/node/pull/24436)
* [[`b309dd2be3`](https://github.com/nodejs/node/commit/b309dd2be3)] - **test**: replace anonymous closure with arrow func (suman-mitra) [#24480](https://github.com/nodejs/node/pull/24480)
* [[`c4f16ddccd`](https://github.com/nodejs/node/commit/c4f16ddccd)] - **test**: replace callback with arrow functions (sreepurnajasti) [#24490](https://github.com/nodejs/node/pull/24490)
* [[`dbf14ce17b`](https://github.com/nodejs/node/commit/dbf14ce17b)] - **test**: replcae anonymous closure with arrow function (Sarath Govind K K) [#24476](https://github.com/nodejs/node/pull/24476)
* [[`4792bea514`](https://github.com/nodejs/node/commit/4792bea514)] - **test**: refactor test-http-write-empty-string to use arrow functions (sagirk) [#24483](https://github.com/nodejs/node/pull/24483)
* [[`c45660fd53`](https://github.com/nodejs/node/commit/c45660fd53)] - **test**: replace anonymous closure with arrow functions (suman-mitra) [#24481](https://github.com/nodejs/node/pull/24481)
* [[`f19dae33e6`](https://github.com/nodejs/node/commit/f19dae33e6)] - **test**: replace anonymous closure functions with arrow functions (sagirk) [#24478](https://github.com/nodejs/node/pull/24478)
* [[`fbb228be97`](https://github.com/nodejs/node/commit/fbb228be97)] - **test**: replace anonymous closure functions with arrow function (Abhishek Dixit) [#24420](https://github.com/nodejs/node/pull/24420)
* [[`c15208cb8f`](https://github.com/nodejs/node/commit/c15208cb8f)] - **test**: replace anonymous closure with arrow funct (Prabu Subra) [#24439](https://github.com/nodejs/node/pull/24439)
* [[`8f18f0d5bd`](https://github.com/nodejs/node/commit/8f18f0d5bd)] - **test**: add whatwg-encoding TextDecoder custom inspection with showHidden (ZauberNerd) [#24166](https://github.com/nodejs/node/pull/24166)
* [[`33b524203b`](https://github.com/nodejs/node/commit/33b524203b)] - **test**: use Worker scope in WPT (Joyee Cheung) [#24410](https://github.com/nodejs/node/pull/24410)
* [[`ed714a2e79`](https://github.com/nodejs/node/commit/ed714a2e79)] - **test**: modify order of parameters for assertion (Mrityunjoy Saha) [#24430](https://github.com/nodejs/node/pull/24430)
* [[`3bfa953990`](https://github.com/nodejs/node/commit/3bfa953990)] - **test**: replace closure with arrow functions (kanishk30) [#24440](https://github.com/nodejs/node/pull/24440)
* [[`7d743e659d`](https://github.com/nodejs/node/commit/7d743e659d)] - **test**: replace anonymous closure function with arrow function (Kunda Sunil Kumar) [#24435](https://github.com/nodejs/node/pull/24435)
* [[`e9abf42751`](https://github.com/nodejs/node/commit/e9abf42751)] - **test**: add typeerror test for EC crypto keygen (Matteo) [#24400](https://github.com/nodejs/node/pull/24400)
* [[`237e479196`](https://github.com/nodejs/node/commit/237e479196)] - **test**: change anonymous closure functions to arrow functions (Namit Bhalla) [#24418](https://github.com/nodejs/node/pull/24418)
* [[`2f0a5b6a45`](https://github.com/nodejs/node/commit/2f0a5b6a45)] - **test**: favor arrow functions in callbacks (UjjwalUpadhyay) [#24425](https://github.com/nodejs/node/pull/24425)
* [[`957ecbe019`](https://github.com/nodejs/node/commit/957ecbe019)] - **test**: use print() function on both Python 2 and 3 (cclauss) [#24485](https://github.com/nodejs/node/pull/24485)
* [[`b1dee7dab6`](https://github.com/nodejs/node/commit/b1dee7dab6)] - **test**: replace anonymous closure functions with arrow function (Amanpreet) [#24417](https://github.com/nodejs/node/pull/24417)
* [[`4348ffede5`](https://github.com/nodejs/node/commit/4348ffede5)] - **test**: fix arguments order in napi test\_exception (kanishk30) [#24413](https://github.com/nodejs/node/pull/24413)
* [[`0a08cd714e`](https://github.com/nodejs/node/commit/0a08cd714e)] - **test**: fix the arguments order in `assert.strictEqual` (Jay Arthanareeswaran) [#24416](https://github.com/nodejs/node/pull/24416)
* [[`585ebfffa7`](https://github.com/nodejs/node/commit/585ebfffa7)] - **test**: replace closure with arrow functions (Amanpreet) [#24438](https://github.com/nodejs/node/pull/24438)
* [[`d5543ead7c`](https://github.com/nodejs/node/commit/d5543ead7c)] - **test**: change callback function to arrow function (Jay Arthanareeswaran) [#24419](https://github.com/nodejs/node/pull/24419)
* [[`5d663100a0`](https://github.com/nodejs/node/commit/5d663100a0)] - **test**: fix the arguments order in `assert.strictEqual` (apoorvanand) [#24431](https://github.com/nodejs/node/pull/24431)
* [[`9b2ab12b8c`](https://github.com/nodejs/node/commit/9b2ab12b8c)] - **test**: assertion equality fix (NoSkillGirl) [#24422](https://github.com/nodejs/node/pull/24422)
* [[`2777bc42aa`](https://github.com/nodejs/node/commit/2777bc42aa)] - **test**: remove unused function arguments in async-hooks tests (Simon Bruce) [#24406](https://github.com/nodejs/node/pull/24406)
* [[`59723d4b2b`](https://github.com/nodejs/node/commit/59723d4b2b)] - **test**: fix actual parameter order for 'assert.strictEqual' (Selvaraj) [#24428](https://github.com/nodejs/node/pull/24428)
* [[`658df6ba26`](https://github.com/nodejs/node/commit/658df6ba26)] - **test**: swap actual&optional params (Nikhil M) [#24426](https://github.com/nodejs/node/pull/24426)
* [[`de378c0c2d`](https://github.com/nodejs/node/commit/de378c0c2d)] - **test**: skip test that use --tls-v1.x flags (Daniel Bevenius) [#24376](https://github.com/nodejs/node/pull/24376)
* [[`c1777990ae`](https://github.com/nodejs/node/commit/c1777990ae)] - **test**: change callback function to arrow function (Lakshmi Shanmugam) [#24421](https://github.com/nodejs/node/pull/24421)
* [[`ffb5e5da4b`](https://github.com/nodejs/node/commit/ffb5e5da4b)] - **test**: replace anonymous closure for test-http-expect-handling.js (Jayasankar) [#24423](https://github.com/nodejs/node/pull/24423)
* [[`3fadc809bb`](https://github.com/nodejs/node/commit/3fadc809bb)] - **test**: replace callback functions with arrow functions (potham) [#24432](https://github.com/nodejs/node/pull/24432)
* [[`856a0fc8e4`](https://github.com/nodejs/node/commit/856a0fc8e4)] - **test**: use arrow functions for callbacks (Pushkal B) [#24444](https://github.com/nodejs/node/pull/24444)
* [[`f112c06b3e`](https://github.com/nodejs/node/commit/f112c06b3e)] - **test**: replace anonymous closure function (Jayasankar) [#24415](https://github.com/nodejs/node/pull/24415)
* [[`6dd29252c7`](https://github.com/nodejs/node/commit/6dd29252c7)] - **test**: fixed the arguments order in `assert.strictEqual` (Lakshmi Shanmugam) [#24414](https://github.com/nodejs/node/pull/24414)
* [[`7e2a2849db`](https://github.com/nodejs/node/commit/7e2a2849db)] - **test**: use destructuring and remove unused arguments (Julia) [#24375](https://github.com/nodejs/node/pull/24375)
* [[`cdda7f4f18`](https://github.com/nodejs/node/commit/cdda7f4f18)] - **test**: https agent clientcertengine coverage (Osmond van Hemert) [#24248](https://github.com/nodejs/node/pull/24248)
* [[`92f826622b`](https://github.com/nodejs/node/commit/92f826622b)] - **test**: confirm tls server suite default is its own (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* [[`261aa7884c`](https://github.com/nodejs/node/commit/261aa7884c)] - **test**: cover tls multi-identity option mixtures (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* [[`3c2fb883b4`](https://github.com/nodejs/node/commit/3c2fb883b4)] - **test**: add independent multi-alg crypto identities (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* [[`2fc9550280`](https://github.com/nodejs/node/commit/2fc9550280)] - **test**: rename agent1-pfx.pem to agent1.pfx (Sam Roberts) [#24374](https://github.com/nodejs/node/pull/24374)
* [[`ee64ae0f6d`](https://github.com/nodejs/node/commit/ee64ae0f6d)] - **test**: remove unused function arguments in async-hooks tests (Rich Trott) [#24368](https://github.com/nodejs/node/pull/24368)
* [[`d2e9b76c1d`](https://github.com/nodejs/node/commit/d2e9b76c1d)] - **timers**: fix setTimeout expiration logic (Suguru Motegi) [#24214](https://github.com/nodejs/node/pull/24214)
* [[`acb73518b7`](https://github.com/nodejs/node/commit/acb73518b7)] - **(SEMVER-MINOR)** **tls**: add min/max protocol version options (Sam Roberts) [#24405](https://github.com/nodejs/node/pull/24405)
* [[`f30c7c4911`](https://github.com/nodejs/node/commit/f30c7c4911)] - **(SEMVER-MINOR)** **tls**: include RSA bit size in X.509 public key info (Sam Roberts) [#24358](https://github.com/nodejs/node/pull/24358)
* [[`37f0bd7e3a`](https://github.com/nodejs/node/commit/37f0bd7e3a)] - **(SEMVER-MINOR)** **tls**: include elliptic curve X.509 public key info (Sam Roberts) [#24358](https://github.com/nodejs/node/pull/24358)
* [[`71a9c987b2`](https://github.com/nodejs/node/commit/71a9c987b2)] - **tls**: destroy TLS socket if StreamWrap is destroyed (Anna Henningsen) [#24290](https://github.com/nodejs/node/pull/24290)
* [[`0c93b125e4`](https://github.com/nodejs/node/commit/0c93b125e4)] - **tls**: do not rely on 'drain' handlers in StreamWrap (Anna Henningsen) [#24290](https://github.com/nodejs/node/pull/24290)
* [[`249c143703`](https://github.com/nodejs/node/commit/249c143703)] - **tools**: prepare tools/install.py for Python 3 (cclauss) [#24800](https://github.com/nodejs/node/pull/24800)
* [[`1ea01c5790`](https://github.com/nodejs/node/commit/1ea01c5790)] - **tools**: replace rollup with ncc (Rich Trott) [#24813](https://github.com/nodejs/node/pull/24813)
* [[`09cd2ec034`](https://github.com/nodejs/node/commit/09cd2ec034)] - **tools**: fix eslint usage for Node.js 8 and before (Ruben Bridgewater) [#24753](https://github.com/nodejs/node/pull/24753)
* [[`9e5a79a192`](https://github.com/nodejs/node/commit/9e5a79a192)] - **tools**: don't use GH API for commit message checks (Rod Vagg) [#24574](https://github.com/nodejs/node/pull/24574)
* [[`e3649c8e09`](https://github.com/nodejs/node/commit/e3649c8e09)] - **tools**: only sign release if promotion successful (Rod Vagg) [#24669](https://github.com/nodejs/node/pull/24669)
* [[`2ef6aed58a`](https://github.com/nodejs/node/commit/2ef6aed58a)] - **tools**: check for git tag before promoting release (Rod Vagg) [#24670](https://github.com/nodejs/node/pull/24670)
* [[`e7fbdf5784`](https://github.com/nodejs/node/commit/e7fbdf5784)] - **tools**: update remark-preset-lint-node to v1.3.1 (Daijiro Wachi) [#24642](https://github.com/nodejs/node/pull/24642)
* [[`23d815292f`](https://github.com/nodejs/node/commit/23d815292f)] - **tools**: use print() function on both Python 2 and 3 (cclauss) [#24486](https://github.com/nodejs/node/pull/24486)
* [[`13a4d10f67`](https://github.com/nodejs/node/commit/13a4d10f67)] - **tools**: update to remark-lint-preset-node@1.2.0 (Rich Trott) [#24391](https://github.com/nodejs/node/pull/24391)
* [[`5748e862b0`](https://github.com/nodejs/node/commit/5748e862b0)] - **tools**: fix `make lint-md-rollup` and run it (Daijiro Wachi) [#24333](https://github.com/nodejs/node/pull/24333)
* [[`7ffc8b7778`](https://github.com/nodejs/node/commit/7ffc8b7778)] - **tools**: update remark-lint to v6.0.3 from v6.0.2 (Daijiro Wachi) [#24333](https://github.com/nodejs/node/pull/24333)
* [[`b9a4bc15c2`](https://github.com/nodejs/node/commit/b9a4bc15c2)] - **tools**: update remark version to v10 from v8 (Daijiro Wachi) [#24333](https://github.com/nodejs/node/pull/24333)
* [[`1625329fbf`](https://github.com/nodejs/node/commit/1625329fbf)] - **tools,doc**: fix version picker bug in html.js (Rich Trott) [#24638](https://github.com/nodejs/node/pull/24638)
* [[`b6004b3651`](https://github.com/nodejs/node/commit/b6004b3651)] - **trace_events**: forbid tracing modifications from worker threads (Anna Henningsen) [#23781](https://github.com/nodejs/node/pull/23781)
* [[`d881b33028`](https://github.com/nodejs/node/commit/d881b33028)] - **(SEMVER-MINOR)** **url**: support LF, CR and TAB in pathToFileURL (Charles Samborski) [#23720](https://github.com/nodejs/node/pull/23720)
* [[`540929d597`](https://github.com/nodejs/node/commit/540929d597)] - **url**: simplify native URL object construction (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* [[`0d7ee19786`](https://github.com/nodejs/node/commit/0d7ee19786)] - **url**: reuse existing context in href setter (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* [[`96e6873dd0`](https://github.com/nodejs/node/commit/96e6873dd0)] - ***Revert*** "**url**: make the context non-enumerable" (Timothy Gu) [#24495](https://github.com/nodejs/node/pull/24495)
* [[`be54dc0f72`](https://github.com/nodejs/node/commit/be54dc0f72)] - **url**: use SafeSet to filter known special protocols (Mike Samuel) [#24703](https://github.com/nodejs/node/pull/24703)
* [[`5a853a093c`](https://github.com/nodejs/node/commit/5a853a093c)] - ***Revert*** "**util**: change util.inspect depth default" (Gus Caplan)
* [[`807c108be8`](https://github.com/nodejs/node/commit/807c108be8)] - **util**: improve internal `isError()` validation (Ruben Bridgewater) [#24746](https://github.com/nodejs/node/pull/24746)
* [[`764d76f684`](https://github.com/nodejs/node/commit/764d76f684)] - ***Revert*** "**util**: change %o depth default" (Ruben Bridgewater) [#24806](https://github.com/nodejs/node/pull/24806)
* [[`9e8f91dbc7`](https://github.com/nodejs/node/commit/9e8f91dbc7)] - **util**: remove unreachable branch (rahulshuklab4u) [#24447](https://github.com/nodejs/node/pull/24447)
* [[`e13571c199`](https://github.com/nodejs/node/commit/e13571c199)] - **(SEMVER-MINOR)** **util,console**: handle symbols as defined in the spec (Ruben Bridgewater) [#23708](https://github.com/nodejs/node/pull/23708)
* [[`4d9a2650b2`](https://github.com/nodejs/node/commit/4d9a2650b2)] - **win**: do not use Boxstarter to install tools (João Reis) [#24677](https://github.com/nodejs/node/pull/24677)
* [[`899e7c30b0`](https://github.com/nodejs/node/commit/899e7c30b0)] - **win, build**: skip building cctest by default (Bartosz Sosnowski) [#21408](https://github.com/nodejs/node/pull/21408)

<a id="11.3.0"></a>
## 2018-11-27, Version 11.3.0 (Current), @rvagg

This is a security release. All Node.js users should consult the security release summary at:

  https://nodejs.org/en/blog/vulnerability/november-2018-security-releases/

for details on patched vulnerabilities.

Fixes for the following CVEs are included in this release:

  * Node.js: Denial of Service with large HTTP headers (CVE-2018-12121)
  * Node.js: Slowloris HTTP Denial of Service (CVE-2018-12122 / Node.js)
  * Node.js: Hostname spoofing in URL parser for javascript protocol (CVE-2018-12123)
  * OpenSSL: Timing vulnerability in DSA signature generation (CVE-2018-0734)
  * OpenSSL: Timing vulnerability in ECDSA signature generation (CVE-2019-0735)

### Notable Changes

* **deps**: Upgrade to OpenSSL 1.1.0j, fixing CVE-2018-0734 and CVE-2019-0735
* **http**:
    * Headers received by HTTP servers must not exceed 8192 bytes in total to prevent possible Denial of Service attacks. Reported by Trevor Norris. (CVE-2018-12121 / Matteo Collina)
    * A timeout of 40 seconds now applies to servers receiving HTTP headers. This value can be adjusted with `server.headersTimeout`. Where headers are not completely received within this period, the socket is destroyed on the next received chunk. In conjunction with `server.setTimeout()`, this aids in protecting against excessive resource retention and possible Denial of Service. Reported by Jan Maybach ([liebdich.com](https://liebdich.com)). (CVE-2018-12122 / Matteo Collina)
* **url**: Fix a bug that would allow a hostname being spoofed when parsing URLs with `url.parse()` with the `'javascript:'` protocol. Reported by [Martin Bajanik](https://twitter.com/_bayotop) ([Kentico](https://kenticocloud.com/)). (CVE-2018-12123 / Matteo Collina)

### Commits

* [[`8f191f3759`](https://github.com/nodejs/node/commit/8f191f3759)] - **deps**: update openssl 1.1.0 upgrade docs (Sam Roberts) [#24523](https://github.com/nodejs/node/pull/24523)
* [[`f20ac47d7a`](https://github.com/nodejs/node/commit/f20ac47d7a)] - **deps**: update archs files for OpenSSL-1.1.0 (Sam Roberts) [#24523](https://github.com/nodejs/node/pull/24523)
* [[`8248d227b7`](https://github.com/nodejs/node/commit/8248d227b7)] - **deps**: add s390 asm rules for OpenSSL-1.1.0 (Shigeki Ohtsu) [#24523](https://github.com/nodejs/node/pull/24523)
* [[`65d03f0180`](https://github.com/nodejs/node/commit/65d03f0180)] - **deps**: upgrade openssl sources to 1.1.0j (Sam Roberts) [#24523](https://github.com/nodejs/node/pull/24523)
* [[`a2b8aba23c`](https://github.com/nodejs/node/commit/a2b8aba23c)] - **deps,http**: llhttp set max header size to 8KB (Rod Vagg) [nodejs-private/node-private#149](https://github.com/nodejs-private/node-private/pull/149)
* [[`74e01d0020`](https://github.com/nodejs/node/commit/74e01d0020)] - **deps,http**: http\_parser set max header size to 8KB (Matteo Collina) [nodejs-private/node-private#143](https://github.com/nodejs-private/node-private/pull/143)
* [[`4ecbd3bdaa`](https://github.com/nodejs/node/commit/4ecbd3bdaa)] - **http**: reset headers\_nread\_ on llhttp parser reuse (Rod Vagg) [nodejs-private/node-private#149](https://github.com/nodejs-private/node-private/pull/149)
* [[`04e0620597`](https://github.com/nodejs/node/commit/04e0620597)] - **http**: fix header limit errors and test for llhttp (Fedor Indutny) [nodejs-private/node-private#149](https://github.com/nodejs-private/node-private/pull/149)
* [[`315ee2e626`](https://github.com/nodejs/node/commit/315ee2e626)] - **(SEMVER-MINOR)** **http,https**: protect against slow headers attack (Matteo Collina) [nodejs-private/node-private#144](https://github.com/nodejs-private/node-private/pull/144)
* [[`d7504324e1`](https://github.com/nodejs/node/commit/d7504324e1)] - **url**: avoid hostname spoofing w/ javascript protocol (Matteo Collina) [nodejs-private/node-private#145](https://github.com/nodejs-private/node-private/pull/145)

<a id="11.2.0"></a>
## 2018-11-15, Version 11.2.0 (Current), @BridgeAR

### Notable changes

* **deps**:
  * A new experimental HTTP parser (`llhttp`) is now supported. https://github.com/nodejs/node/pull/24059
* **timers**:
  * Fixed an issue that could cause setTimeout to stop working as expected. https://github.com/nodejs/node/pull/24322
* **Windows**
  * A crashing process will now show the names of stack frames if the node.pdb file is available. https://github.com/nodejs/node/pull/23822
  * Continued effort to improve the installer's new stage that installs
    native build tools. https://github.com/nodejs/node/pull/23987, https://github.com/nodejs/node/pull/24348
  * **child_process**:
    * On Windows the `windowsHide` option default was restored to `false`.
      This means `detached` child processes and GUI apps will once again
      start in a new window. https://github.com/nodejs/node/pull/24034
* **Added new collaborators**:
  * [oyyd](https://github.com/oyyd) - Ouyang Yadong. https://github.com/nodejs/node/pull/24300
  * [psmarshall](https://github.com/psmarshall) - Peter Marshall. https://github.com/nodejs/node/pull/24170
  * [shisama](https://github.com/shisama) - Masashi Hirano. https://github.com/nodejs/node/pull/24136

### Commits

* [[`685724b53d`](https://github.com/nodejs/node/commit/685724b53d)] - **assert**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`bb766ae05a`](https://github.com/nodejs/node/commit/bb766ae05a)] - **async_hooks**: add HandleScopes to C++ embedder/addon API (Anna Henningsen) [#24285](https://github.com/nodejs/node/pull/24285)
* [[`ad5c9b4463`](https://github.com/nodejs/node/commit/ad5c9b4463)] - **benchmark**: support more options in startup benchmark (Joyee Cheung) [#24220](https://github.com/nodejs/node/pull/24220)
* [[`d0bf8c2259`](https://github.com/nodejs/node/commit/d0bf8c2259)] - **benchmark**: add dir and withFileTypes option readdir benchmarks (Joyee Cheung) [#24125](https://github.com/nodejs/node/pull/24125)
* [[`40b3ad3eb8`](https://github.com/nodejs/node/commit/40b3ad3eb8)] - **benchmark**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`1f3cb63da3`](https://github.com/nodejs/node/commit/1f3cb63da3)] - **bootstrap**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`fcc25f9ee8`](https://github.com/nodejs/node/commit/fcc25f9ee8)] - **buffer**: fix writeUInt16BE range check (Brian White) [#24208](https://github.com/nodejs/node/pull/24208)
* [[`e4cd255a85`](https://github.com/nodejs/node/commit/e4cd255a85)] - **buffer**: throw exception when creating from non-Node.js Context (Anna Henningsen) [#23938](https://github.com/nodejs/node/pull/23938)
* [[`44ebdbb860`](https://github.com/nodejs/node/commit/44ebdbb860)] - **build**: fix benchmark tests on CI (Rich Trott) [#24307](https://github.com/nodejs/node/pull/24307)
* [[`1c8b4d7c89`](https://github.com/nodejs/node/commit/1c8b4d7c89)] - **build**: disable openssl asm on arm64 for now (Ben Noordhuis) [#24270](https://github.com/nodejs/node/pull/24270)
* [[`0c9d86f58c`](https://github.com/nodejs/node/commit/0c9d86f58c)] - **build**: use BUILDTYPE in bench-addons-build targets (Daniel Bevenius) [#24033](https://github.com/nodejs/node/pull/24033)
* [[`70699ee09b`](https://github.com/nodejs/node/commit/70699ee09b)] - **build**: lint commit message in separate Travis job (Richard Lau) [#24254](https://github.com/nodejs/node/pull/24254)
* [[`2b282e8f20`](https://github.com/nodejs/node/commit/2b282e8f20)] - **build**: move headers out of c++ src section (Daniel Bevenius) [#24124](https://github.com/nodejs/node/pull/24124)
* [[`a8008d1517`](https://github.com/nodejs/node/commit/a8008d1517)] - **build**: only try to find node when it's needed by the target (Joyee Cheung) [#24115](https://github.com/nodejs/node/pull/24115)
* [[`e4bcb97024`](https://github.com/nodejs/node/commit/e4bcb97024)] - **build**: change repo to https protocol in Makefile (mritunjaygoutam12) [#24073](https://github.com/nodejs/node/pull/24073)
* [[`7083b96c49`](https://github.com/nodejs/node/commit/7083b96c49)] - **build**: use latest node on travis (cjihrig) [#24198](https://github.com/nodejs/node/pull/24198)
* [[`99c2a10f7b`](https://github.com/nodejs/node/commit/99c2a10f7b)] - **build**: fix Travis non-PR builds (Richard Lau) [#24093](https://github.com/nodejs/node/pull/24093)
* [[`3de1c5cadd`](https://github.com/nodejs/node/commit/3de1c5cadd)] - **build**: do not lint on non-PR Travis builds (Anna Henningsen) [#24076](https://github.com/nodejs/node/pull/24076)
* [[`762679efec`](https://github.com/nodejs/node/commit/762679efec)] - **build**: make benchmark/napi all prereq order-only (Daniel Bevenius) [#23951](https://github.com/nodejs/node/pull/23951)
* [[`4651cd721d`](https://github.com/nodejs/node/commit/4651cd721d)] - **build**: add -Werror=undefined-inline to clang builds (Refael Ackermann) [#23961](https://github.com/nodejs/node/pull/23961)
* [[`e7133f1e7c`](https://github.com/nodejs/node/commit/e7133f1e7c)] - **build**: configure default v8\_optimized\_debug (Refael Ackermann) [#23704](https://github.com/nodejs/node/pull/23704)
* [[`26c19889a8`](https://github.com/nodejs/node/commit/26c19889a8)] - **build,meta**: don't fail Travis for commit message (Refael Ackermann) [#23739](https://github.com/nodejs/node/pull/23739)
* [[`838fb550c6`](https://github.com/nodejs/node/commit/838fb550c6)] - **build,tools**: update make-v8.sh for s390x (Refael Ackermann) [#23839](https://github.com/nodejs/node/pull/23839)
* [[`c07cce368a`](https://github.com/nodejs/node/commit/c07cce368a)] - ***Revert*** "**child_process**: change windowsHide default to true" (Rich Trott) [#24034](https://github.com/nodejs/node/pull/24034)
* [[`a1c7c1902a`](https://github.com/nodejs/node/commit/a1c7c1902a)] - **child_process**: allow 'http\_parser' monkey patching again (Jimb Esser) [#24006](https://github.com/nodejs/node/pull/24006)
* [[`4af63ee5d9`](https://github.com/nodejs/node/commit/4af63ee5d9)] - **child_process**: handle undefined/null for fork() args (Shobhit Chittora) [#22416](https://github.com/nodejs/node/pull/22416)
* [[`a2c13fac94`](https://github.com/nodejs/node/commit/a2c13fac94)] - **console**: console.timeLog() using the default label (Marie Terrier) [#24286](https://github.com/nodejs/node/pull/24286)
* [[`9e891327b7`](https://github.com/nodejs/node/commit/9e891327b7)] - **console**: cover .assert with single argument (Morgan Roderick) [#24188](https://github.com/nodejs/node/pull/24188)
* [[`2b48c7169a`](https://github.com/nodejs/node/commit/2b48c7169a)] - **crypto**: put legacy \_handle accessors on prototypes (Michaël Zasso) [#24269](https://github.com/nodejs/node/pull/24269)
* [[`f669817a5a`](https://github.com/nodejs/node/commit/f669817a5a)] - **(SEMVER-MINOR)** **crypto**: add support for chacha20-poly1305 for AEAD (chux0519) [#24081](https://github.com/nodejs/node/pull/24081)
* [[`ef69e7bcca`](https://github.com/nodejs/node/commit/ef69e7bcca)] - **deps**: backport 073073b4f1 from upstream V8 (Yang Guo) [#24274](https://github.com/nodejs/node/pull/24274)
* [[`a39493f4aa`](https://github.com/nodejs/node/commit/a39493f4aa)] - **deps**: cherry-pick b87d408 from upstream V8 (Peter Marshall) [#24272](https://github.com/nodejs/node/pull/24272)
* [[`9cefbba5d7`](https://github.com/nodejs/node/commit/9cefbba5d7)] - **deps**: patch V8 to 7.0.276.38 (Michaël Zasso) [#24271](https://github.com/nodejs/node/pull/24271)
* [[`115c57a240`](https://github.com/nodejs/node/commit/115c57a240)] - **deps**: introduce `llhttp` (Fedor Indutny) [#24059](https://github.com/nodejs/node/pull/24059)
* [[`566399ee31`](https://github.com/nodejs/node/commit/566399ee31)] - **deps**: patch V8 to 7.0.276.36 (Michaël Zasso) [#24109](https://github.com/nodejs/node/pull/24109)
* [[`3e1c53fe37`](https://github.com/nodejs/node/commit/3e1c53fe37)] - **deps**: cherry-pick 0483e9a from upstream V8 (Joyee Cheung) [#24125](https://github.com/nodejs/node/pull/24125)
* [[`6b697d4816`](https://github.com/nodejs/node/commit/6b697d4816)] - **deps**: c-ares float, version number patch (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* [[`07663694b4`](https://github.com/nodejs/node/commit/07663694b4)] - **deps**: upgrade to c-ares v1.15.0 (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* [[`eaea90b2ee`](https://github.com/nodejs/node/commit/eaea90b2ee)] - **deps**: remove old c-ares configure files (Ben Noordhuis) [#23854](https://github.com/nodejs/node/pull/23854)
* [[`f49b9e9c84`](https://github.com/nodejs/node/commit/f49b9e9c84)] - **deps**: patch V8 to 7.0.276.35 (Michaël Zasso) [#24056](https://github.com/nodejs/node/pull/24056)
* [[`6e4f238344`](https://github.com/nodejs/node/commit/6e4f238344)] - **deps,v8**: cherry-pick dc704497 (Refael Ackermann) [#23985](https://github.com/nodejs/node/pull/23985)
* [[`ef8b5b4094`](https://github.com/nodejs/node/commit/ef8b5b4094)] - **deps,v8**: fix gypfile bug (Refael Ackermann) [#23704](https://github.com/nodejs/node/pull/23704)
* [[`a01e829fb0`](https://github.com/nodejs/node/commit/a01e829fb0)] - **doc**: document http request.finished boolean (Thomas Watson) [#24319](https://github.com/nodejs/node/pull/24319)
* [[`36e4d0c6f0`](https://github.com/nodejs/node/commit/36e4d0c6f0)] - **doc**: document NODE\_TLS\_REJECT\_UNAUTHORIZED (cjihrig) [#24289](https://github.com/nodejs/node/pull/24289)
* [[`fbd0b037ec`](https://github.com/nodejs/node/commit/fbd0b037ec)] - **doc**: clarify issues and pull requests guidance (Rich Trott) [#24316](https://github.com/nodejs/node/pull/24316)
* [[`a993a488fa`](https://github.com/nodejs/node/commit/a993a488fa)] - **doc**: fix comma splices in process.md (Rich Trott) [#24357](https://github.com/nodejs/node/pull/24357)
* [[`e584cc52fc`](https://github.com/nodejs/node/commit/e584cc52fc)] - **doc**: use real protocol names in ALPN example (Sam Roberts) [#24232](https://github.com/nodejs/node/pull/24232)
* [[`7fc910763e`](https://github.com/nodejs/node/commit/7fc910763e)] - **doc**: update core-validate-commit url (Daijiro Wachi) [#24331](https://github.com/nodejs/node/pull/24331)
* [[`39382ed4e1`](https://github.com/nodejs/node/commit/39382ed4e1)] - **doc**: fix echo example programs (Sam Roberts) [#24235](https://github.com/nodejs/node/pull/24235)
* [[`c68b0ae46e`](https://github.com/nodejs/node/commit/c68b0ae46e)] - **doc**: update fs.open() changes record for optional 'flags' (Rod Vagg) [#24240](https://github.com/nodejs/node/pull/24240)
* [[`6b7e69875d`](https://github.com/nodejs/node/commit/6b7e69875d)] - **doc**: add links to Stream section (Dmitry Igrishin) [#24301](https://github.com/nodejs/node/pull/24301)
* [[`82c64d0008`](https://github.com/nodejs/node/commit/82c64d0008)] - **doc**: correct async\_hooks sample outputs (Gerhard Stoebich) [#24050](https://github.com/nodejs/node/pull/24050)
* [[`991d066338`](https://github.com/nodejs/node/commit/991d066338)] - **doc**: add oyyd to collaborators (Ouyang Yadong) [#24300](https://github.com/nodejs/node/pull/24300)
* [[`118d8d0feb`](https://github.com/nodejs/node/commit/118d8d0feb)] - **doc**: edit BUILDING.md (Rich Trott) [#24243](https://github.com/nodejs/node/pull/24243)
* [[`b5b5f9f8bd`](https://github.com/nodejs/node/commit/b5b5f9f8bd)] - **doc**: fix code examples in stream.md (Grant Carthew) [#24112](https://github.com/nodejs/node/pull/24112)
* [[`6ab46b5c47`](https://github.com/nodejs/node/commit/6ab46b5c47)] - **doc**: fix some inconsistent use of hostname (Sam Roberts) [#24199](https://github.com/nodejs/node/pull/24199)
* [[`1b81b348a3`](https://github.com/nodejs/node/commit/1b81b348a3)] - **doc**: describe what tls servername is for (Sam Roberts) [#24236](https://github.com/nodejs/node/pull/24236)
* [[`104b076d3d`](https://github.com/nodejs/node/commit/104b076d3d)] - **doc**: clarify allowed encoding parameter types (Sam Roberts) [#24230](https://github.com/nodejs/node/pull/24230)
* [[`7bcc4ccd8e`](https://github.com/nodejs/node/commit/7bcc4ccd8e)] - **doc**: remove legacy WPT integration guide (Joyee Cheung) [#24035](https://github.com/nodejs/node/pull/24035)
* [[`7cc3b9337f`](https://github.com/nodejs/node/commit/7cc3b9337f)] - **doc**: fix linting errors (cjihrig) [#24229](https://github.com/nodejs/node/pull/24229)
* [[`3ce71f7723`](https://github.com/nodejs/node/commit/3ce71f7723)] - **doc**: wrap GOVERNANCE.md at 80 characters (Rich Trott) [#24094](https://github.com/nodejs/node/pull/24094)
* [[`161be13602`](https://github.com/nodejs/node/commit/161be13602)] - **doc**: add text about error.code stability (Rich Trott) [#24090](https://github.com/nodejs/node/pull/24090)
* [[`2143b56b19`](https://github.com/nodejs/node/commit/2143b56b19)] - **doc**: update System Errors documentation (Rich Trott) [#24090](https://github.com/nodejs/node/pull/24090)
* [[`75ed7ce4a3`](https://github.com/nodejs/node/commit/75ed7ce4a3)] - **doc**: add psmarshall to collaborators (Peter Marshall) [#24170](https://github.com/nodejs/node/pull/24170)
* [[`f9f185a47b`](https://github.com/nodejs/node/commit/f9f185a47b)] - **doc**: add shisama to collaborators (Masashi Hirano) [#24136](https://github.com/nodejs/node/pull/24136)
* [[`d15270507e`](https://github.com/nodejs/node/commit/d15270507e)] - **doc**: implement minor text fixes to path.md (Rich Trott) [#24118](https://github.com/nodejs/node/pull/24118)
* [[`8642eacfff`](https://github.com/nodejs/node/commit/8642eacfff)] - **doc**: inspector security warning for changing host (Сковорода Никита Андреевич) [#23640](https://github.com/nodejs/node/pull/23640)
* [[`5ea48a92b2`](https://github.com/nodejs/node/commit/5ea48a92b2)] - **doc**: fix minor text issues in stream.md (Rich Trott) [#24116](https://github.com/nodejs/node/pull/24116)
* [[`6f54a7ace8`](https://github.com/nodejs/node/commit/6f54a7ace8)] - **doc**: streamline CONTRIBUTING.md (Rich Trott) [#24010](https://github.com/nodejs/node/pull/24010)
* [[`3b1044072c`](https://github.com/nodejs/node/commit/3b1044072c)] - **doc**: add table of contents to release guide (Michaël Zasso) [#24042](https://github.com/nodejs/node/pull/24042)
* [[`667ce42447`](https://github.com/nodejs/node/commit/667ce42447)] - **doc**: add missing comma in net documentation (Rich Trott) [#24074](https://github.com/nodejs/node/pull/24074)
* [[`1d6d384c02`](https://github.com/nodejs/node/commit/1d6d384c02)] - **doc**: correct link to test coverage command (mritunjaygoutam12) [#24049](https://github.com/nodejs/node/pull/24049)
* [[`94f73942ed`](https://github.com/nodejs/node/commit/94f73942ed)] - **doc**: fix socket.connecting description (Anna Henningsen) [#24066](https://github.com/nodejs/node/pull/24066)
* [[`fa84164de4`](https://github.com/nodejs/node/commit/fa84164de4)] - **doc**: add SECURITY.md to readme.md (warnerp18) [#24031](https://github.com/nodejs/node/pull/24031)
* [[`e8078f2693`](https://github.com/nodejs/node/commit/e8078f2693)] - **doc**: edit man page for superfluous "node" usage (Rich Trott) [#24029](https://github.com/nodejs/node/pull/24029)
* [[`a1b75d0cbf`](https://github.com/nodejs/node/commit/a1b75d0cbf)] - **doc**: fix dublication in net.createServer() docs (Ivan Filenko) [#24026](https://github.com/nodejs/node/pull/24026)
* [[`d729f3e198`](https://github.com/nodejs/node/commit/d729f3e198)] - **doc**: correct async\_hooks resource names (Gerhard Stoebich) [#24001](https://github.com/nodejs/node/pull/24001)
* [[`7012f72a12`](https://github.com/nodejs/node/commit/7012f72a12)] - **doc**: address bits of proof reading work (Jagannath Bhat) [#23978](https://github.com/nodejs/node/pull/23978)
* [[`399d64b331`](https://github.com/nodejs/node/commit/399d64b331)] - **doc**: revise COLLABORATOR\_GUIDE.md (Rich Trott) [#23990](https://github.com/nodejs/node/pull/23990)
* [[`879402b422`](https://github.com/nodejs/node/commit/879402b422)] - **doc**: simplify CODE\_OF\_CONDUCT.md (Rich Trott) [#23989](https://github.com/nodejs/node/pull/23989)
* [[`7b7155e90b`](https://github.com/nodejs/node/commit/7b7155e90b)] - **doc**: revise CHANGELOG.md text (Rich Trott) [#23988](https://github.com/nodejs/node/pull/23988)
* [[`b8a71bed02`](https://github.com/nodejs/node/commit/b8a71bed02)] - **doc**: improve COLLABORATOR\_GUIDE (Jagannath Bhat) [#23977](https://github.com/nodejs/node/pull/23977)
* [[`846e450f51`](https://github.com/nodejs/node/commit/846e450f51)] - **doc**: improve BUILDING.md (Jagannath Bhat) [#23976](https://github.com/nodejs/node/pull/23976)
* [[`b182e2e8b2`](https://github.com/nodejs/node/commit/b182e2e8b2)] - **doc**: add types and their corresponding return values (Ouyang Yadong) [#23998](https://github.com/nodejs/node/pull/23998)
* [[`2d84f45d22`](https://github.com/nodejs/node/commit/2d84f45d22)] - **esm**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`5ecfc7cab7`](https://github.com/nodejs/node/commit/5ecfc7cab7)] - **events**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`f49b4fc794`](https://github.com/nodejs/node/commit/f49b4fc794)] - **fs**: replace pushValueToArray with pure C++ API (Joyee Cheung) [#24125](https://github.com/nodejs/node/pull/24125)
* [[`d59dc0d6bf`](https://github.com/nodejs/node/commit/d59dc0d6bf)] - **fs**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`424be28840`](https://github.com/nodejs/node/commit/424be28840)] - **fs**: handle result of access binding directly in fs.existsSync (Joyee Cheung) [#24015](https://github.com/nodejs/node/pull/24015)
* [[`2aa23cd433`](https://github.com/nodejs/node/commit/2aa23cd433)] - **(SEMVER-MINOR)** **fs,net**: standardize `pending` stream property (Anna Henningsen) [#24067](https://github.com/nodejs/node/pull/24067)
* [[`86aa27f85d`](https://github.com/nodejs/node/commit/86aa27f85d)] - **http**: remove pushValueToArray in Parser::CreateHeaders() (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`c2599a14de`](https://github.com/nodejs/node/commit/c2599a14de)] - **http**: remove obsolete function escapeHeaderValue (Lauri Piisang) [#24173](https://github.com/nodejs/node/pull/24173)
* [[`62fefd8aeb`](https://github.com/nodejs/node/commit/62fefd8aeb)] - **http2**: remove pushValueToArray in Http2Session::HandleOriginFrame (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`7ffbb1f55f`](https://github.com/nodejs/node/commit/7ffbb1f55f)] - **http2**: remove pushValueToArray in Http2Session::HandleHeadersFrame (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`4a0f27656d`](https://github.com/nodejs/node/commit/4a0f27656d)] - **(SEMVER-MINOR)** **http2**: add Http2Stream.bufferSize (Ouyang Yadong) [#23711](https://github.com/nodejs/node/pull/23711)
* [[`c7f471ab97`](https://github.com/nodejs/node/commit/c7f471ab97)] - **http2**: improve http2 code a bit (James M Snell) [#23984](https://github.com/nodejs/node/pull/23984)
* [[`4dbcf7ac1f`](https://github.com/nodejs/node/commit/4dbcf7ac1f)] - **inspector**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`5ca0cf7ae6`](https://github.com/nodejs/node/commit/5ca0cf7ae6)] - **lib**: improved conditional check in zlib (Dan Corman) [#24190](https://github.com/nodejs/node/pull/24190)
* [[`d8d93442aa`](https://github.com/nodejs/node/commit/d8d93442aa)] - **lib**: adjust params from uvExceptionWithHostPort (msmichellegar) [#24159](https://github.com/nodejs/node/pull/24159)
* [[`6f80a45528`](https://github.com/nodejs/node/commit/6f80a45528)] - **lib**: combine contructor, tag, Object into a function (Paul Isache) [#24171](https://github.com/nodejs/node/pull/24171)
* [[`1225a0af09`](https://github.com/nodejs/node/commit/1225a0af09)] - **lib**: add crypto dependant modules cannotUseCache (Daniel Bevenius) [#24100](https://github.com/nodejs/node/pull/24100)
* [[`453c96ed2d`](https://github.com/nodejs/node/commit/453c96ed2d)] - **lib**: move process prototype manipulation into setupProcessObject (Joyee Cheung) [#24089](https://github.com/nodejs/node/pull/24089)
* [[`6a6b036042`](https://github.com/nodejs/node/commit/6a6b036042)] - **lib**: move internalBinding whitelisting into loaders.js (Joyee Cheung) [#24088](https://github.com/nodejs/node/pull/24088)
* [[`b4c8158459`](https://github.com/nodejs/node/commit/b4c8158459)] - **lib**: fix grammar error and make it clearer for comments (MaleDong) [#23799](https://github.com/nodejs/node/pull/23799)
* [[`879c0f1f3e`](https://github.com/nodejs/node/commit/879c0f1f3e)] - **lib**: move module exports proxy into a separate method (Joyee Cheung) [#24057](https://github.com/nodejs/node/pull/24057)
* [[`874393bfd0`](https://github.com/nodejs/node/commit/874393bfd0)] - **lib**: remove useless getLibuvNow in internal/timers (ZYSzys) [#23995](https://github.com/nodejs/node/pull/23995)
* [[`7ee0cea028`](https://github.com/nodejs/node/commit/7ee0cea028)] - **lib**: make coverage work for Node.js (Benjamin) [#23941](https://github.com/nodejs/node/pull/23941)
* [[`b3f3ebf3b3`](https://github.com/nodejs/node/commit/b3f3ebf3b3)] - **lib**: repl multiline history support (Anto Aravinth) [#22153](https://github.com/nodejs/node/pull/22153)
* [[`55adc25968`](https://github.com/nodejs/node/commit/55adc25968)] - **(SEMVER-MINOR)** **lib**: enable TypedArray and DataView for the v8 module (Ouyang Yadong) [#23953](https://github.com/nodejs/node/pull/23953)
* [[`5ff1e67ff7`](https://github.com/nodejs/node/commit/5ff1e67ff7)] - **lib**: fix code cache generation (Joyee Cheung) [#23855](https://github.com/nodejs/node/pull/23855)
* [[`164f2444a0`](https://github.com/nodejs/node/commit/164f2444a0)] - **lib**: remove useless cwd in posix.resolve (ZYSzys) [#23902](https://github.com/nodejs/node/pull/23902)
* [[`10156c612d`](https://github.com/nodejs/node/commit/10156c612d)] - **meta,doc**: ping community about new release (Refael Ackermann) [#24064](https://github.com/nodejs/node/pull/24064)
* [[`1dd8191515`](https://github.com/nodejs/node/commit/1dd8191515)] - **(SEMVER-MINOR)** **module**: support multi-dot file extension (Geoffrey Booth) [#23416](https://github.com/nodejs/node/pull/23416)
* [[`72204d114f`](https://github.com/nodejs/node/commit/72204d114f)] - **n-api**: add missing handle scopes (Daniel Bevenius) [#24011](https://github.com/nodejs/node/pull/24011)
* [[`10edc4f186`](https://github.com/nodejs/node/commit/10edc4f186)] - **net**: always invoke after-write callback (Anna Henningsen) [#24291](https://github.com/nodejs/node/pull/24291)
* [[`753f706858`](https://github.com/nodejs/node/commit/753f706858)] - **net**: add comments explaining error check (Steven Gabarro) [#24222](https://github.com/nodejs/node/pull/24222)
* [[`c53117e7ea`](https://github.com/nodejs/node/commit/c53117e7ea)] - **net**: remove unreachable check in internalConnect (Philipp Dunkel) [#24158](https://github.com/nodejs/node/pull/24158)
* [[`74451263a3`](https://github.com/nodejs/node/commit/74451263a3)] - **net**: partially revert "simplify Socket.prototype.\_final" (Anna Henningsen) [#24288](https://github.com/nodejs/node/pull/24288)
* [[`636e4e02a5`](https://github.com/nodejs/node/commit/636e4e02a5)] - **net**: simplify Socket.prototype.\_final (Anna Henningsen) [#24075](https://github.com/nodejs/node/pull/24075)
* [[`cd227eb791`](https://github.com/nodejs/node/commit/cd227eb791)] - **net**: `net.Server.listen()` avoid operations on `null` when fail (Ouyang Yadong) [#23920](https://github.com/nodejs/node/pull/23920)
* [[`293983a112`](https://github.com/nodejs/node/commit/293983a112)] - **os**: do not call into JS to push values to an array in GetCPUInfo (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`ccc3bb73db`](https://github.com/nodejs/node/commit/ccc3bb73db)] - **process**: remove pushValueToArray in GetActiveHandles (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`ba4337d77d`](https://github.com/nodejs/node/commit/ba4337d77d)] - **process**: remove pushValueToArray in GetActiveRequests (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`e5888462f6`](https://github.com/nodejs/node/commit/e5888462f6)] - **process**: remove pushValueToArray in EnvEnumerator (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`52468b33f7`](https://github.com/nodejs/node/commit/52468b33f7)] - **querystring**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`213b6293fc`](https://github.com/nodejs/node/commit/213b6293fc)] - **repl**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`e27f43201c`](https://github.com/nodejs/node/commit/e27f43201c)] - **repl**: use promise#finally (Weijia Wang) [#23971](https://github.com/nodejs/node/pull/23971)
* [[`b7aded3300`](https://github.com/nodejs/node/commit/b7aded3300)] - **src**: compile native modules and their code cache in C++ (Joyee Cheung) [#24221](https://github.com/nodejs/node/pull/24221)
* [[`92a8cbe87a`](https://github.com/nodejs/node/commit/92a8cbe87a)] - **src**: enable detailed source positions in V8 (Yang Guo) [#24274](https://github.com/nodejs/node/pull/24274)
* [[`f8ed673308`](https://github.com/nodejs/node/commit/f8ed673308)] - **src**: remove pushValueToArray and SetupProcessObject (Joyee Cheung) [#24264](https://github.com/nodejs/node/pull/24264)
* [[`7601cdfe8b`](https://github.com/nodejs/node/commit/7601cdfe8b)] - **src**: bundle persistent-to-local methods as class (Gabriel Schulhof) [#24276](https://github.com/nodejs/node/pull/24276)
* [[`f5945c9279`](https://github.com/nodejs/node/commit/f5945c9279)] - **src**: sort internal binding list (cjihrig) [#24292](https://github.com/nodejs/node/pull/24292)
* [[`e1c792919e`](https://github.com/nodejs/node/commit/e1c792919e)] - **src**: fix v8 compiler warnings in src (Daniel Bevenius) [#24246](https://github.com/nodejs/node/pull/24246)
* [[`81f4fb2b3b`](https://github.com/nodejs/node/commit/81f4fb2b3b)] - **src**: reuse std::make\_unique (alyssaq) [#24132](https://github.com/nodejs/node/pull/24132)
* [[`a9053c38ea`](https://github.com/nodejs/node/commit/a9053c38ea)] - **src**: cache the result of GetOptions() in JS land (Joyee Cheung) [#24091](https://github.com/nodejs/node/pull/24091)
* [[`17e80eca95`](https://github.com/nodejs/node/commit/17e80eca95)] - **src**: prefer param function check over args length (Shelley Vohr) [#23835](https://github.com/nodejs/node/pull/23835)
* [[`1cda9b3988`](https://github.com/nodejs/node/commit/1cda9b3988)] - **src**: fix Set() usage in env-inl.h (cjihrig) [#24060](https://github.com/nodejs/node/pull/24060)
* [[`bef1c3b748`](https://github.com/nodejs/node/commit/bef1c3b748)] - **src**: fix Set() usage in node.h (cjihrig) [#24060](https://github.com/nodejs/node/pull/24060)
* [[`2a93882498`](https://github.com/nodejs/node/commit/2a93882498)] - **src**: fix Get() usage in tls\_wrap.cc (cjihrig) [#24060](https://github.com/nodejs/node/pull/24060)
* [[`9437aaad26`](https://github.com/nodejs/node/commit/9437aaad26)] - **src**: fix Get() usage in async\_wrap.cc (cjihrig) [#24060](https://github.com/nodejs/node/pull/24060)
* [[`cb7d9f9980`](https://github.com/nodejs/node/commit/cb7d9f9980)] - **src**: move error handling code into node\_errors.cc (Joyee Cheung) [#24058](https://github.com/nodejs/node/pull/24058)
* [[`fdba226d13`](https://github.com/nodejs/node/commit/fdba226d13)] - **src**: fix compiler warning for debug build (Daniel Bevenius) [#23994](https://github.com/nodejs/node/pull/23994)
* [[`84e5807b1e`](https://github.com/nodejs/node/commit/84e5807b1e)] - **src**: fix CreatePlatform header param mismatch (Shelley Vohr) [#23947](https://github.com/nodejs/node/pull/23947)
* [[`38b0525bc3`](https://github.com/nodejs/node/commit/38b0525bc3)] - **src**: use v8:: for consistency in util (ZYSzys) [#23934](https://github.com/nodejs/node/pull/23934)
* [[`90872c4c6e`](https://github.com/nodejs/node/commit/90872c4c6e)] - **src**: fix fully-static & large-pages combination (Suresh Srinivas) [#23964](https://github.com/nodejs/node/pull/23964)
* [[`063b40edc1`](https://github.com/nodejs/node/commit/063b40edc1)] - **src**: use "constants" string instead of creating new one (Ouyang Yadong) [#23894](https://github.com/nodejs/node/pull/23894)
* [[`24b18645b9`](https://github.com/nodejs/node/commit/24b18645b9)] - **src,win**: informative stack traces (Refael Ackermann) [#23822](https://github.com/nodejs/node/pull/23822)
* [[`13dee430cd`](https://github.com/nodejs/node/commit/13dee430cd)] - **stream**: make `.destroy()` interact better with write queue (Anna Henningsen) [#24062](https://github.com/nodejs/node/pull/24062)
* [[`d6bcf8b98b`](https://github.com/nodejs/node/commit/d6bcf8b98b)] - **(SEMVER-MINOR)** **stream**: add auto-destroy mode (Mathias Buus) [#22795](https://github.com/nodejs/node/pull/22795)
* [[`2593b40f5c`](https://github.com/nodejs/node/commit/2593b40f5c)] - **test**: compare objects not identical by reference (Marie Terrier) [#24189](https://github.com/nodejs/node/pull/24189)
* [[`eeb5cc6305`](https://github.com/nodejs/node/commit/eeb5cc6305)] - **test**: add typeerror for vm/compileFunction params (Dan Corman) [#24179](https://github.com/nodejs/node/pull/24179)
* [[`dc26247e69`](https://github.com/nodejs/node/commit/dc26247e69)] - **test**: deep object to table not covered (Osmond van Hemert) [#24257](https://github.com/nodejs/node/pull/24257)
* [[`29a29f7f97`](https://github.com/nodejs/node/commit/29a29f7f97)] - **test**: add tests for Socket.setNoDelay (James Herrington) [#24250](https://github.com/nodejs/node/pull/24250)
* [[`aa800b097a`](https://github.com/nodejs/node/commit/aa800b097a)] - **test**: assert diff no color (Florin-Daniel BÎLBÎE) [#24181](https://github.com/nodejs/node/pull/24181)
* [[`b6d2819b93`](https://github.com/nodejs/node/commit/b6d2819b93)] - **test**: add process no deprecation (razvanbh) [#24196](https://github.com/nodejs/node/pull/24196)
* [[`dd9864b8d7`](https://github.com/nodejs/node/commit/dd9864b8d7)] - **test**: check for invalid module type in vm.js (alyssaq) [#24161](https://github.com/nodejs/node/pull/24161)
* [[`957ceaabe6`](https://github.com/nodejs/node/commit/957ceaabe6)] - **test**: fix flaky test-vm-timeout-escape-queuemicrotask (Rich Trott) [#24296](https://github.com/nodejs/node/pull/24296)
* [[`89c3388a77`](https://github.com/nodejs/node/commit/89c3388a77)] - **test**: fix arguments order in assertions (Emanuel Kluge) [#24149](https://github.com/nodejs/node/pull/24149)
* [[`ea5d1841af`](https://github.com/nodejs/node/commit/ea5d1841af)] - **test**: remove unused parameters in function definition (Paul Hodgson) [#24268](https://github.com/nodejs/node/pull/24268)
* [[`cb4c2dd33e`](https://github.com/nodejs/node/commit/cb4c2dd33e)] - **test**: esm loader unknown builtin module (Fran Herrero) [#24183](https://github.com/nodejs/node/pull/24183)
* [[`1a86499947`](https://github.com/nodejs/node/commit/1a86499947)] - **test**: fixed order of actual and expected arguments (kiyomizumia) [#24178](https://github.com/nodejs/node/pull/24178)
* [[`77163a9dee`](https://github.com/nodejs/node/commit/77163a9dee)] - **test**: add else and error case for TextDecoder (Lauri Piisang) [#24162](https://github.com/nodejs/node/pull/24162)
* [[`e5e9c6427b`](https://github.com/nodejs/node/commit/e5e9c6427b)] - **test**: dgram socket prints deprecation warnings (Robert Pamely) [#24177](https://github.com/nodejs/node/pull/24177)
* [[`366529654e`](https://github.com/nodejs/node/commit/366529654e)] - **test**: url format path ending hashchar not covered (Osmond van Hemert) [#24259](https://github.com/nodejs/node/pull/24259)
* [[`0a104ef33c`](https://github.com/nodejs/node/commit/0a104ef33c)] - **test**: test add and remove for lib/domain (Petar Dodev) [#24163](https://github.com/nodejs/node/pull/24163)
* [[`fe7ef1ad11`](https://github.com/nodejs/node/commit/fe7ef1ad11)] - **test**: add test for autoDestroy in stream (Daijiro Wachi) [#24127](https://github.com/nodejs/node/pull/24127)
* [[`02e9fa01f3`](https://github.com/nodejs/node/commit/02e9fa01f3)] - **test**: fix args order in process-getactiverequests (Vladyslav Kopylash) [#24186](https://github.com/nodejs/node/pull/24186)
* [[`f805db3620`](https://github.com/nodejs/node/commit/f805db3620)] - **test**: check control characters replacing (Alessandro Gatti) [#24182](https://github.com/nodejs/node/pull/24182)
* [[`75e4f7db40`](https://github.com/nodejs/node/commit/75e4f7db40)] - **test**: fix strictEqual argument order (Martin Kask) [#24153](https://github.com/nodejs/node/pull/24153)
* [[`09a8f4713d`](https://github.com/nodejs/node/commit/09a8f4713d)] - **test**: correct order of args in assert.strictEqual() (Natalie Cluer) [#24157](https://github.com/nodejs/node/pull/24157)
* [[`c83b650a10`](https://github.com/nodejs/node/commit/c83b650a10)] - **test**: add tests for process.initgroups (James Herrington) [#24154](https://github.com/nodejs/node/pull/24154)
* [[`762bb94d72`](https://github.com/nodejs/node/commit/762bb94d72)] - **test**: add test case for completion bash flag (Aivo Paas) [#24168](https://github.com/nodejs/node/pull/24168)
* [[`afcfdec289`](https://github.com/nodejs/node/commit/afcfdec289)] - **test**: add test for deepEqual Float32Array (Yehiyam Livneh) [#24164](https://github.com/nodejs/node/pull/24164)
* [[`b02eed5e3b`](https://github.com/nodejs/node/commit/b02eed5e3b)] - **test**: fix arguments order in assert.strictEqual() (Ulises Santana Suárez) [#24192](https://github.com/nodejs/node/pull/24192)
* [[`768425f21a`](https://github.com/nodejs/node/commit/768425f21a)] - **test**: fix assert.strictEqual argument order (John Mc Quillan) [#24172](https://github.com/nodejs/node/pull/24172)
* [[`26c625c3d2`](https://github.com/nodejs/node/commit/26c625c3d2)] - **test**: fix v8 Set/Get compiler warnings (Daniel Bevenius) [#24246](https://github.com/nodejs/node/pull/24246)
* [[`beb0800ab3`](https://github.com/nodejs/node/commit/beb0800ab3)] - **test**: move benchmark tests out of main test suite (Rich Trott) [#24265](https://github.com/nodejs/node/pull/24265)
* [[`883519679e`](https://github.com/nodejs/node/commit/883519679e)] - **test**: replacing fixture directory with temp (saurabhSiddhu) [#24077](https://github.com/nodejs/node/pull/24077)
* [[`ddbd0e1973`](https://github.com/nodejs/node/commit/ddbd0e1973)] - **test**: increase coverage internal readline (Berry de Witte) [#24150](https://github.com/nodejs/node/pull/24150)
* [[`56cd911cad`](https://github.com/nodejs/node/commit/56cd911cad)] - **test**: use NULL instead of 0 in common.h (Daniel Bevenius) [#24104](https://github.com/nodejs/node/pull/24104)
* [[`a05f2fc46b`](https://github.com/nodejs/node/commit/a05f2fc46b)] - **test**: move test-fs-watch-system-limit from sequential to pummel (Marcus Scott) [#23692](https://github.com/nodejs/node/pull/23692)
* [[`9af7ad592c`](https://github.com/nodejs/node/commit/9af7ad592c)] - **test**: fix uses of deprecated assert.fail with multiple args (ivan.filenko) [#23673](https://github.com/nodejs/node/pull/23673)
* [[`2b0410a3ef`](https://github.com/nodejs/node/commit/2b0410a3ef)] - **test**: use assert.strictEqual instead of assert.equal (ivan.filenko) [#23673](https://github.com/nodejs/node/pull/23673)
* [[`825f0dda5b`](https://github.com/nodejs/node/commit/825f0dda5b)] - **test**: add test for strictDeepEqual (Nikita Malyschkin) [#24197](https://github.com/nodejs/node/pull/24197)
* [[`b16e485910`](https://github.com/nodejs/node/commit/b16e485910)] - **test**: add coverage for systemerror set name (Amer Alimanović) [#24200](https://github.com/nodejs/node/pull/24200)
* [[`bc97b62f35`](https://github.com/nodejs/node/commit/bc97b62f35)] - **test**: fix order of arguments in assert.strictEqual (Alex Seifert) [#24145](https://github.com/nodejs/node/pull/24145)
* [[`4a69d218b6`](https://github.com/nodejs/node/commit/4a69d218b6)] - **test**: add test for 'ERR\_INVALID\_CALLBACK' (razvanbh) [#24224](https://github.com/nodejs/node/pull/24224)
* [[`8b0626c836`](https://github.com/nodejs/node/commit/8b0626c836)] - **test**: add coverage for escape key switch case (Artur Daschevici) [#24194](https://github.com/nodejs/node/pull/24194)
* [[`92d2d7917f`](https://github.com/nodejs/node/commit/92d2d7917f)] - **test**: fix NewFromUtf8 compiler warning (Daniel Bevenius) [#24216](https://github.com/nodejs/node/pull/24216)
* [[`0c4facfbaf`](https://github.com/nodejs/node/commit/0c4facfbaf)] - **test**: change arguments order in strictEqual (Paul Isache) [#24156](https://github.com/nodejs/node/pull/24156)
* [[`2baa59b897`](https://github.com/nodejs/node/commit/2baa59b897)] - **test**: switch order of strictEqual arguments (Jonah Polack) [#24185](https://github.com/nodejs/node/pull/24185)
* [[`c8d8e5cf2c`](https://github.com/nodejs/node/commit/c8d8e5cf2c)] - **test**: fix the arguments order in `assert.strictEqual` (mzucker) [#24227](https://github.com/nodejs/node/pull/24227)
* [[`4245cbbf49`](https://github.com/nodejs/node/commit/4245cbbf49)] - **test**: fix the arguments order in `assert.strictEqual` (mzucker) [#24226](https://github.com/nodejs/node/pull/24226)
* [[`be40fd1e50`](https://github.com/nodejs/node/commit/be40fd1e50)] - **test**: fix order in assert.strictEqual to actual, expected (Kevin Seidel) [#24184](https://github.com/nodejs/node/pull/24184)
* [[`a1f5179e09`](https://github.com/nodejs/node/commit/a1f5179e09)] - **test**: fix arguments order in assert.strictEqual (szabolcsit) [#24143](https://github.com/nodejs/node/pull/24143)
* [[`5510bec3cc`](https://github.com/nodejs/node/commit/5510bec3cc)] - **test**: fix assert argument order (Manish Poddar) [#24160](https://github.com/nodejs/node/pull/24160)
* [[`e46b8edb58`](https://github.com/nodejs/node/commit/e46b8edb58)] - **test**: add error code tests in dgram test (Mark Arranz) [#24215](https://github.com/nodejs/node/pull/24215)
* [[`6076ccf90d`](https://github.com/nodejs/node/commit/6076ccf90d)] - **test**: fix order of arguments in test-delayed-require assertion (reineke-fox) [#24165](https://github.com/nodejs/node/pull/24165)
* [[`989c2aaf83`](https://github.com/nodejs/node/commit/989c2aaf83)] - **test**: fix flaky test-vm-timeout-escape-nexttick (Rich Trott) [#24251](https://github.com/nodejs/node/pull/24251)
* [[`b68734b66a`](https://github.com/nodejs/node/commit/b68734b66a)] - **test**: initialize test/wpt to run URL and console .js tests (Joyee Cheung) [#24035](https://github.com/nodejs/node/pull/24035)
* [[`c973551eca`](https://github.com/nodejs/node/commit/c973551eca)] - **test**: use URL fixtures under test/fixtures/wpt/url/resources (Joyee Cheung) [#24035](https://github.com/nodejs/node/pull/24035)
* [[`3f935d74e0`](https://github.com/nodejs/node/commit/3f935d74e0)] - **test**: remove WPT tests that are now .any.js in the upstream (Joyee Cheung) [#24035](https://github.com/nodejs/node/pull/24035)
* [[`121a3f8855`](https://github.com/nodejs/node/commit/121a3f8855)] - **test**: use git node wpt to pull WPT into test/fixtures (Joyee Cheung) [#24035](https://github.com/nodejs/node/pull/24035)
* [[`317901174c`](https://github.com/nodejs/node/commit/317901174c)] - **test**: fix arguments order in test-fs-write-buffer (razvanbh) [#24155](https://github.com/nodejs/node/pull/24155)
* [[`9b3c2e5054`](https://github.com/nodejs/node/commit/9b3c2e5054)] - **test**: fix argument order in assert.strictEqual() (Clement) [#24147](https://github.com/nodejs/node/pull/24147)
* [[`2d87ce3d8b`](https://github.com/nodejs/node/commit/2d87ce3d8b)] - **test**: switch arguments in strictEqual (Mathieu Pavageau) [#24141](https://github.com/nodejs/node/pull/24141)
* [[`6c8b128fcc`](https://github.com/nodejs/node/commit/6c8b128fcc)] - **test**: fix arguments order (Simona Cotin) [#24151](https://github.com/nodejs/node/pull/24151)
* [[`3d19a04b51`](https://github.com/nodejs/node/commit/3d19a04b51)] - **test**: fixe argument order in assert.strictEqual (Marc Posth) [#24140](https://github.com/nodejs/node/pull/24140)
* [[`a0681b7211`](https://github.com/nodejs/node/commit/a0681b7211)] - **test**: removed extraneous argument 's' (Jackson Chui) [#24213](https://github.com/nodejs/node/pull/24213)
* [[`12429812bc`](https://github.com/nodejs/node/commit/12429812bc)] - **test**: fixing arguments order in `assert.strictEqual()` (G. Carcaci) [#24152](https://github.com/nodejs/node/pull/24152)
* [[`fc494cdb16`](https://github.com/nodejs/node/commit/fc494cdb16)] - **test**: add tests for OutgoingMessage setTimeout (Robin Drexler) [#24148](https://github.com/nodejs/node/pull/24148)
* [[`ce124aca65`](https://github.com/nodejs/node/commit/ce124aca65)] - **test**: swap expected and actual in assert.strictEqual (Florin-Daniel BÎLBÎE) [#24146](https://github.com/nodejs/node/pull/24146)
* [[`737f897b51`](https://github.com/nodejs/node/commit/737f897b51)] - **test**: fix assert parameter order (Roland Broekema) [#24144](https://github.com/nodejs/node/pull/24144)
* [[`d85161cbfd`](https://github.com/nodejs/node/commit/d85161cbfd)] - **test**: change order of assert.strictEqual() (Remy Parzinski) [#24142](https://github.com/nodejs/node/pull/24142)
* [[`fb58ada9dd`](https://github.com/nodejs/node/commit/fb58ada9dd)] - **test**: fix invalid argument order in test-http-expect-continue.js (Morgan Roderick) [#24138](https://github.com/nodejs/node/pull/24138)
* [[`7cc0a46e85`](https://github.com/nodejs/node/commit/7cc0a46e85)] - **test**: strictEqual argument order (actual, expected) (Ahmad Nassri) [#24137](https://github.com/nodejs/node/pull/24137)
* [[`a5ac7b94ea`](https://github.com/nodejs/node/commit/a5ac7b94ea)] - **test**: fixed the arguments order in `assert.strictEqual` (mzucker) [#24135](https://github.com/nodejs/node/pull/24135)
* [[`71545e6284`](https://github.com/nodejs/node/commit/71545e6284)] - **test**: swap the order of arguments (Musa Hamwala) [#24134](https://github.com/nodejs/node/pull/24134)
* [[`a8908f16f7`](https://github.com/nodejs/node/commit/a8908f16f7)] - **test**: fs readfile, swap arguments in strictEqual (Petar Dodev) [#24133](https://github.com/nodejs/node/pull/24133)
* [[`7c04fe07a6`](https://github.com/nodejs/node/commit/7c04fe07a6)] - **test**: fix arguments order (Fran Herrero) [#24131](https://github.com/nodejs/node/pull/24131)
* [[`6f80a5eeda`](https://github.com/nodejs/node/commit/6f80a5eeda)] - **test**: http-client-timeout error assert arguments (Tadhg Creedon) [#24130](https://github.com/nodejs/node/pull/24130)
* [[`415fcded15`](https://github.com/nodejs/node/commit/415fcded15)] - **test**: fix flaky VM timeout test on Raspberry Pi (Rich Trott) [#24238](https://github.com/nodejs/node/pull/24238)
* [[`a2e2c91cfa`](https://github.com/nodejs/node/commit/a2e2c91cfa)] - **test**: disable color formating for test-internal-errors.js (Refael Ackermann) [#24204](https://github.com/nodejs/node/pull/24204)
* [[`a35bcd5ef5`](https://github.com/nodejs/node/commit/a35bcd5ef5)] - **test**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`9bf36bc6c3`](https://github.com/nodejs/node/commit/9bf36bc6c3)] - **test**: add a test for `tls.Socket` with `allowHalfOpen` (Ouyang Yadong) [#23866](https://github.com/nodejs/node/pull/23866)
* [[`8a3836ec72`](https://github.com/nodejs/node/commit/8a3836ec72)] - **test**: add crypto check to test-benchmark-http2 (Daniel Bevenius) [#24096](https://github.com/nodejs/node/pull/24096)
* [[`b86a89b9ad`](https://github.com/nodejs/node/commit/b86a89b9ad)] - **test**: increase --stack\_size test-async-wrap-pop (Daniel Bevenius) [#23996](https://github.com/nodejs/node/pull/23996)
* [[`1b97dbd6b5`](https://github.com/nodejs/node/commit/1b97dbd6b5)] - **test**: assert that invalidcmd throws error code (Jerome Covington) [#23942](https://github.com/nodejs/node/pull/23942)
* [[`63778b7ae1`](https://github.com/nodejs/node/commit/63778b7ae1)] - **test**: fix strictEqual arguments order (Esteban Sotillo) [#23956](https://github.com/nodejs/node/pull/23956)
* [[`dccf4a6c38`](https://github.com/nodejs/node/commit/dccf4a6c38)] - **test**: add property for RangeError in test-buffer-copy (mritunjaygoutam12) [#23968](https://github.com/nodejs/node/pull/23968)
* [[`8bffd90933`](https://github.com/nodejs/node/commit/8bffd90933)] - **test**: fix test-fs-watch-system-limit (Ali Ijaz Sheikh) [#23986](https://github.com/nodejs/node/pull/23986)
* [[`7a2134c414`](https://github.com/nodejs/node/commit/7a2134c414)] - **test**: run code cache test by default and test generator (Joyee Cheung) [#23855](https://github.com/nodejs/node/pull/23855)
* [[`5b9ef11e35`](https://github.com/nodejs/node/commit/5b9ef11e35)] - **timers**: fix priority queue removeAt (Anatoli Papirovski) [#24322](https://github.com/nodejs/node/pull/24322)
* [[`d6f91ba139`](https://github.com/nodejs/node/commit/d6f91ba139)] - **(SEMVER-MINOR)** **tls**: get the local certificate after tls handshake (Sam Roberts) [#24261](https://github.com/nodejs/node/pull/24261)
* [[`ad72e40e5b`](https://github.com/nodejs/node/commit/ad72e40e5b)] - **tools**: update ESLint to 5.9.0 (cjihrig) [#24280](https://github.com/nodejs/node/pull/24280)
* [[`6fdc5d9c9a`](https://github.com/nodejs/node/commit/6fdc5d9c9a)] - **tools**: enable 80-char line length markdown linting (Rich Trott) [#24094](https://github.com/nodejs/node/pull/24094)
* [[`b3c163f11b`](https://github.com/nodejs/node/commit/b3c163f11b)] - **tools**: lint for unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`1541c7f401`](https://github.com/nodejs/node/commit/1541c7f401)] - **tools**: add script to lint first PR commit message (Richard Lau) [#24030](https://github.com/nodejs/node/pull/24030)
* [[`4d7fbc3e0f`](https://github.com/nodejs/node/commit/4d7fbc3e0f)] - **tools**: update alternative docs versions (Richard Lau) [#23980](https://github.com/nodejs/node/pull/23980)
* [[`8de1030a70`](https://github.com/nodejs/node/commit/8de1030a70)] - **tracing**: fix static destruction order issue (Anna Henningsen) [#24123](https://github.com/nodejs/node/pull/24123)
* [[`0063448b04`](https://github.com/nodejs/node/commit/0063448b04)] - **url**: make the context non-enumerable (Joyee Cheung) [#24218](https://github.com/nodejs/node/pull/24218)
* [[`953697a7b8`](https://github.com/nodejs/node/commit/953697a7b8)] - **util**: deleted unreachable code from util.inspect (kiyomizumia) [#24187](https://github.com/nodejs/node/pull/24187)
* [[`fb7c1b3e81`](https://github.com/nodejs/node/commit/fb7c1b3e81)] - **v8_prof_polyfill**: remove unused catch bindings (cjihrig) [#24079](https://github.com/nodejs/node/pull/24079)
* [[`9c15124aa8`](https://github.com/nodejs/node/commit/9c15124aa8)] - **vm**: clarify timeout option in vm (Vladimir de Turckheim) [#23512](https://github.com/nodejs/node/pull/23512)
* [[`2331181410`](https://github.com/nodejs/node/commit/2331181410)] - **vm**: allow `cachedData` to also be TypedArray|DataView (Benjamin Chen) [#22921](https://github.com/nodejs/node/pull/22921)
* [[`4709fe676d`](https://github.com/nodejs/node/commit/4709fe676d)] - **win**: add customization warning to tools script (João Reis) [#24348](https://github.com/nodejs/node/pull/24348)
* [[`57a2b957de`](https://github.com/nodejs/node/commit/57a2b957de)] - **win**: add prompt to tools installation script (João Reis) [#23987](https://github.com/nodejs/node/pull/23987)
* [[`df1ca0fd82`](https://github.com/nodejs/node/commit/df1ca0fd82)] - **win**: clarify Boxstarter behavior on install tools (Rob Reynolds) [#23987](https://github.com/nodejs/node/pull/23987)

<a id="11.1.0"></a>
## 2018-11-02, Version 11.1.0 (Current), @targos

### Notable changes

* **deps**
  * Updated ICU to 63.1. [#23715](https://github.com/nodejs/node/pull/23715)
* **repl**
  * Top-level for-await-of is now supported in the REPL. [#23841](https://github.com/nodejs/node/pull/23841)
* **timers**
  * Fixed an issue that could cause timers to enter an infinite loop. [#23870](https://github.com/nodejs/node/pull/23870)

### Commits

* [[`2c2e2b53ab`](https://github.com/nodejs/node/commit/2c2e2b53ab)] - **benchmark**: fix bench-mkdirp to use recursive option (Klaus Meinhardt) [#23699](https://github.com/nodejs/node/pull/23699)
* [[`787e13b41c`](https://github.com/nodejs/node/commit/787e13b41c)] - **build**: expose more openssl categories for addons (Jonathan Cardoso Machado) [#23344](https://github.com/nodejs/node/pull/23344)
* [[`b8f3bb107e`](https://github.com/nodejs/node/commit/b8f3bb107e)] - **build**: add lint-py which uses flake8 (cclauss) [#21952](https://github.com/nodejs/node/pull/21952)
* [[`35c3c4ba68`](https://github.com/nodejs/node/commit/35c3c4ba68)] - **build**: allow for overwriting of use\_openssl\_def (Shelley Vohr) [#23763](https://github.com/nodejs/node/pull/23763)
* [[`5c35d0db47`](https://github.com/nodejs/node/commit/5c35d0db47)] - **build,meta**: switch to gcc-4.9 on travis (Refael Ackermann) [#23778](https://github.com/nodejs/node/pull/23778)
* [[`141aec9564`](https://github.com/nodejs/node/commit/141aec9564)] - **crypto**: add SET\_INTEGER\_CONSANT macro (Daniel Bevenius) [#23687](https://github.com/nodejs/node/pull/23687)
* [[`4112a10abe`](https://github.com/nodejs/node/commit/4112a10abe)] - **crypto**: strip unwanted space from openssl version (Sam Roberts) [#23678](https://github.com/nodejs/node/pull/23678)
* [[`2cc4f5c923`](https://github.com/nodejs/node/commit/2cc4f5c923)] - **deps**: patch V8 to 7.0.276.32 (Michaël Zasso) [#23851](https://github.com/nodejs/node/pull/23851)
* [[`0312d8b2cd`](https://github.com/nodejs/node/commit/0312d8b2cd)] - **deps**: fix shim for `v8::Value::IntegerValue()` (Anna Henningsen) [#23898](https://github.com/nodejs/node/pull/23898)
* [[`9011db426e`](https://github.com/nodejs/node/commit/9011db426e)] - **(SEMVER-MINOR)** **deps**: move more deprecations to V8\_DEPRECATED (Anna Henningsen) [#23414](https://github.com/nodejs/node/pull/23414)
* [[`e5b51cc496`](https://github.com/nodejs/node/commit/e5b51cc496)] - **(SEMVER-MINOR)** **deps**: icu 63.1 bump (CLDR 34) (Steven R. Loomis) [#23715](https://github.com/nodejs/node/pull/23715)
* [[`ab58439916`](https://github.com/nodejs/node/commit/ab58439916)] - **deps**: icu: apply workaround patch (Steven R. Loomis) [#23764](https://github.com/nodejs/node/pull/23764)
* [[`3b66a8d893`](https://github.com/nodejs/node/commit/3b66a8d893)] - **deps**: fix wrong default for v8 handle zapping (Refael Ackermann) [#23801](https://github.com/nodejs/node/pull/23801)
* [[`26510fbd8e`](https://github.com/nodejs/node/commit/26510fbd8e)] - **doc**: add branding to style guide (Rich Trott) [#23967](https://github.com/nodejs/node/pull/23967)
* [[`33053ec8d7`](https://github.com/nodejs/node/commit/33053ec8d7)] - **doc**: use Node.js instead of Node (Rich Trott) [#23967](https://github.com/nodejs/node/pull/23967)
* [[`ec009f620c`](https://github.com/nodejs/node/commit/ec009f620c)] - **doc**: revise BUILDING.md (Rich Trott) [#23966](https://github.com/nodejs/node/pull/23966)
* [[`da494ef889`](https://github.com/nodejs/node/commit/da494ef889)] - **doc**: clarify fd behaviour with {read,write}File (Sakthipriyan Vairamani (thefourtheye)) [#23706](https://github.com/nodejs/node/pull/23706)
* [[`539e1233b0`](https://github.com/nodejs/node/commit/539e1233b0)] - **doc**: moved test instructions to BUILDING.md (Kamat, Trivikram) [#23949](https://github.com/nodejs/node/pull/23949)
* [[`cc65fee1d3`](https://github.com/nodejs/node/commit/cc65fee1d3)] - **doc**: fix typographical issues (Denis McDonald) [#23970](https://github.com/nodejs/node/pull/23970)
* [[`ee6b0395f5`](https://github.com/nodejs/node/commit/ee6b0395f5)] - **doc**: sort markdown refs in errors (Sam Roberts) [#23972](https://github.com/nodejs/node/pull/23972)
* [[`ee299c7ef1`](https://github.com/nodejs/node/commit/ee299c7ef1)] - **doc**: remove "idiomatic choice" from queueMicrotask (Rod Vagg) [#23885](https://github.com/nodejs/node/pull/23885)
* [[`147e5d5792`](https://github.com/nodejs/node/commit/147e5d5792)] - **doc**: document HPE\_HEADER\_OVERFLOW error (Sam Roberts) [#23963](https://github.com/nodejs/node/pull/23963)
* [[`24c6a02930`](https://github.com/nodejs/node/commit/24c6a02930)] - **doc**: add documentation for http.IncomingMessage$complete (James M Snell) [#23914](https://github.com/nodejs/node/pull/23914)
* [[`82ee6c3e47`](https://github.com/nodejs/node/commit/82ee6c3e47)] - **doc**: remove mailing list (Rich Trott) [#23932](https://github.com/nodejs/node/pull/23932)
* [[`99fffff6e0`](https://github.com/nodejs/node/commit/99fffff6e0)] - **doc**: remove notice of dashes in V8 options (Denys Otrishko) [#23903](https://github.com/nodejs/node/pull/23903)
* [[`8b5339da14`](https://github.com/nodejs/node/commit/8b5339da14)] - **doc**: rename README section for Release Keys (Rich Trott) [#23927](https://github.com/nodejs/node/pull/23927)
* [[`676875195b`](https://github.com/nodejs/node/commit/676875195b)] - **doc**: add note about ABI compatibility (Myles Borins) [#22237](https://github.com/nodejs/node/pull/22237)
* [[`f01a806276`](https://github.com/nodejs/node/commit/f01a806276)] - **doc**: add optional callback to socket.end() (Ajido) [#23937](https://github.com/nodejs/node/pull/23937)
* [[`64c205d9bc`](https://github.com/nodejs/node/commit/64c205d9bc)] - **doc**: make example more clarified in cluster.md (ZYSzys) [#23931](https://github.com/nodejs/node/pull/23931)
* [[`748dbf9778`](https://github.com/nodejs/node/commit/748dbf9778)] - **doc**: simplify valid security issue descriptions (Rich Trott) [#23881](https://github.com/nodejs/node/pull/23881)
* [[`e241398ef6`](https://github.com/nodejs/node/commit/e241398ef6)] - **doc**: simplify path.basename() on POSIX and Windows (ZYSzys) [#23864](https://github.com/nodejs/node/pull/23864)
* [[`49b32af5ab`](https://github.com/nodejs/node/commit/49b32af5ab)] - **doc**: document nullptr comparisons in style guide (Anna Henningsen) [#23805](https://github.com/nodejs/node/pull/23805)
* [[`0ba49fec12`](https://github.com/nodejs/node/commit/0ba49fec12)] - **doc**: remove problematic example from README (Rich Trott) [#23817](https://github.com/nodejs/node/pull/23817)
* [[`d808d27120`](https://github.com/nodejs/node/commit/d808d27120)] - **doc**: use Cookie in request.setHeader() examples (Luigi Pinca) [#23707](https://github.com/nodejs/node/pull/23707)
* [[`1baba9b061`](https://github.com/nodejs/node/commit/1baba9b061)] - **doc**: NODE\_EXTRA\_CA\_CERTS is ignored if setuid root (Ben Noordhuis) [#23770](https://github.com/nodejs/node/pull/23770)
* [[`dd5afbe05f`](https://github.com/nodejs/node/commit/dd5afbe05f)] - **doc**: add review suggestions to require() (erickwendel) [#23605](https://github.com/nodejs/node/pull/23605)
* [[`db113a24e0`](https://github.com/nodejs/node/commit/db113a24e0)] - **doc**: document and warn if the ICU version is too old (Steven R. Loomis) [#23766](https://github.com/nodejs/node/pull/23766)
* [[`c30de85ca5`](https://github.com/nodejs/node/commit/c30de85ca5)] - **doc**: move @phillipj to emeriti (Phillip Johnsen) [#23790](https://github.com/nodejs/node/pull/23790)
* [[`84fdb1cc0e`](https://github.com/nodejs/node/commit/84fdb1cc0e)] - **doc**: add note about removeListener order (James M Snell) [#23762](https://github.com/nodejs/node/pull/23762)
* [[`f4c4b2b41b`](https://github.com/nodejs/node/commit/f4c4b2b41b)] - **doc**: document ACL limitation for fs.access on Windows (James M Snell) [#23772](https://github.com/nodejs/node/pull/23772)
* [[`83b776c864`](https://github.com/nodejs/node/commit/83b776c864)] - **doc**: document that addMembership must be called once in a cluster (James M Snell) [#23746](https://github.com/nodejs/node/pull/23746)
* [[`1851cf4f83`](https://github.com/nodejs/node/commit/1851cf4f83)] - **doc, test**: document and test vm timeout escapes (James M Snell) [#23743](https://github.com/nodejs/node/pull/23743)
* [[`b4b101fed6`](https://github.com/nodejs/node/commit/b4b101fed6)] - **(SEMVER-MINOR)** **fs**: default open/openSync flags argument to 'r' (Ben Noordhuis) [#23767](https://github.com/nodejs/node/pull/23767)
* [[`1c5ffb3ec5`](https://github.com/nodejs/node/commit/1c5ffb3ec5)] - **(SEMVER-MINOR)** **lib**: add escapeCodeTimeout as an option to createInterface (Raoof) [#19780](https://github.com/nodejs/node/pull/19780)
* [[`1cda41b7da`](https://github.com/nodejs/node/commit/1cda41b7da)] - **lib**: migrate from process.binding('config') to getOptions() (Vladimir Ilic) [#23588](https://github.com/nodejs/node/pull/23588)
* [[`22cd53791a`](https://github.com/nodejs/node/commit/22cd53791a)] - **lib**: trigger uncaught exception handler for microtasks (Gus Caplan) [#23794](https://github.com/nodejs/node/pull/23794)
* [[`97496f0fd9`](https://github.com/nodejs/node/commit/97496f0fd9)] - **n-api**: make per-`Context`-ness of `napi\_env` explicit (Anna Henningsen) [#23689](https://github.com/nodejs/node/pull/23689)
* [[`3e512f1897`](https://github.com/nodejs/node/commit/3e512f1897)] - **os**: fix memory leak in `userInfo()` (Anna Henningsen) [#23893](https://github.com/nodejs/node/pull/23893)
* [[`02f13abde3`](https://github.com/nodejs/node/commit/02f13abde3)] - **repl**: support top-level for-await-of (Shelley Vohr) [#23841](https://github.com/nodejs/node/pull/23841)
* [[`86cf01404c`](https://github.com/nodejs/node/commit/86cf01404c)] - **repl**: migrate from process.binding('config') to getOptions() (Jose Bucio) [#23684](https://github.com/nodejs/node/pull/23684)
* [[`4a79b2568f`](https://github.com/nodejs/node/commit/4a79b2568f)] - **src**: improve StreamBase write throughput (Anna Henningsen) [#23843](https://github.com/nodejs/node/pull/23843)
* [[`dcaf72311b`](https://github.com/nodejs/node/commit/dcaf72311b)] - **src**: minor refactor to node\_errors.h (Anna Henningsen) [#23879](https://github.com/nodejs/node/pull/23879)
* [[`fef17b716d`](https://github.com/nodejs/node/commit/fef17b716d)] - **src**: avoid extra `Persistent` in `DefaultTriggerAsyncIdScope` (Anna Henningsen) [#23844](https://github.com/nodejs/node/pull/23844)
* [[`ce106df728`](https://github.com/nodejs/node/commit/ce106df728)] - **src**: use maybe version v8::Function::Call (Ouyang Yadong) [#23826](https://github.com/nodejs/node/pull/23826)
* [[`1bdbf8765d`](https://github.com/nodejs/node/commit/1bdbf8765d)] - **src**: reduce duplication in tcp\_wrap Connect (Daniel Bevenius) [#23753](https://github.com/nodejs/node/pull/23753)
* [[`9fbe91a061`](https://github.com/nodejs/node/commit/9fbe91a061)] - **src**: refactor deprecated v8::String::NewFromTwoByte call (Romain Lanz) [#23803](https://github.com/nodejs/node/pull/23803)
* [[`48ed81fad2`](https://github.com/nodejs/node/commit/48ed81fad2)] - **src**: improve StreamBase read throughput (Anna Henningsen) [#23797](https://github.com/nodejs/node/pull/23797)
* [[`a6fe2caaae`](https://github.com/nodejs/node/commit/a6fe2caaae)] - **src**: simplify `TimerFunctionCall()` in `node\_perf.cc` (Anna Henningsen) [#23782](https://github.com/nodejs/node/pull/23782)
* [[`30be5cbdb0`](https://github.com/nodejs/node/commit/30be5cbdb0)] - **src**: memory management using smart pointer (Uttam Pawar) [#23628](https://github.com/nodejs/node/pull/23628)
* [[`df05ddfd72`](https://github.com/nodejs/node/commit/df05ddfd72)] - **src**: refactor deprecated v8::Function::Call call (Romain Lanz) [#23804](https://github.com/nodejs/node/pull/23804)
* [[`7bbc072529`](https://github.com/nodejs/node/commit/7bbc072529)] - **stream**: do not error async iterators on destroy(null) (Matteo Collina) [#23901](https://github.com/nodejs/node/pull/23901)
* [[`5ce3b6d7a4`](https://github.com/nodejs/node/commit/5ce3b6d7a4)] - **stream**: ended streams should resolve the async iteration (Matteo Collina) [#23901](https://github.com/nodejs/node/pull/23901)
* [[`aaddf97d9b`](https://github.com/nodejs/node/commit/aaddf97d9b)] - **stream**: async iteration should work with destroyed stream (Matteo Collina) [#23785](https://github.com/nodejs/node/pull/23785)
* [[`871e32789a`](https://github.com/nodejs/node/commit/871e32789a)] - **test**: fixed error message in test-buffer-read (Arvind Pandey) [#23957](https://github.com/nodejs/node/pull/23957)
* [[`ed10a91e83`](https://github.com/nodejs/node/commit/ed10a91e83)] - **test**: add test-benchmark-http2 (Rich Trott) [#23863](https://github.com/nodejs/node/pull/23863)
* [[`22bbece323`](https://github.com/nodejs/node/commit/22bbece323)] - **test**: fix regression when compiled with FIPS (Adam Majer) [#23871](https://github.com/nodejs/node/pull/23871)
* [[`22caa26c69`](https://github.com/nodejs/node/commit/22caa26c69)] - **test**: fix strictEqual() argument order (Loic) [#23829](https://github.com/nodejs/node/pull/23829)
* [[`572ea60378`](https://github.com/nodejs/node/commit/572ea60378)] - **test**: verify `performance.timerify()` works w/ non-Node Contexts (Anna Henningsen) [#23784](https://github.com/nodejs/node/pull/23784)
* [[`0f00ac9c7a`](https://github.com/nodejs/node/commit/0f00ac9c7a)] - **test**: mark test-vm-timeout-\* known issue tests flaky (James M Snell) [#23743](https://github.com/nodejs/node/pull/23743)
* [[`a80452a1ab`](https://github.com/nodejs/node/commit/a80452a1ab)] - **test**: add test-benchmark-napi (Emily Marigold Klassen) [#23585](https://github.com/nodejs/node/pull/23585)
* [[`086ee5e57f`](https://github.com/nodejs/node/commit/086ee5e57f)] - **test**: increase coverage of internal/stream/end-of-stream (Tyler Vann-Campbell) [#23751](https://github.com/nodejs/node/pull/23751)
* [[`ee8fa528e2`](https://github.com/nodejs/node/commit/ee8fa528e2)] - **test**: fix strictEqual() arguments order (Nolan Rigo) [#23800](https://github.com/nodejs/node/pull/23800)
* [[`83ddd3e7d0`](https://github.com/nodejs/node/commit/83ddd3e7d0)] - **test**: fix flaky test (cjihrig) [#23811](https://github.com/nodejs/node/pull/23811)
* [[`1521d8991d`](https://github.com/nodejs/node/commit/1521d8991d)] - **test**: fix invalid modulesLength for DSA keygen (Adam Majer) [#23732](https://github.com/nodejs/node/pull/23732)
* [[`dfecf85ded`](https://github.com/nodejs/node/commit/dfecf85ded)] - **test**: fix test-require-symlink on Windows (Bartosz Sosnowski) [#23691](https://github.com/nodejs/node/pull/23691)
* [[`ddd9ccf1d8`](https://github.com/nodejs/node/commit/ddd9ccf1d8)] - **test**: fix strictEqual() argument order (Romain Lanz) [#23768](https://github.com/nodejs/node/pull/23768)
* [[`a666d3ea24`](https://github.com/nodejs/node/commit/a666d3ea24)] - **test**: fix strictEqual() arguments order (Thomas GENTILHOMME) [#23771](https://github.com/nodejs/node/pull/23771)
* [[`fa1373fc74`](https://github.com/nodejs/node/commit/fa1373fc74)] - **test**: fix assertion arguments order (Elian Gutierrez) [#23787](https://github.com/nodejs/node/pull/23787)
* [[`167e99b9a1`](https://github.com/nodejs/node/commit/167e99b9a1)] - **timers**: fix priority queue removeAt fn (Anatoli Papirovski) [#23870](https://github.com/nodejs/node/pull/23870)
* [[`09f25af16f`](https://github.com/nodejs/node/commit/09f25af16f)] - **tls**: throw if protocol too long (Andre Jodat-Danbrani) [#23606](https://github.com/nodejs/node/pull/23606)
* [[`45a20a8d78`](https://github.com/nodejs/node/commit/45a20a8d78)] - **tools**: update ESLint to 5.8.0 (cjihrig) [#23904](https://github.com/nodejs/node/pull/23904)
* [[`c20eb4f2bd`](https://github.com/nodejs/node/commit/c20eb4f2bd)] - **(SEMVER-MINOR)** **tools, icu**: actually failover if there are multiple URLs (Steven R. Loomis) [#23715](https://github.com/nodejs/node/pull/23715)
* [[`b07cb4810c`](https://github.com/nodejs/node/commit/b07cb4810c)] - **zlib**: do not leak on destroy (Mathias Buus) [#23734](https://github.com/nodejs/node/pull/23734)

<a id="11.0.0"></a>
## 2018-10-23, Version 11.0.0 (Current), @jasnell

### Notable Changes

* Build
  * FreeBSD 10 is no longer supported. [#22617](https://github.com/nodejs/node/pull/22617)
* `child_process`
  * The default value of the `windowsHide` option has been changed to `true`. [#21316](https://github.com/nodejs/node/pull/21316)
* `console`
  * `console.countReset()` will emit a warning if the timer being reset does not exist. [#21649](https://github.com/nodejs/node/pull/21649)
  * `console.time()` will no longer reset a timer if it already exists. [#20442](https://github.com/nodejs/node/pull/20442)
* Dependencies
  * V8 has been updated to 7.0. [#22754](https://github.com/nodejs/node/pull/22754)
* `fs`
  * The `fs.read()` method now requires a callback. [#22146](https://github.com/nodejs/node/pull/22146)
  * The previously deprecated `fs.SyncWriteStream` utility has been removed.[#20735](https://github.com/nodejs/node/pull/20735)
* `http`
  * The `http`, `https`, and `tls` modules now use the WHATWG URL parser by default. [#20270](https://github.com/nodejs/node/pull/20270)
* General
  * Use of `process.binding()` has been deprecated. Userland code using `process.binding()` should re-evaluate that use and begin migrating. If there are no supported API alternatives, please open an issue in the Node.js GitHub repository so that a suitable alternative may be discussed.
  * An experimental implementation of `queueMicrotask()` has been added. [#22951](https://github.com/nodejs/node/pull/22951)
* Internal
  * Windows performance-counter support has been removed. [#22485](https://github.com/nodejs/node/pull/22485)
  * The `--expose-http2` command-line option has been removed. [#20887](https://github.com/nodejs/node/pull/20887)
* Timers
  * Interval timers will be rescheduled even if previous interval threw an error. [#20002](https://github.com/nodejs/node/pull/20002)
  * `nextTick` queue will be run after each immediate and timer. [#22842](https://github.com/nodejs/node/pull/22842)
* `util`
  * The WHATWG `TextEncoder` and `TextDecoder` are now globals. [#22281](https://github.com/nodejs/node/pull/22281)
  * `util.inspect()` output size is limited to 128 MB by default. [#22756](https://github.com/nodejs/node/pull/22756)
  * A runtime warning will be emitted when `NODE_DEBUG` is set for either `http` or `http2`. [#21914](https://github.com/nodejs/node/pull/21914)

### Semver-Major Commits

* [[`0518b9edf3`](https://github.com/nodejs/node/commit/0518b9edf3)] - **(SEMVER-MAJOR)** **assert**: multiple improvements (Ruben Bridgewater) [#21628](https://github.com/nodejs/node/pull/21628)
* [[`21c3a402d4`](https://github.com/nodejs/node/commit/21c3a402d4)] - **(SEMVER-MAJOR)** **assert**: validate input stricter (Ruben Bridgewater) [#20481](https://github.com/nodejs/node/pull/20481)
* [[`439b75b9c0`](https://github.com/nodejs/node/commit/439b75b9c0)] - **(SEMVER-MAJOR)** **assert, util**: \*DeepEqual() handles ArrayBuffers (Caleb Sander) [#22266](https://github.com/nodejs/node/pull/22266)
* [[`5d95542212`](https://github.com/nodejs/node/commit/5d95542212)] - **(SEMVER-MAJOR)** **buffer**: move process.binding('buffer') to internalBinding (Weijia Wang) [#22370](https://github.com/nodejs/node/pull/22370)
* [[`8fb6bce3a0`](https://github.com/nodejs/node/commit/8fb6bce3a0)] - **(SEMVER-MAJOR)** **buffer**: unconditionally use internalBinding (cjihrig) [#23234](https://github.com/nodejs/node/pull/23234)
* [[`755520c4c3`](https://github.com/nodejs/node/commit/755520c4c3)] - **(SEMVER-MAJOR)** **buffer**: show hidden item count (Ruben Bridgewater) [#22289](https://github.com/nodejs/node/pull/22289)
* [[`60b5b38b48`](https://github.com/nodejs/node/commit/60b5b38b48)] - **(SEMVER-MAJOR)** **buffer**: do not always use defaults (Ruben Bridgewater) [#20054](https://github.com/nodejs/node/pull/20054)
* [[`b3b3f53a33`](https://github.com/nodejs/node/commit/b3b3f53a33)] - **(SEMVER-MAJOR)** **build**: exclude npm test directories on Windows (Richard Lau) [#23001](https://github.com/nodejs/node/pull/23001)
* [[`dd296a8344`](https://github.com/nodejs/node/commit/dd296a8344)] - **(SEMVER-MAJOR)** **build**: reset embedder string to "-node.0" (Michaël Zasso) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`4b25ef5341`](https://github.com/nodejs/node/commit/4b25ef5341)] - **(SEMVER-MAJOR)** **build**: reset embedder string to "-node.0" (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`c0fb95d700`](https://github.com/nodejs/node/commit/c0fb95d700)] - **(SEMVER-MAJOR)** **build**: stop supporting FreeBSD 10 (Michaël Zasso) [#22617](https://github.com/nodejs/node/pull/22617)
* [[`4b47d2907d`](https://github.com/nodejs/node/commit/4b47d2907d)] - **(SEMVER-MAJOR)** **build**: do not copy v8-inspector\* headers ar part of install (Alexey Kozyatinskiy) [#22586](https://github.com/nodejs/node/pull/22586)
* [[`2d4dd10829`](https://github.com/nodejs/node/commit/2d4dd10829)] - **(SEMVER-MAJOR)** **build**: add '-z relro -z now' linker flags (Shao,Ting) [#20513](https://github.com/nodejs/node/pull/20513)
* [[`9c9c01f183`](https://github.com/nodejs/node/commit/9c9c01f183)] - **(SEMVER-MAJOR)** **child_process**: move process.binding('spawn\_sync') to internalBinding (Anto Aravinth) [#22260](https://github.com/nodejs/node/pull/22260)
* [[`af883e1f99`](https://github.com/nodejs/node/commit/af883e1f99)] - **(SEMVER-MAJOR)** **child_process**: fix switches for alternative shells on Windows (Tessei Kameyama) [#21943](https://github.com/nodejs/node/pull/21943)
* [[`56cf058878`](https://github.com/nodejs/node/commit/56cf058878)] - **(SEMVER-MAJOR)** **child_process**: make process\_wrap binding internal (cjihrig) [#22479](https://github.com/nodejs/node/pull/22479)
* [[`420d8afe3d`](https://github.com/nodejs/node/commit/420d8afe3d)] - **(SEMVER-MAJOR)** **child_process**: change windowsHide default to true (cjihrig) [#21316](https://github.com/nodejs/node/pull/21316)
* [[`d4164ca559`](https://github.com/nodejs/node/commit/d4164ca559)] - **(SEMVER-MAJOR)** **console**: console.countReset() should emit warning (Dominic Farolino) [#21649](https://github.com/nodejs/node/pull/21649)
* [[`a59826403a`](https://github.com/nodejs/node/commit/a59826403a)] - **(SEMVER-MAJOR)** **console**: console.time() should not reset a timer when it exists (Gus Caplan) [#20442](https://github.com/nodejs/node/pull/20442)
* [[`90e8f79f65`](https://github.com/nodejs/node/commit/90e8f79f65)] - **(SEMVER-MAJOR)** **constants**: freeze the constants object (Bryan English) [#19813](https://github.com/nodejs/node/pull/19813)
* [[`058c5b81cd`](https://github.com/nodejs/node/commit/058c5b81cd)] - **(SEMVER-MAJOR)** **crypto**: do not allow multiple calls to setAuthTag (Tobias Nießen) [#22931](https://github.com/nodejs/node/pull/22931)
* [[`19ad6b8f72`](https://github.com/nodejs/node/commit/19ad6b8f72)] - **(SEMVER-MAJOR)** **crypto**: deprecate digest == null in PBKDF2 (Tobias Nießen) [#22861](https://github.com/nodejs/node/pull/22861)
* [[`0ade10df79`](https://github.com/nodejs/node/commit/0ade10df79)] - **(SEMVER-MAJOR)** **crypto**: hide native handles from JS modules (Tobias Nießen) [#22747](https://github.com/nodejs/node/pull/22747)
* [[`503fd55a35`](https://github.com/nodejs/node/commit/503fd55a35)] - **(SEMVER-MAJOR)** **crypto**: make \_toBuf non-enumerable (Tobias Nießen) [#22551](https://github.com/nodejs/node/pull/22551)
* [[`221df2286d`](https://github.com/nodejs/node/commit/221df2286d)] - **(SEMVER-MAJOR)** **crypto**: deprecate aliases for randomBytes (Tobias Nießen) [#22519](https://github.com/nodejs/node/pull/22519)
* [[`50aa85dc9b`](https://github.com/nodejs/node/commit/50aa85dc9b)] - **(SEMVER-MAJOR)** **crypto**: deprecate \_toBuf (Tobias Nießen) [#22501](https://github.com/nodejs/node/pull/22501)
* [[`eab916c4e8`](https://github.com/nodejs/node/commit/eab916c4e8)] - **(SEMVER-MAJOR)** **crypto**: move process.binding('tls\_wrap') internal (Daniel Bevenius) [#22429](https://github.com/nodejs/node/pull/22429)
* [[`bf5cc3bf1a`](https://github.com/nodejs/node/commit/bf5cc3bf1a)] - **(SEMVER-MAJOR)** **crypto**: move process.binding('crypto') to internal (Daniel Bevenius) [#22426](https://github.com/nodejs/node/pull/22426)
* [[`39dd3a4430`](https://github.com/nodejs/node/commit/39dd3a4430)] - **(SEMVER-MAJOR)** **crypto**: deprecate useless crypto APIs (Tobias Nießen) [#22126](https://github.com/nodejs/node/pull/22126)
* [[`933d8eb689`](https://github.com/nodejs/node/commit/933d8eb689)] - **(SEMVER-MAJOR)** **crypto**: move createCipher to runtime deprecation (Tobias Nießen) [#22089](https://github.com/nodejs/node/pull/22089)
* [[`d2ee7d64aa`](https://github.com/nodejs/node/commit/d2ee7d64aa)] - **(SEMVER-MAJOR)** **crypto**: remove deprecated legacy API (Antoine du HAMEL) [#21153](https://github.com/nodejs/node/pull/21153)
* [[`faf449ca04`](https://github.com/nodejs/node/commit/faf449ca04)] - **(SEMVER-MAJOR)** **crypto**: throw in setAuthTag on invalid length (Tobias Nießen) [#20040](https://github.com/nodejs/node/pull/20040)
* [[`d81a7b4baa`](https://github.com/nodejs/node/commit/d81a7b4baa)] - **(SEMVER-MAJOR)** **crypto**: throw on invalid authentication tag length (Tobias Nießen) [#17825](https://github.com/nodejs/node/pull/17825)
* [[`2f9775995f`](https://github.com/nodejs/node/commit/2f9775995f)] - **(SEMVER-MAJOR)** **crypto**: move Decipher.finaltol to End-of-Life (Tobias Nießen) [#19941](https://github.com/nodejs/node/pull/19941)
* [[`083d1012c7`](https://github.com/nodejs/node/commit/083d1012c7)] - **(SEMVER-MAJOR)** **deps**: cherry-pick b0af309 from upstream V8 (Anna Henningsen) [#23415](https://github.com/nodejs/node/pull/23415)
* [[`dca0300a86`](https://github.com/nodejs/node/commit/dca0300a86)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 2363cdf from upstream V8 (Michaël Zasso) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`1da9d60003`](https://github.com/nodejs/node/commit/1da9d60003)] - **(SEMVER-MAJOR)** **deps**: update v8.gyp (Michaël Zasso) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`0e7ddbd3d7`](https://github.com/nodejs/node/commit/0e7ddbd3d7)] - **(SEMVER-MAJOR)** **deps**: update V8 to 7.0.276.20 (Michaël Zasso) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`a3f258c769`](https://github.com/nodejs/node/commit/a3f258c769)] - **(SEMVER-MAJOR)** **deps**: cherry-pick a8f6869 from upstream V8 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`fc1770b0d1`](https://github.com/nodejs/node/commit/fc1770b0d1)] - **(SEMVER-MAJOR)** **deps**: cherry-pick bf5ea81 from upstream V8 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`7766baf943`](https://github.com/nodejs/node/commit/7766baf943)] - **(SEMVER-MAJOR)** **deps**: cherry-pick ba752ea from upstream V8 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`8dc159658c`](https://github.com/nodejs/node/commit/8dc159658c)] - **(SEMVER-MAJOR)** **deps**: cherry-pick c608122 from upstream V8 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`5bb985d331`](https://github.com/nodejs/node/commit/5bb985d331)] - **(SEMVER-MAJOR)** **deps**: cherry-pick 0dd3390 from upstream V8 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`f04ab3c756`](https://github.com/nodejs/node/commit/f04ab3c756)] - **(SEMVER-MAJOR)** **deps**: update v8.gyp (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`586db2414a`](https://github.com/nodejs/node/commit/586db2414a)] - **(SEMVER-MAJOR)** **deps**: update V8 to 6.9.427.22 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`c8950cdabc`](https://github.com/nodejs/node/commit/c8950cdabc)] - **(SEMVER-MAJOR)** **dgram**: make process.binding('udp\_wrap') internal (cjihrig) [#22475](https://github.com/nodejs/node/pull/22475)
* [[`3ce6bc3b50`](https://github.com/nodejs/node/commit/3ce6bc3b50)] - **(SEMVER-MAJOR)** **dgram**: remove unnecessary fd property from Socket (Ouyang Yadong) [#21684](https://github.com/nodejs/node/pull/21684)
* [[`fe069cca6a`](https://github.com/nodejs/node/commit/fe069cca6a)] - **(SEMVER-MAJOR)** **dgram**: deprecate all previous private APIs (cjihrig) [#22011](https://github.com/nodejs/node/pull/22011)
* [[`2bea9cefbc`](https://github.com/nodejs/node/commit/2bea9cefbc)] - **(SEMVER-MAJOR)** **dgram**: implement socket.bind({ fd }) (Ouyang Yadong) [#21745](https://github.com/nodejs/node/pull/21745)
* [[`8b2e77c248`](https://github.com/nodejs/node/commit/8b2e77c248)] - **(SEMVER-MAJOR)** **dns**: deprecate passing falsy hostname to dns.lookup (Ouyang Yadong) [#23173](https://github.com/nodejs/node/pull/23173)
* [[`8b0c482647`](https://github.com/nodejs/node/commit/8b0c482647)] - **(SEMVER-MAJOR)** **dns**: make process.binding('cares\_wrap') internal (cjihrig) [#22474](https://github.com/nodejs/node/pull/22474)
* [[`4e1c4e8193`](https://github.com/nodejs/node/commit/4e1c4e8193)] - **(SEMVER-MAJOR)** **dns**: type check for dns.setServers argument. (Masashi Hirano) [#21944](https://github.com/nodejs/node/pull/21944)
* [[`a158d412b3`](https://github.com/nodejs/node/commit/a158d412b3)] - **(SEMVER-MAJOR)** **dns**: report out of memory properly (Ruben Bridgewater) [#20317](https://github.com/nodejs/node/pull/20317)
* [[`c267639daa`](https://github.com/nodejs/node/commit/c267639daa)] - **(SEMVER-MAJOR)** **doc**: clarify ciphers option format (Brian White) [#21557](https://github.com/nodejs/node/pull/21557)
* [[`985d180855`](https://github.com/nodejs/node/commit/985d180855)] - **(SEMVER-MAJOR)** **doc**: move support for invalid GCM tags to EOL (Tobias Nießen) [#17825](https://github.com/nodejs/node/pull/17825)
* [[`cf350856cf`](https://github.com/nodejs/node/commit/cf350856cf)] - **(SEMVER-MAJOR)** **doc**: note that setAuthTag throws on invalid length (Tobias Nießen) [#17825](https://github.com/nodejs/node/pull/17825)
* [[`f8d69911be`](https://github.com/nodejs/node/commit/f8d69911be)] - **(SEMVER-MAJOR)** **errors**: use ERR\_OUT\_OF\_RANGE for index errors (Rich Trott) [#22969](https://github.com/nodejs/node/pull/22969)
* [[`186857f15c`](https://github.com/nodejs/node/commit/186857f15c)] - **(SEMVER-MAJOR)** **errors**: remove ERR\_INVALID\_ARRAY\_LENGTH (Ruben Bridgewater) [#20484](https://github.com/nodejs/node/pull/20484)
* [[`6e942e7353`](https://github.com/nodejs/node/commit/6e942e7353)] - **(SEMVER-MAJOR)** **fs**: make fs\_event\_wrap binding internal (cjihrig) [#22480](https://github.com/nodejs/node/pull/22480)
* [[`8e1b6e7718`](https://github.com/nodejs/node/commit/8e1b6e7718)] - **(SEMVER-MAJOR)** **fs**: require callback in read (Ruben Bridgewater) [#22146](https://github.com/nodejs/node/pull/22146)
* [[`42bded83e8`](https://github.com/nodejs/node/commit/42bded83e8)] - **(SEMVER-MAJOR)** **fs**: throw ERR\_INVALID\_ARG\_VALUE when buffer being written is empty (AdityaSrivast) [#21262](https://github.com/nodejs/node/pull/21262)
* [[`7bd48896e9`](https://github.com/nodejs/node/commit/7bd48896e9)] - **(SEMVER-MAJOR)** **fs**: move SyncWriteStream to end-of-life (James M Snell) [#20735](https://github.com/nodejs/node/pull/20735)
* [[`19374fd25b`](https://github.com/nodejs/node/commit/19374fd25b)] - **(SEMVER-MAJOR)** **fs**: improve argument handling for ReadStream (Ujjwal Sharma) [#19898](https://github.com/nodejs/node/pull/19898)
* [[`f22c7c10ca`](https://github.com/nodejs/node/commit/f22c7c10ca)] - **(SEMVER-MAJOR)** **http**: always emit close on req and res (Robert Nagy) [#20611](https://github.com/nodejs/node/pull/20611)
* [[`1744205ff5`](https://github.com/nodejs/node/commit/1744205ff5)] - **(SEMVER-MAJOR)** **http**: move process.binding('http\_parser') to internalBinding (James M Snell) [#22329](https://github.com/nodejs/node/pull/22329)
* [[`4b00c4fafa`](https://github.com/nodejs/node/commit/4b00c4fafa)] - **(SEMVER-MAJOR)** **http**: make client `.aborted` boolean (Robert Nagy) [#20230](https://github.com/nodejs/node/pull/20230)
* [[`564048dc29`](https://github.com/nodejs/node/commit/564048dc29)] - **(SEMVER-MAJOR)** **http,https,tls**: switch to WHATWG URL parser (Hackzzila) [#20270](https://github.com/nodejs/node/pull/20270)
* [[`4fa5448e5d`](https://github.com/nodejs/node/commit/4fa5448e5d)] - **(SEMVER-MAJOR)** **http2**: move process.binding('http2') to internalBinding (James M Snell) [#22328](https://github.com/nodejs/node/pull/22328)
* [[`8f3cfc89fa`](https://github.com/nodejs/node/commit/8f3cfc89fa)] - **(SEMVER-MAJOR)** **icu**: make process.binding('icu') internal (cjihrig) [#23234](https://github.com/nodejs/node/pull/23234)
* [[`de0441f6f6`](https://github.com/nodejs/node/commit/de0441f6f6)] - **(SEMVER-MAJOR)** **lib**: implement queueMicrotask (Gus Caplan) [#22951](https://github.com/nodejs/node/pull/22951)
* [[`dcc0c2c5c9`](https://github.com/nodejs/node/commit/dcc0c2c5c9)] - **(SEMVER-MAJOR)** **lib**: move process.binding('js\_stream') to internalBinding (Anto Aravinth) [#22239](https://github.com/nodejs/node/pull/22239)
* [[`6a689c8aa3`](https://github.com/nodejs/node/commit/6a689c8aa3)] - **(SEMVER-MAJOR)** **lib**: make pipe\_wrap binding internal (cjihrig) [#22482](https://github.com/nodejs/node/pull/22482)
* [[`36468ca928`](https://github.com/nodejs/node/commit/36468ca928)] - **(SEMVER-MAJOR)** **lib**: require a callback for end-of-stream (Ruben Bridgewater) [#21058](https://github.com/nodejs/node/pull/21058)
* [[`6f6f7f749b`](https://github.com/nodejs/node/commit/6f6f7f749b)] - **(SEMVER-MAJOR)** **lib**: add internal PriorityQueue class (Anatoli Papirovski) [#20555](https://github.com/nodejs/node/pull/20555)
* [[`e836128703`](https://github.com/nodejs/node/commit/e836128703)] - **(SEMVER-MAJOR)** **lib**: introduce internal/validators (Michaël Zasso) [#19973](https://github.com/nodejs/node/pull/19973)
* [[`1b92214d09`](https://github.com/nodejs/node/commit/1b92214d09)] - **(SEMVER-MAJOR)** **module**: fix inconsistency between load and \_findPath (Denys Otrishko) [#22382](https://github.com/nodejs/node/pull/22382)
* [[`b36c581d5b`](https://github.com/nodejs/node/commit/b36c581d5b)] - **(SEMVER-MAJOR)** **module**: accept Windows relative path (João Reis) [#22186](https://github.com/nodejs/node/pull/22186)
* [[`4a0466f23a`](https://github.com/nodejs/node/commit/4a0466f23a)] - **(SEMVER-MAJOR)** **net**: throw error if port/path does not exist in options (Yaniv Friedensohn) [#22085](https://github.com/nodejs/node/pull/22085)
* [[`49681e7414`](https://github.com/nodejs/node/commit/49681e7414)] - **(SEMVER-MAJOR)** **process**: refactor emitWarning (Ruben Bridgewater) [#20726](https://github.com/nodejs/node/pull/20726)
* [[`2fd248f639`](https://github.com/nodejs/node/commit/2fd248f639)] - **(SEMVER-MAJOR)** **process**: migrate methods to throw errors with code (Michaël Zasso) [#19973](https://github.com/nodejs/node/pull/19973)
* [[`2bf4697ff4`](https://github.com/nodejs/node/commit/2bf4697ff4)] - **(SEMVER-MAJOR)** **repl**: remove duplicate util binding (cjihrig) [#22675](https://github.com/nodejs/node/pull/22675)
* [[`eeb1d514ad`](https://github.com/nodejs/node/commit/eeb1d514ad)] - **(SEMVER-MAJOR)** **repl**: changes ctrl+u to delete from cursor to line start (Shobhit Chittora) [#20686](https://github.com/nodejs/node/pull/20686)
* [[`5f714ac0bd`](https://github.com/nodejs/node/commit/5f714ac0bd)] - **(SEMVER-MAJOR)** **src**: remove long-deprecated APIs without `Isolate\*` arg (Anna Henningsen) [#23178](https://github.com/nodejs/node/pull/23178)
* [[`24186e0d20`](https://github.com/nodejs/node/commit/24186e0d20)] - **(SEMVER-MAJOR)** **src**: remove public API for option variables (Anna Henningsen) [#23069](https://github.com/nodejs/node/pull/23069)
* [[`0f73875e7b`](https://github.com/nodejs/node/commit/0f73875e7b)] - **(SEMVER-MAJOR)** **src**: update postmortem constants (cjihrig) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`a5604a73d8`](https://github.com/nodejs/node/commit/a5604a73d8)] - **(SEMVER-MAJOR)** **src**: use HeapStatistics to get external memory (Rodrigo Bruno) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`7429d181c5`](https://github.com/nodejs/node/commit/7429d181c5)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 67 (Michaël Zasso) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`9d71e6a607`](https://github.com/nodejs/node/commit/9d71e6a607)] - **(SEMVER-MAJOR)** **src**: deprecate global COUNTER\_\* and remove perfctr (James M Snell) [#22485](https://github.com/nodejs/node/pull/22485)
* [[`dbf72030b7`](https://github.com/nodejs/node/commit/dbf72030b7)] - **(SEMVER-MAJOR)** **src**: update postmortem constant name (cjihrig) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`90ae4bd0c9`](https://github.com/nodejs/node/commit/90ae4bd0c9)] - **(SEMVER-MAJOR)** **src**: add InitializeV8Platform function (Daniel Bevenius) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`d5e7294445`](https://github.com/nodejs/node/commit/d5e7294445)] - **(SEMVER-MAJOR)** **src**: initialize PerIsolateData eagerly (Andreas Haas) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`2e28090855`](https://github.com/nodejs/node/commit/2e28090855)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 66 (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`a8572b191e`](https://github.com/nodejs/node/commit/a8572b191e)] - **(SEMVER-MAJOR)** **src**: use default parameters for CreateIsolateData (Anna Henningsen) [#22465](https://github.com/nodejs/node/pull/22465)
* [[`da8641f3b4`](https://github.com/nodejs/node/commit/da8641f3b4)] - **(SEMVER-MAJOR)** **src**: move process.binding('async\_wrap') internal (Daniel Bevenius) [#22469](https://github.com/nodejs/node/pull/22469)
* [[`57d98bc732`](https://github.com/nodejs/node/commit/57d98bc732)] - **(SEMVER-MAJOR)** **src**: move process.binding('tcp\_wrap') to internal (Daniel Bevenius) [#22432](https://github.com/nodejs/node/pull/22432)
* [[`0bdb95f4cf`](https://github.com/nodejs/node/commit/0bdb95f4cf)] - **(SEMVER-MAJOR)** **src**: move process.binding('signal\_wrap') to internalBinding (James M Snell) [#22290](https://github.com/nodejs/node/pull/22290)
* [[`c7962dcba4`](https://github.com/nodejs/node/commit/c7962dcba4)] - **(SEMVER-MAJOR)** **src**: move process.binding('uv') to internalBinding (James M Snell) [#22163](https://github.com/nodejs/node/pull/22163)
* [[`9f5cc1fc92`](https://github.com/nodejs/node/commit/9f5cc1fc92)] - **(SEMVER-MAJOR)** **src**: move process.binding('performance') to internalBinding (James M Snell) [#22029](https://github.com/nodejs/node/pull/22029)
* [[`f479050916`](https://github.com/nodejs/node/commit/f479050916)] - **(SEMVER-MAJOR)** **src**: rename PROVIDER\_FSREQWRAP to PROVIDER\_FSREQCALLBACK (Jon Moss) [#21971](https://github.com/nodejs/node/pull/21971)
* [[`0f3c2c64d2`](https://github.com/nodejs/node/commit/0f3c2c64d2)] - **(SEMVER-MAJOR)** **src**: use modern v8::Platform worker threads APIs (Gabriel Charette) [#21079](https://github.com/nodejs/node/pull/21079)
* [[`6f9705275b`](https://github.com/nodejs/node/commit/6f9705275b)] - **(SEMVER-MAJOR)** **src**: update NODE\_MODULE\_VERSION to 65 (Michaël Zasso) [#21079](https://github.com/nodejs/node/pull/21079)
* [[`cf37945b12`](https://github.com/nodejs/node/commit/cf37945b12)] - **(SEMVER-MAJOR)** **src**: include cwd in chdir error message (Anna Henningsen) [#21526](https://github.com/nodejs/node/pull/21526)
* [[`bfcf5b01bb`](https://github.com/nodejs/node/commit/bfcf5b01bb)] - **(SEMVER-MAJOR)** **src**: remove tick\_info-\>has\_thrown (Anatoli Papirovski) [#20894](https://github.com/nodejs/node/pull/20894)
* [[`2930bd1317`](https://github.com/nodejs/node/commit/2930bd1317)] - **(SEMVER-MAJOR)** **src**: refactor timers to remove TimerWrap (Anatoli Papirovski) [#20894](https://github.com/nodejs/node/pull/20894)
* [[`3294d1bf62`](https://github.com/nodejs/node/commit/3294d1bf62)] - **(SEMVER-MAJOR)** **src**: remove --expose-http2 option (Daniel Bevenius) [#20887](https://github.com/nodejs/node/pull/20887)
* [[`3152b7c0d3`](https://github.com/nodejs/node/commit/3152b7c0d3)] - **(SEMVER-MAJOR)** **src**: assign ERR\_SCRIPT\_EXECUTION\_\* codes in C++ (Joyee Cheung) [#20147](https://github.com/nodejs/node/pull/20147)
* [[`1d1ab76e17`](https://github.com/nodejs/node/commit/1d1ab76e17)] - **(SEMVER-MAJOR)** **src**: make process.env.TZ setter clear tz cache (Ben Noordhuis) [#20026](https://github.com/nodejs/node/pull/20026)
* [[`627f10937e`](https://github.com/nodejs/node/commit/627f10937e)] - **(SEMVER-MAJOR)** **src,lib**: move `natives` and `constants` to `internalBinding()` (Anna Henningsen) [#23663](https://github.com/nodejs/node/pull/23663)
* [[`172b4d7ceb`](https://github.com/nodejs/node/commit/172b4d7ceb)] - **(SEMVER-MAJOR)** **src,lib**: rename FSReqWrap to FSReqCallback (Jon Moss) [#21971](https://github.com/nodejs/node/pull/21971)
* [[`884b23daf7`](https://github.com/nodejs/node/commit/884b23daf7)] - **(SEMVER-MAJOR)** **stream**: move process.binding('stream\_wrap') to internalBinding (James M Snell) [#22345](https://github.com/nodejs/node/pull/22345)
* [[`32c51f10d3`](https://github.com/nodejs/node/commit/32c51f10d3)] - **(SEMVER-MAJOR)** **stream**: make the pipeline callback mandatory (Ruben Bridgewater) [#21054](https://github.com/nodejs/node/pull/21054)
* [[`06f6ac179c`](https://github.com/nodejs/node/commit/06f6ac179c)] - **(SEMVER-MAJOR)** **string_decoder**: fix number of replacement chars (Anna Henningsen) [#22709](https://github.com/nodejs/node/pull/22709)
* [[`2285177383`](https://github.com/nodejs/node/commit/2285177383)] - **(SEMVER-MAJOR)** **test**: remove test-buffer-bindingobj-no-zerofill.js (Weijia Wang) [#23234](https://github.com/nodejs/node/pull/23234)
* [[`1b274287c9`](https://github.com/nodejs/node/commit/1b274287c9)] - **(SEMVER-MAJOR)** **test**: add string-decoder fuzz test (Anna Henningsen) [#22709](https://github.com/nodejs/node/pull/22709)
* [[`8aca934009`](https://github.com/nodejs/node/commit/8aca934009)] - **(SEMVER-MAJOR)** **test**: update postmortem metadata test for V8 7.0 (cjihrig) [#22754](https://github.com/nodejs/node/pull/22754)
* [[`36cc812d18`](https://github.com/nodejs/node/commit/36cc812d18)] - **(SEMVER-MAJOR)** **test**: update postmortem metadata test for V8 6.9 (cjihrig) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`f7d572fa2b`](https://github.com/nodejs/node/commit/f7d572fa2b)] - **(SEMVER-MAJOR)** **test**: add new\_large\_object\_space heap space (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`e865acd4db`](https://github.com/nodejs/node/commit/e865acd4db)] - **(SEMVER-MAJOR)** **test**: update postmortem metadata test (Matheus Marchini) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`19984ad7bb`](https://github.com/nodejs/node/commit/19984ad7bb)] - **(SEMVER-MAJOR)** **test**: fix inspector tests after V8 upgrade (Alexey Kozyatinskiy) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`34f56e2d71`](https://github.com/nodejs/node/commit/34f56e2d71)] - **(SEMVER-MAJOR)** **test**: fix crypto test case (Tobias Nießen) [#22126](https://github.com/nodejs/node/pull/22126)
* [[`0deb27bd29`](https://github.com/nodejs/node/commit/0deb27bd29)] - **(SEMVER-MAJOR)** **test**: add dns memory error test (Rich Trott) [#20317](https://github.com/nodejs/node/pull/20317)
* [[`52428c81cd`](https://github.com/nodejs/node/commit/52428c81cd)] - **(SEMVER-MAJOR)** **timers**: run nextTicks after each immediate and timer (Anatoli Papirovski) [#22842](https://github.com/nodejs/node/pull/22842)
* [[`23a56e0c28`](https://github.com/nodejs/node/commit/23a56e0c28)] - **(SEMVER-MAJOR)** **timers**: use only a single TimerWrap instance (Anatoli Papirovski) [#20555](https://github.com/nodejs/node/pull/20555)
* [[`198eb9c5d6`](https://github.com/nodejs/node/commit/198eb9c5d6)] - **(SEMVER-MAJOR)** **timers**: reschedule interval even if it threw (Anatoli Papirovski) [#20002](https://github.com/nodejs/node/pull/20002)
* [[`3c2aa4b9f3`](https://github.com/nodejs/node/commit/3c2aa4b9f3)] - **(SEMVER-MAJOR)** **tls**: de-duplicate for TLSSocket methods (Jon Moss) [#22142](https://github.com/nodejs/node/pull/22142)
* [[`fa3d6bedf9`](https://github.com/nodejs/node/commit/fa3d6bedf9)] - **(SEMVER-MAJOR)** **tls**: use internal API instead of crypto module (Tobias Nießen) [#22501](https://github.com/nodejs/node/pull/22501)
* [[`3095eecc47`](https://github.com/nodejs/node/commit/3095eecc47)] - **(SEMVER-MAJOR)** **tls**: warn on NODE\_TLS\_REJECT\_UNAUTHORIZED = '0' (cjihrig) [#21900](https://github.com/nodejs/node/pull/21900)
* [[`a15ea5d7ca`](https://github.com/nodejs/node/commit/a15ea5d7ca)] - **(SEMVER-MAJOR)** **tls**: throw error on bad ciphers option (Brian White) [#21557](https://github.com/nodejs/node/pull/21557)
* [[`eadcee1137`](https://github.com/nodejs/node/commit/eadcee1137)] - **(SEMVER-MAJOR)** **tls**: throw if SNICallback is not a function (Rich Trott) [#20969](https://github.com/nodejs/node/pull/20969)
* [[`4d00cd4ce7`](https://github.com/nodejs/node/commit/4d00cd4ce7)] - **(SEMVER-MAJOR)** **tls**: move convertNPNProtocols to End-of-Life (James M Snell) [#20736](https://github.com/nodejs/node/pull/20736)
* [[`e6cdf24bb5`](https://github.com/nodejs/node/commit/e6cdf24bb5)] - **(SEMVER-MAJOR)** **tools**: remove lldbinit file from install script (Clemens Hammacher) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`267b0b5f3d`](https://github.com/nodejs/node/commit/267b0b5f3d)] - **(SEMVER-MAJOR)** **tools**: fix compilation after V8 upgrade (Michaël Zasso) [#21983](https://github.com/nodejs/node/pull/21983)
* [[`c1e2d6b0f1`](https://github.com/nodejs/node/commit/c1e2d6b0f1)] - **(SEMVER-MAJOR)** **trace_events**: move trace\_events to internalBinding (James M Snell) [#22159](https://github.com/nodejs/node/pull/22159)
* [[`df073cdda4`](https://github.com/nodejs/node/commit/df073cdda4)] - **(SEMVER-MAJOR)** **tty**: make process.binding('tty\_wrap') internal (cjihrig) [#22477](https://github.com/nodejs/node/pull/22477)
* [[`91eec00ca2`](https://github.com/nodejs/node/commit/91eec00ca2)] - **(SEMVER-MAJOR)** **tty**: make \_read throw ERR\_TTY\_WRITABLE\_NOT\_READABLE (Matteo Collina) [#21654](https://github.com/nodejs/node/pull/21654)
* [[`922a1b03b6`](https://github.com/nodejs/node/commit/922a1b03b6)] - **(SEMVER-MAJOR)** **url**: docs deprecate legacy url API (James M Snell) [#22715](https://github.com/nodejs/node/pull/22715)
* [[`e917a23d2e`](https://github.com/nodejs/node/commit/e917a23d2e)] - **(SEMVER-MAJOR)** **url**: move process.binding('url') to internalBinding (Weijia Wang) [#22204](https://github.com/nodejs/node/pull/22204)
* [[`1a1fe53e3d`](https://github.com/nodejs/node/commit/1a1fe53e3d)] - **(SEMVER-MAJOR)** **util**: change %o depth default (Ruben Bridgewater) [#22846](https://github.com/nodejs/node/pull/22846)
* [[`ac7450a09a`](https://github.com/nodejs/node/commit/ac7450a09a)] - **(SEMVER-MAJOR)** **util**: change util.inspect depth default (Ruben Bridgewater) [#22846](https://github.com/nodejs/node/pull/22846)
* [[`5e6940d4f6`](https://github.com/nodejs/node/commit/5e6940d4f6)] - **(SEMVER-MAJOR)** **util**: set `super\_` property to non-enumerable (Ruben Bridgewater) [#23107](https://github.com/nodejs/node/pull/23107)
* [[`932be0164f`](https://github.com/nodejs/node/commit/932be0164f)] - **(SEMVER-MAJOR)** **util**: make TextEncoder/TextDecoder global (James M Snell) [#22281](https://github.com/nodejs/node/pull/22281)
* [[`eb61127c48`](https://github.com/nodejs/node/commit/eb61127c48)] - **(SEMVER-MAJOR)** **util**: limit inspection output size to 128 MB (Ruben Bridgewater) [#22756](https://github.com/nodejs/node/pull/22756)
* [[`7e4b0a4850`](https://github.com/nodejs/node/commit/7e4b0a4850)] - **(SEMVER-MAJOR)** **util**: make util binding internal (cjihrig) [#22675](https://github.com/nodejs/node/pull/22675)
* [[`980877ffa2`](https://github.com/nodejs/node/commit/980877ffa2)] - **(SEMVER-MAJOR)** **util**: adding warnings when NODE\_DEBUG is set as http/http2 (Anto Aravinth) [#21914](https://github.com/nodejs/node/pull/21914)
* [[`b3e93a91eb`](https://github.com/nodejs/node/commit/b3e93a91eb)] - **(SEMVER-MAJOR)** **util**: do not escape single quotes if not necessary (Ruben Bridgewater) [#21624](https://github.com/nodejs/node/pull/21624)
* [[`80496a5570`](https://github.com/nodejs/node/commit/80496a5570)] - **(SEMVER-MAJOR)** **util**: add inspect suffix to BigInt64Array elements (Teddy Katz) [#21499](https://github.com/nodejs/node/pull/21499)
* [[`e270ae9f01`](https://github.com/nodejs/node/commit/e270ae9f01)] - **(SEMVER-MAJOR)** **util**: change items unknown style (Ruben Bridgewater) [#20792](https://github.com/nodejs/node/pull/20792)
* [[`27df81cd18`](https://github.com/nodejs/node/commit/27df81cd18)] - **(SEMVER-MAJOR)** **util**: remove custom inspection function (Ruben Bridgewater) [#20722](https://github.com/nodejs/node/pull/20722)
* [[`892932f9bd`](https://github.com/nodejs/node/commit/892932f9bd)] - **(SEMVER-MAJOR)** **v8**: move process.binding('v8') to internalBinding (James M Snell) [#22288](https://github.com/nodejs/node/pull/22288)
* [[`cf3bb593de`](https://github.com/nodejs/node/commit/cf3bb593de)] - **(SEMVER-MAJOR)** **v8**: move serdes to internalBinding (Gus Caplan) [#22161](https://github.com/nodejs/node/pull/22161)
* [[`4963a04b30`](https://github.com/nodejs/node/commit/4963a04b30)] - **(SEMVER-MAJOR)** **vm**: move process.binding('contextify') to internalBinding (James M Snell) [#22419](https://github.com/nodejs/node/pull/22419)
* [[`07682eb0c4`](https://github.com/nodejs/node/commit/07682eb0c4)] - **(SEMVER-MAJOR)** **zlib**: move `bytesRead` accessors to runtime deprecation (Anna Henningsen) [#23308](https://github.com/nodejs/node/pull/23308)
* [[`4f48ddb72f`](https://github.com/nodejs/node/commit/4f48ddb72f)] - **(SEMVER-MAJOR)** **zlib**: move process.binding('zlib') to internalBinding (Anna Henningsen) [#23307](https://github.com/nodejs/node/pull/23307)

### Semver-Minor Commits

* [[`b61d31a845`](https://github.com/nodejs/node/commit/b61d31a845)] - **(SEMVER-MINOR)** **src**: add deprecation warning to errname() (Dolapo Toki) [#23597](https://github.com/nodejs/node/pull/23597)
* [[`39fcda0ca4`](https://github.com/nodejs/node/commit/39fcda0ca4)] - **(SEMVER-MINOR)** **src,test**: add public wrapper for Environment::GetCurrent (Shelley Vohr) [#23676](https://github.com/nodejs/node/pull/23676)
* [[`48a2568f41`](https://github.com/nodejs/node/commit/48a2568f41)] - **(SEMVER-MINOR)** **timers**: add hasRef method to Timeout & Immediate (Anatoli Papirovski) [#20898](https://github.com/nodejs/node/pull/20898)
* [[`bed4a8c6e0`](https://github.com/nodejs/node/commit/bed4a8c6e0)] - **(SEMVER-MINOR)** **tls**: support changing credentials dynamically (cjihrig) [#23644](https://github.com/nodejs/node/pull/23644)


### Semver-Patch Commits

* [[`eccc65919a`](https://github.com/nodejs/node/commit/eccc65919a)] - **assert**: add comments for diff algorithm (Ruben Bridgewater) [#23048](https://github.com/nodejs/node/pull/23048)
* [[`02c44a4894`](https://github.com/nodejs/node/commit/02c44a4894)] - **assert**: reduce diff noise (Ruben Bridgewater) [#23048](https://github.com/nodejs/node/pull/23048)
* [[`b8a8eedf32`](https://github.com/nodejs/node/commit/b8a8eedf32)] - **assert**: switch `inputs` to `values` (Ruben Bridgewater) [#23056](https://github.com/nodejs/node/pull/23056)
* [[`be26c76114`](https://github.com/nodejs/node/commit/be26c76114)] - **assert**: improve the strict equal messages (Ruben Bridgewater) [#23056](https://github.com/nodejs/node/pull/23056)
* [[`1d859ef532`](https://github.com/nodejs/node/commit/1d859ef532)] - **assert**: improve loose assertion message (Ruben Bridgewater) [#22155](https://github.com/nodejs/node/pull/22155)
* [[`0339d3dc36`](https://github.com/nodejs/node/commit/0339d3dc36)] - **async_hooks**: add missing async\_hooks destroys in AsyncReset (Bastian Krol) [#23272](https://github.com/nodejs/node/pull/23272)
* [[`996b3c5bb1`](https://github.com/nodejs/node/commit/996b3c5bb1)] - **benchmark**: coerce PORT to number (Ali Ijaz Sheikh) [#23721](https://github.com/nodejs/node/pull/23721)
* [[`cdca587b3d`](https://github.com/nodejs/node/commit/cdca587b3d)] - **benchmark**: added a test benchmark for worker (Muzafar Umarov) [#23475](https://github.com/nodejs/node/pull/23475)
* [[`2ca7aebefc`](https://github.com/nodejs/node/commit/2ca7aebefc)] - **benchmark**: add common.binding() (cjihrig) [#23460](https://github.com/nodejs/node/pull/23460)
* [[`0d548924b0`](https://github.com/nodejs/node/commit/0d548924b0)] - **bootstrapper**: move internalBinding to NativeModule (Gus Caplan) [#23025](https://github.com/nodejs/node/pull/23025)
* [[`1bd44d7f75`](https://github.com/nodejs/node/commit/1bd44d7f75)] - **build**: fix coverage generation (Michael Dawson) [#23769](https://github.com/nodejs/node/pull/23769)
* [[`6c7d8b4e12`](https://github.com/nodejs/node/commit/6c7d8b4e12)] - **build**: spawn `make test-ci` with `-j1` (Refael Ackermann) [#23733](https://github.com/nodejs/node/pull/23733)
* [[`d548e63123`](https://github.com/nodejs/node/commit/d548e63123)] - **build**: fix `./configure --enable-d8` (Ben Noordhuis) [#23656](https://github.com/nodejs/node/pull/23656)
* [[`c9fd435d28`](https://github.com/nodejs/node/commit/c9fd435d28)] - **build**: add .DS\_store to .gitgnore (Marcos Frony) [#23554](https://github.com/nodejs/node/pull/23554)
* [[`a6124892ff`](https://github.com/nodejs/node/commit/a6124892ff)] - **console**: add trace-events for time and count (James M Snell) [#23703](https://github.com/nodejs/node/pull/23703)
* [[`a144d64e68`](https://github.com/nodejs/node/commit/a144d64e68)] - **crypto**: migrate to getOptions() (nick-ng) [#23562](https://github.com/nodejs/node/pull/23562)
* [[`f4d1d9cb31`](https://github.com/nodejs/node/commit/f4d1d9cb31)] - **crypto**: remove DiffieHellman.initialised\_ (Tobias Nießen) [#23717](https://github.com/nodejs/node/pull/23717)
* [[`1ad660b72d`](https://github.com/nodejs/node/commit/1ad660b72d)] - **crypto**: reduce memory usage of SignFinal (Tobias Nießen) [#23427](https://github.com/nodejs/node/pull/23427)
* [[`1336830069`](https://github.com/nodejs/node/commit/1336830069)] - **crypto**: DRY Diffie-Hellman initialization code (Ben Noordhuis) [#23657](https://github.com/nodejs/node/pull/23657)
* [[`6975639651`](https://github.com/nodejs/node/commit/6975639651)] - **crypto**: simplify internal state handling (Tobias Nießen) [#23648](https://github.com/nodejs/node/pull/23648)
* [[`b2b48083a6`](https://github.com/nodejs/node/commit/b2b48083a6)] - **crypto**: simplify error handling in ECDH::New (Tobias Nießen) [#23647](https://github.com/nodejs/node/pull/23647)
* [[`ed0070e318`](https://github.com/nodejs/node/commit/ed0070e318)] - **crypto**: move field initialization to class (Diana Holland) [#23610](https://github.com/nodejs/node/pull/23610)
* [[`cb569a37e9`](https://github.com/nodejs/node/commit/cb569a37e9)] - **crypto**: fix length argument to snprintf() (Ben Noordhuis) [#23622](https://github.com/nodejs/node/pull/23622)
* [[`709b3b1e1c`](https://github.com/nodejs/node/commit/709b3b1e1c)] - **crypto**: downgrade DEP0115 to `--pending-deprecation` only (Anna Henningsen) [#23017](https://github.com/nodejs/node/pull/23017)
* [[`360465dfe2`](https://github.com/nodejs/node/commit/360465dfe2)] - **crypto**: assign missing deprecation code (Tobias Nießen) [#22827](https://github.com/nodejs/node/pull/22827)
* [[`c4e74ec1cd`](https://github.com/nodejs/node/commit/c4e74ec1cd)] - **deps**: add missing ares\_android.h file (cjihrig) [#23682](https://github.com/nodejs/node/pull/23682)
* [[`e2258adff7`](https://github.com/nodejs/node/commit/e2258adff7)] - **deps**: patch V8 to 7.0.276.28 (Michaël Zasso) [#23424](https://github.com/nodejs/node/pull/23424)
* [[`8165657d9e`](https://github.com/nodejs/node/commit/8165657d9e)] - **deps**: patch V8 to 7.0.276.25 (Michaël Zasso) [#23290](https://github.com/nodejs/node/pull/23290)
* [[`a67650f4be`](https://github.com/nodejs/node/commit/a67650f4be)] - **deps**: V8: cherry-pick 64-bit hash seed commits (Yang Guo) [#23264](https://github.com/nodejs/node/pull/23264)
* [[`4fcfa9d1dc`](https://github.com/nodejs/node/commit/4fcfa9d1dc)] - **deps**: provide more V8 backwards compatibility (Anna Henningsen) [#23158](https://github.com/nodejs/node/pull/23158)
* [[`ef85f08a5e`](https://github.com/nodejs/node/commit/ef85f08a5e)] - **deps**: revert 9136dd8088a9 from upstream V8 (Anna Henningsen) [#23158](https://github.com/nodejs/node/pull/23158)
* [[`d25646b4c5`](https://github.com/nodejs/node/commit/d25646b4c5)] - **deps**: patch V8 to 7.0.276.24 (Michaël Zasso) [#23158](https://github.com/nodejs/node/pull/23158)
* [[`6117af3490`](https://github.com/nodejs/node/commit/6117af3490)] - **deps**: patch V8 to 7.0.276.22 (Michaël Zasso) [#23160](https://github.com/nodejs/node/pull/23160)
* [[`2811ae4801`](https://github.com/nodejs/node/commit/2811ae4801)] - **deps**: patch V8 to 6.9.427.23 (Michaël Zasso) [#22898](https://github.com/nodejs/node/pull/22898)
* [[`56d7411be3`](https://github.com/nodejs/node/commit/56d7411be3)] - **deps**: cherry-pick e1a7699 from upstream V8 (Camillo Bruni) [#22390](https://github.com/nodejs/node/pull/22390)
* [[`349612b233`](https://github.com/nodejs/node/commit/349612b233)] - **deps**: cherry-pick e1a7699 from upstream V8 (Camillo Bruni) [#22390](https://github.com/nodejs/node/pull/22390)
* [[`2f9dabd0d8`](https://github.com/nodejs/node/commit/2f9dabd0d8)] - **deps**: cherry-pick 9eb96bb from upstream V8 (Timothy Gu) [#22390](https://github.com/nodejs/node/pull/22390)
* [[`54c87f37f4`](https://github.com/nodejs/node/commit/54c87f37f4)] - **deps**: cherry-pick 6ee8345 from upstream V8 (Joyee Cheung) [#22106](https://github.com/nodejs/node/pull/22106)
* [[`e2ea82b9ce`](https://github.com/nodejs/node/commit/e2ea82b9ce)] - **dgram**: fix linting issue (Jon Moss) [#22175](https://github.com/nodejs/node/pull/22175)
* [[`dd756248db`](https://github.com/nodejs/node/commit/dd756248db)] - **dns**: fix inconsistent (hostname vs host) (Ulises Gascón) [#23572](https://github.com/nodejs/node/pull/23572)
* [[`d6b3f6513b`](https://github.com/nodejs/node/commit/d6b3f6513b)] - **doc**: add missing YAML labels (Vse Mozhet Byt) [#23810](https://github.com/nodejs/node/pull/23810)
* [[`3f292bf783`](https://github.com/nodejs/node/commit/3f292bf783)] - **doc**: remove reference to sslv3 in tls.md (James M Snell) [#23745](https://github.com/nodejs/node/pull/23745)
* [[`e8d293ecdc`](https://github.com/nodejs/node/commit/e8d293ecdc)] - **doc**: revise security-reporting example text (Rich Trott) [#23759](https://github.com/nodejs/node/pull/23759)
* [[`eaff120bfd`](https://github.com/nodejs/node/commit/eaff120bfd)] - **doc**: formalize non-const reference usage in C++ style guide (Anna Henningsen) [#23155](https://github.com/nodejs/node/pull/23155)
* [[`512faa8ec6`](https://github.com/nodejs/node/commit/512faa8ec6)] - **doc**: fix index in table of contents in BUILDING.md (ZYSzys) [#23777](https://github.com/nodejs/node/pull/23777)
* [[`50c99d87b0`](https://github.com/nodejs/node/commit/50c99d87b0)] - **doc**: add missing deprecation labels (James M Snell) [#23761](https://github.com/nodejs/node/pull/23761)
* [[`889a49f79c`](https://github.com/nodejs/node/commit/889a49f79c)] - **doc**: document use of buffer.swap16() for utf16be (James M Snell) [#23747](https://github.com/nodejs/node/pull/23747)
* [[`4c7f16def0`](https://github.com/nodejs/node/commit/4c7f16def0)] - **doc**: add Backport-PR-URL info in backport guide (Ali Ijaz Sheikh) [#23701](https://github.com/nodejs/node/pull/23701)
* [[`a5b1e7b6c4`](https://github.com/nodejs/node/commit/a5b1e7b6c4)] - **doc**: improve README.md (Rich Trott) [#23705](https://github.com/nodejs/node/pull/23705)
* [[`27892345b9`](https://github.com/nodejs/node/commit/27892345b9)] - **doc**: simplify security reporting text (Rich Trott) [#23686](https://github.com/nodejs/node/pull/23686)
* [[`9c5ec790a0`](https://github.com/nodejs/node/commit/9c5ec790a0)] - **doc**: cleanup and references in C++ guide (Refael Ackermann) [#23650](https://github.com/nodejs/node/pull/23650)
* [[`9430ac2f0c`](https://github.com/nodejs/node/commit/9430ac2f0c)] - **doc**: add info how to run single tests to BUILDING.md (Felix Schlenkrich) [#23490](https://github.com/nodejs/node/pull/23490)
* [[`3ad2267cd0`](https://github.com/nodejs/node/commit/3ad2267cd0)] - **doc**: add "tick" function name and argument description (Artur Hayrapetyan) [#23551](https://github.com/nodejs/node/pull/23551)
* [[`f14a8e5870`](https://github.com/nodejs/node/commit/f14a8e5870)] - **doc**: fix url example to match behavior (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* [[`ba11ad3322`](https://github.com/nodejs/node/commit/ba11ad3322)] - **doc**: use reserved domains for examples in url.md (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* [[`e6c310d29f`](https://github.com/nodejs/node/commit/e6c310d29f)] - **doc**: fix pr-url in repl.md (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* [[`4f38d45f1c`](https://github.com/nodejs/node/commit/4f38d45f1c)] - **doc**: wrap links in \<\> (Сковорода Никита Андреевич) [#23359](https://github.com/nodejs/node/pull/23359)
* [[`d911bab8c3`](https://github.com/nodejs/node/commit/d911bab8c3)] - **doc**: edit BUILDING.md (Rich Trott) [#23435](https://github.com/nodejs/node/pull/23435)
* [[`7d07e161d5`](https://github.com/nodejs/node/commit/7d07e161d5)] - **doc**: describe SNI host name format (Sam Roberts) [#23357](https://github.com/nodejs/node/pull/23357)
* [[`9d6a1d661b`](https://github.com/nodejs/node/commit/9d6a1d661b)] - **doc**: revise security-reporting text in README (Rich Trott) [#23407](https://github.com/nodejs/node/pull/23407)
* [[`2303e4c63c`](https://github.com/nodejs/node/commit/2303e4c63c)] - **doc**: rewrite consensus seeking in guide (Rich Trott) [#23349](https://github.com/nodejs/node/pull/23349)
* [[`db8b5247fd`](https://github.com/nodejs/node/commit/db8b5247fd)] - **doc**: edit for minor fixes to prcoess.md (Rich Trott) [#23347](https://github.com/nodejs/node/pull/23347)
* [[`927878e4a0`](https://github.com/nodejs/node/commit/927878e4a0)] - **doc**: remove personal pronoun from worker\_threads (Rich Trott) [#23347](https://github.com/nodejs/node/pull/23347)
* [[`bc45605775`](https://github.com/nodejs/node/commit/bc45605775)] - **doc**: remove personal pronoun from domain.md (Rich Trott) [#23347](https://github.com/nodejs/node/pull/23347)
* [[`f41d42ffb5`](https://github.com/nodejs/node/commit/f41d42ffb5)] - **doc**: remove style instruction that is not followed (Rich Trott) [#23346](https://github.com/nodejs/node/pull/23346)
* [[`992c1d56de`](https://github.com/nodejs/node/commit/992c1d56de)] - **doc**: add WebAssembly to globals (Steven) [#23339](https://github.com/nodejs/node/pull/23339)
* [[`5ed4b8974a`](https://github.com/nodejs/node/commit/5ed4b8974a)] - **doc**: fix confusing language about microtask queue (Gus Caplan) [#23197](https://github.com/nodejs/node/pull/23197)
* [[`67ba8ff31a`](https://github.com/nodejs/node/commit/67ba8ff31a)] - **doc**: fix type of DEP0116 (Tobias Nießen) [#22765](https://github.com/nodejs/node/pull/22765)
* [[`193d6d1bda`](https://github.com/nodejs/node/commit/193d6d1bda)] - **doc**: update notes about GCM decryption (Tobias Nießen) [#21445](https://github.com/nodejs/node/pull/21445)
* [[`baca6d337f`](https://github.com/nodejs/node/commit/baca6d337f)] - **doc**: add a missing anchor to error codes (Сковорода Никита Андреевич) [#21483](https://github.com/nodejs/node/pull/21483)
* [[`72258c3cbc`](https://github.com/nodejs/node/commit/72258c3cbc)] - **doc,meta**: assign PR semantics (Refael Ackermann) [#23292](https://github.com/nodejs/node/pull/23292)
* [[`d08544f99c`](https://github.com/nodejs/node/commit/d08544f99c)] - **doc,meta**: refresh wording in colab guide (Refael Ackermann) [#23292](https://github.com/nodejs/node/pull/23292)
* [[`cabf144db9`](https://github.com/nodejs/node/commit/cabf144db9)] - **doc,meta**: add references to outside C++ guides (Refael Ackermann) [#23317](https://github.com/nodejs/node/pull/23317)
* [[`37e40e369d`](https://github.com/nodejs/node/commit/37e40e369d)] - **http**: reduce duplicated code for cleaning parser (Weijia Wang) [#23351](https://github.com/nodejs/node/pull/23351)
* [[`70ba041735`](https://github.com/nodejs/node/commit/70ba041735)] - **http2**: make Http2Settings constructors delegate (Daniel Bevenius) [#23326](https://github.com/nodejs/node/pull/23326)
* [[`f40399a0c4`](https://github.com/nodejs/node/commit/f40399a0c4)] - **lib**: migrate process.binding to internalBinding (surreal8) [#23517](https://github.com/nodejs/node/pull/23517)
* [[`ff5f1fb0cd`](https://github.com/nodejs/node/commit/ff5f1fb0cd)] - **lib**: migrate process.binding to getOptions (Randy Wressell) [#23522](https://github.com/nodejs/node/pull/23522)
* [[`66d4ac1af5`](https://github.com/nodejs/node/commit/66d4ac1af5)] - **lib**: migrate process.binding('config') to getOptions() (Jonny Kalambay) [#23526](https://github.com/nodejs/node/pull/23526)
* [[`c1ec3bf989`](https://github.com/nodejs/node/commit/c1ec3bf989)] - **lib**: removed unused variable (Long Nguyen) [#23497](https://github.com/nodejs/node/pull/23497)
* [[`540c01af28`](https://github.com/nodejs/node/commit/540c01af28)] - **lib**: switch to internalBinding for cjs loader (Steven Scott) [#23492](https://github.com/nodejs/node/pull/23492)
* [[`313b44b0ee`](https://github.com/nodejs/node/commit/313b44b0ee)] - **lib**: remove an unused variable (Claire Liu) [#23482](https://github.com/nodejs/node/pull/23482)
* [[`1143ea8f1b`](https://github.com/nodejs/node/commit/1143ea8f1b)] - **lib**: migrate from process.binding to internalBinding (Andres Monge) [#23586](https://github.com/nodejs/node/pull/23586)
* [[`4291c43aff`](https://github.com/nodejs/node/commit/4291c43aff)] - **lib**: remove unused 'e' from catch (Matt Holmes) [#23458](https://github.com/nodejs/node/pull/23458)
* [[`278775a84b`](https://github.com/nodejs/node/commit/278775a84b)] - **lib**: migrate to getOptions in loaders.js (David Xue) [#23455](https://github.com/nodejs/node/pull/23455)
* [[`3663fc8725`](https://github.com/nodejs/node/commit/3663fc8725)] - **lib**: http server, friendly error messages (Sagi Tsofan) [#22995](https://github.com/nodejs/node/pull/22995)
* [[`ea8000f119`](https://github.com/nodejs/node/commit/ea8000f119)] - **lib**: lazy load internal/queue\_microtask (Gus Caplan) [#23046](https://github.com/nodejs/node/pull/23046)
* [[`bb26d4f2f8`](https://github.com/nodejs/node/commit/bb26d4f2f8)] - **meta**: clarify fast-track approval (James M Snell) [#23744](https://github.com/nodejs/node/pull/23744)
* [[`df8e586964`](https://github.com/nodejs/node/commit/df8e586964)] - **module**: removed unused variable (Martin Omander) [#23624](https://github.com/nodejs/node/pull/23624)
* [[`15b12411e9`](https://github.com/nodejs/node/commit/15b12411e9)] - ***Revert*** "**module**: fix inconsistency between load and \_findPath" (John-David Dalton) [#23228](https://github.com/nodejs/node/pull/23228)
* [[`0257fd7ce9`](https://github.com/nodejs/node/commit/0257fd7ce9)] - **process**: wrap process.binding for selective fallthrough (James M Snell) [#22269](https://github.com/nodejs/node/pull/22269)
* [[`3c329bee05`](https://github.com/nodejs/node/commit/3c329bee05)] - **readline**: assert without the use of event listener (Lian Li) [#23472](https://github.com/nodejs/node/pull/23472)
* [[`6855b619c9`](https://github.com/nodejs/node/commit/6855b619c9)] - **repl**: remove unused variable from try catch (mmisiarek) [#23452](https://github.com/nodejs/node/pull/23452)
* [[`4ed1fba740`](https://github.com/nodejs/node/commit/4ed1fba740)] - **repl**: remove unused variable e from try catch (Khalid Adil) [#23449](https://github.com/nodejs/node/pull/23449)
* [[`83d0404971`](https://github.com/nodejs/node/commit/83d0404971)] - **repl**: do not swallow errors in nested REPLs (Rich Trott) [#23004](https://github.com/nodejs/node/pull/23004)
* [[`f0e5afc968`](https://github.com/nodejs/node/commit/f0e5afc968)] - **src**: fix missing deprecation assignment (James M Snell) [#23809](https://github.com/nodejs/node/pull/23809)
* [[`b8cb60fcb9`](https://github.com/nodejs/node/commit/b8cb60fcb9)] - **src**: use more explicit return type in Sign::SignFinal() (Anna Henningsen) [#23779](https://github.com/nodejs/node/pull/23779)
* [[`6c8a96fefa`](https://github.com/nodejs/node/commit/6c8a96fefa)] - **src**: initial large page (2M) support (Suresh Srinivas) [#22079](https://github.com/nodejs/node/pull/22079)
* [[`74ddae783d`](https://github.com/nodejs/node/commit/74ddae783d)] - **src**: add trace events for env.cc (James M Snell) [#23674](https://github.com/nodejs/node/pull/23674)
* [[`59feb5378b`](https://github.com/nodejs/node/commit/59feb5378b)] - **src**: changed stdio\_pipes\_ to std::vector (Steven Auger) [#23615](https://github.com/nodejs/node/pull/23615)
* [[`e4fdedd3f1`](https://github.com/nodejs/node/commit/e4fdedd3f1)] - **src**: update v8::Object::GetPropertyNames() usage (cjihrig) [#23660](https://github.com/nodejs/node/pull/23660)
* [[`da52c3fc9b`](https://github.com/nodejs/node/commit/da52c3fc9b)] - **src**: remove OCB support ifdef OPENSSL\_NO\_OCB (Shelley Vohr) [#23635](https://github.com/nodejs/node/pull/23635)
* [[`2f6b73745c`](https://github.com/nodejs/node/commit/2f6b73745c)] - **src**: remove function hasTextDecoder in encoding.js (Chi-chi Wang) [#23625](https://github.com/nodejs/node/pull/23625)
* [[`fd7fc99e90`](https://github.com/nodejs/node/commit/fd7fc99e90)] - **src**: change macro to fn (Gino Notto) [#23603](https://github.com/nodejs/node/pull/23603)
* [[`e84a7f027d`](https://github.com/nodejs/node/commit/e84a7f027d)] - **src**: add default initializer in tls\_wrap (Richard Hoehn) [#23567](https://github.com/nodejs/node/pull/23567)
* [[`33351a112d`](https://github.com/nodejs/node/commit/33351a112d)] - **src**: use MallocedBuffer abstraction for buffers (Cody Hazelwood) [#23543](https://github.com/nodejs/node/pull/23543)
* [[`866d81cf39`](https://github.com/nodejs/node/commit/866d81cf39)] - **src**: use default initializers over settings fields on the constructor (Andrew J D McCann) [#23532](https://github.com/nodejs/node/pull/23532)
* [[`26fa85c65e`](https://github.com/nodejs/node/commit/26fa85c65e)] - **src**: remove unused UVHandle methods (MarianneDr) [#23535](https://github.com/nodejs/node/pull/23535)
* [[`35d9990140`](https://github.com/nodejs/node/commit/35d9990140)] - **src**: move default assignment of async\_id\_ in async\_wrap.h (David Corona) [#23495](https://github.com/nodejs/node/pull/23495)
* [[`ec7375ad0e`](https://github.com/nodejs/node/commit/ec7375ad0e)] - **src**: change constructor behavior in stream\_base-inl.h (Ian Sutherland) [#23447](https://github.com/nodejs/node/pull/23447)
* [[`b5f5585b0a`](https://github.com/nodejs/node/commit/b5f5585b0a)] - **src**: throw if functions used as constructors in node\_crypto.cc (Bruce A. MacNaughton) [#23582](https://github.com/nodejs/node/pull/23582)
* [[`fc963cd81c`](https://github.com/nodejs/node/commit/fc963cd81c)] - **src**: reduce platform worker barrier lifetime (Ali Ijaz Sheikh) [#23419](https://github.com/nodejs/node/pull/23419)
* [[`b61bbbbb03`](https://github.com/nodejs/node/commit/b61bbbbb03)] - **src**: trace\_event: secondary storage for metadata (Ali Ijaz Sheikh) [#20900](https://github.com/nodejs/node/pull/20900)
* [[`ecacf33356`](https://github.com/nodejs/node/commit/ecacf33356)] - **src**: fix bug in MallocedBuffer constructor (Tobias Nießen) [#23434](https://github.com/nodejs/node/pull/23434)
* [[`a83096a65d`](https://github.com/nodejs/node/commit/a83096a65d)] - **src**: improve SSL version extraction logic (Gireesh Punathil) [#23050](https://github.com/nodejs/node/pull/23050)
* [[`f40b1dbe5d`](https://github.com/nodejs/node/commit/f40b1dbe5d)] - **src**: revert removal of SecureContext `\_external` getter (Vitaly Dyatlov) [#21711](https://github.com/nodejs/node/pull/21711)
* [[`51fd86730f`](https://github.com/nodejs/node/commit/51fd86730f)] - **src**: remove unused limits header from util-inl.h (Daniel Bevenius) [#23353](https://github.com/nodejs/node/pull/23353)
* [[`5f21755e60`](https://github.com/nodejs/node/commit/5f21755e60)] - **src**: replace NO\_RETURN with \[\[noreturn\]\] (Refael Ackermann) [#23337](https://github.com/nodejs/node/pull/23337)
* [[`4d21e34a6d`](https://github.com/nodejs/node/commit/4d21e34a6d)] - **src**: fix usage of deprecated v8::Date::New (Michaël Zasso) [#23288](https://github.com/nodejs/node/pull/23288)
* [[`c2fee5d1cb`](https://github.com/nodejs/node/commit/c2fee5d1cb)] - **src**: ready background workers before bootstrap (Ali Ijaz Sheikh) [#23233](https://github.com/nodejs/node/pull/23233)
* [[`6580ce54dc`](https://github.com/nodejs/node/commit/6580ce54dc)] - **src**: remove accidentally added src/txt (Joyee Cheung) [#23273](https://github.com/nodejs/node/pull/23273)
* [[`8f84613c93`](https://github.com/nodejs/node/commit/8f84613c93)] - **src**: use default parameters for `UVException()` (Anna Henningsen) [#23176](https://github.com/nodejs/node/pull/23176)
* [[`a7b59d6204`](https://github.com/nodejs/node/commit/a7b59d6204)] - **src**: flip Atomics.notify alias (Gus Caplan) [#22844](https://github.com/nodejs/node/pull/22844)
* [[`8989c76c6e`](https://github.com/nodejs/node/commit/8989c76c6e)] - ***Revert*** "**src**: implement query callbacks for vm" (Anna Henningsen) [#22911](https://github.com/nodejs/node/pull/22911)
* [[`85c356c10e`](https://github.com/nodejs/node/commit/85c356c10e)] - **src**: implement query callbacks for vm (Timothy Gu) [#22390](https://github.com/nodejs/node/pull/22390)
* [[`b85460498f`](https://github.com/nodejs/node/commit/b85460498f)] - **src**: remove old process.binding('trace\_events').emit (James M Snell) [#22127](https://github.com/nodejs/node/pull/22127)
* [[`afc5636fe6`](https://github.com/nodejs/node/commit/afc5636fe6)] - **src**: rename WorkerThreadMain to PlatformWorkerThread (Michaël Zasso) [#21982](https://github.com/nodejs/node/pull/21982)
* [[`2faab111ef`](https://github.com/nodejs/node/commit/2faab111ef)] - **src**: remove defunct timer\_wrap file (Jon Moss) [#21777](https://github.com/nodejs/node/pull/21777)
* [[`e767aa1a2e`](https://github.com/nodejs/node/commit/e767aa1a2e)] - ***Revert*** "**src**: make process.env.TZ setter clear tz cache" (Ruben Bridgewater) [#20228](https://github.com/nodejs/node/pull/20228)
* [[`20373c476d`](https://github.com/nodejs/node/commit/20373c476d)] - **stream**: undo internalBinding() conversion in compat mechanism (Anna Henningsen) [#23662](https://github.com/nodejs/node/pull/23662)
* [[`6a080ab782`](https://github.com/nodejs/node/commit/6a080ab782)] - **test**: add blocks and comments to fs-promises tests (Ian Sutherland) [#23627](https://github.com/nodejs/node/pull/23627)
* [[`b19f339bcf`](https://github.com/nodejs/node/commit/b19f339bcf)] - **test**: increase coverage for readfile with withFileTypes (christian-bromann) [#23557](https://github.com/nodejs/node/pull/23557)
* [[`3b014a1ead`](https://github.com/nodejs/node/commit/3b014a1ead)] - **test**: skip failing tests for osx mojave (jn99) [#23550](https://github.com/nodejs/node/pull/23550)
* [[`5c91b28f04`](https://github.com/nodejs/node/commit/5c91b28f04)] - **test**: fix argument order in assertion (Illescas, Ricardo) [#23581](https://github.com/nodejs/node/pull/23581)
* [[`c55f25abfa`](https://github.com/nodejs/node/commit/c55f25abfa)] - **test**: reversed params in assert.strictEqual() (Dusan Radovanovic) [#23591](https://github.com/nodejs/node/pull/23591)
* [[`24e79bdfc8`](https://github.com/nodejs/node/commit/24e79bdfc8)] - **test**: correct order of args in buffer compare (James Irwin) [#23521](https://github.com/nodejs/node/pull/23521)
* [[`a3c6a8d1a8`](https://github.com/nodejs/node/commit/a3c6a8d1a8)] - **test**: enable trace-events tests for workers (Richard Lau) [#23698](https://github.com/nodejs/node/pull/23698)
* [[`add4f019e4`](https://github.com/nodejs/node/commit/add4f019e4)] - **test**: check codes of thrown errors (Nancy Truong) [#23519](https://github.com/nodejs/node/pull/23519)
* [[`b5c75a331d`](https://github.com/nodejs/node/commit/b5c75a331d)] - **test**: error when empty buffer is passed to filehandle.read() (Masashi Hirano) [#23250](https://github.com/nodejs/node/pull/23250)
* [[`a29631b237`](https://github.com/nodejs/node/commit/a29631b237)] - **test**: error when empty buffer is passed to fs.read() (shisama) [#23141](https://github.com/nodejs/node/pull/23141)
* [[`6445307716`](https://github.com/nodejs/node/commit/6445307716)] - **test**: fix strictEqual arguments order (Jonathan Samines) [#23486](https://github.com/nodejs/node/pull/23486)
* [[`06890ff01c`](https://github.com/nodejs/node/commit/06890ff01c)] - **test**: add test coverage for fs.truncate (christian-bromann) [#23620](https://github.com/nodejs/node/pull/23620)
* [[`eb48f287ab`](https://github.com/nodejs/node/commit/eb48f287ab)] - **test**: use smaller keys for a faster keygen test (Sam Roberts) [#23430](https://github.com/nodejs/node/pull/23430)
* [[`d5525986a8`](https://github.com/nodejs/node/commit/d5525986a8)] - **test**: increased code coverage for slowCases (Jared Haines) [#23592](https://github.com/nodejs/node/pull/23592)
* [[`0b510da6ba`](https://github.com/nodejs/node/commit/0b510da6ba)] - **test**: assertions arguments match docs (Amanuel Ghebreweldi) [#23594](https://github.com/nodejs/node/pull/23594)
* [[`58faae9f3a`](https://github.com/nodejs/node/commit/58faae9f3a)] - **test**: fix assert.strictEqual() argument order (Derek) [#23598](https://github.com/nodejs/node/pull/23598)
* [[`bcd14b2c0f`](https://github.com/nodejs/node/commit/bcd14b2c0f)] - **test**: fix assert parameter order in test-https-localaddress.js (Ian Sutherland) [#23599](https://github.com/nodejs/node/pull/23599)
* [[`1c6a55146e`](https://github.com/nodejs/node/commit/1c6a55146e)] - **test**: change order of assert.strictEquals arguments (Chuck Theobald) [#23600](https://github.com/nodejs/node/pull/23600)
* [[`e345897f06`](https://github.com/nodejs/node/commit/e345897f06)] - **test**: fix assert equal order of arguments (David Jiang) [#23602](https://github.com/nodejs/node/pull/23602)
* [[`d778f9e1f0`](https://github.com/nodejs/node/commit/d778f9e1f0)] - **test**: fix order of assert args in client response domain test (Emily Kolar) [#23604](https://github.com/nodejs/node/pull/23604)
* [[`d08ac84aaa`](https://github.com/nodejs/node/commit/d08ac84aaa)] - **test**: re-order strictEqual paramater calls (Paul Tichonczuk) [#23607](https://github.com/nodejs/node/pull/23607)
* [[`50a280acdb`](https://github.com/nodejs/node/commit/50a280acdb)] - **test**: fix assertions args order (Milton Sosa) [#23608](https://github.com/nodejs/node/pull/23608)
* [[`ff75d98479`](https://github.com/nodejs/node/commit/ff75d98479)] - **test**: fix parameters in test-repl.js (Israel Ortiz) [#23609](https://github.com/nodejs/node/pull/23609)
* [[`c160aacd20`](https://github.com/nodejs/node/commit/c160aacd20)] - **test**: reverse arguments in assert.strictEqual (Vsevolod Geraskin) [#23613](https://github.com/nodejs/node/pull/23613)
* [[`4422269274`](https://github.com/nodejs/node/commit/4422269274)] - **test**: update assertion parameter order (Sean Healy) [#23614](https://github.com/nodejs/node/pull/23614)
* [[`2f481f7bb0`](https://github.com/nodejs/node/commit/2f481f7bb0)] - **test**: fix backward assertion arguments (Stéphane Vasseur) [#23616](https://github.com/nodejs/node/pull/23616)
* [[`907461c289`](https://github.com/nodejs/node/commit/907461c289)] - **test**: reversed 1st and 2nd arguments for assert.strictEqual() (vchoubey08) [#23617](https://github.com/nodejs/node/pull/23617)
* [[`1a43e53f1a`](https://github.com/nodejs/node/commit/1a43e53f1a)] - **test**: correct assertion argument order (Jeff Marvin) [#23618](https://github.com/nodejs/node/pull/23618)
* [[`e7cbc3f4f1`](https://github.com/nodejs/node/commit/e7cbc3f4f1)] - **test**: fix assertion order (erickwendel) [#23626](https://github.com/nodejs/node/pull/23626)
* [[`42f43d5827`](https://github.com/nodejs/node/commit/42f43d5827)] - **test**: updated assert test values to doc standards (keeysnc) [#23593](https://github.com/nodejs/node/pull/23593)
* [[`af59b9dd02`](https://github.com/nodejs/node/commit/af59b9dd02)] - **test**: switch order of assertion arguments (Mel) [#23563](https://github.com/nodejs/node/pull/23563)
* [[`ca24bcf571`](https://github.com/nodejs/node/commit/ca24bcf571)] - **test**: fix assert.strictEqual() argument order (Savio Resende) [#23564](https://github.com/nodejs/node/pull/23564)
* [[`7e79e012b6`](https://github.com/nodejs/node/commit/7e79e012b6)] - **test**: fix parameter order of assertions (Pete Lombardo) [#23565](https://github.com/nodejs/node/pull/23565)
* [[`2d5b6c2bb3`](https://github.com/nodejs/node/commit/2d5b6c2bb3)] - **test**: fix assert value order (Ethan Weber) [#23566](https://github.com/nodejs/node/pull/23566)
* [[`d49937a934`](https://github.com/nodejs/node/commit/d49937a934)] - **test**: fix strictEqual order for timers test (Saleh Abdel Motaal) [#23568](https://github.com/nodejs/node/pull/23568)
* [[`986b6cb01f`](https://github.com/nodejs/node/commit/986b6cb01f)] - **test**: corrected assertion arguments order (francois) [#23569](https://github.com/nodejs/node/pull/23569)
* [[`c3140d078b`](https://github.com/nodejs/node/commit/c3140d078b)] - **test**: fix strictEqual input parameters order (AlixAng) [#23570](https://github.com/nodejs/node/pull/23570)
* [[`b49f4a93a6`](https://github.com/nodejs/node/commit/b49f4a93a6)] - **test**: fix order of arguments passed to strictEqual (Joe Shindelar) [#23571](https://github.com/nodejs/node/pull/23571)
* [[`2d86696f35`](https://github.com/nodejs/node/commit/2d86696f35)] - **test**: augment tests for SourceTextModule (Andrew Eisenberg) [#23572](https://github.com/nodejs/node/pull/23572)
* [[`d35965bbf9`](https://github.com/nodejs/node/commit/d35965bbf9)] - **test**: fix arguments ordering for assertions to match the docs (Liran Tal) [#23575](https://github.com/nodejs/node/pull/23575)
* [[`152e7a53c2`](https://github.com/nodejs/node/commit/152e7a53c2)] - **test**: fixed strictEqual arguments order (Ruy Adorno) [#23576](https://github.com/nodejs/node/pull/23576)
* [[`0d9215986f`](https://github.com/nodejs/node/commit/0d9215986f)] - **test**: add crypto.scrypt test case with different encoding (Yitong) [#23578](https://github.com/nodejs/node/pull/23578)
* [[`96c1dd428c`](https://github.com/nodejs/node/commit/96c1dd428c)] - **test**: reversed actual and expected values for .strictEqual() (Salman Shakeel) [#23579](https://github.com/nodejs/node/pull/23579)
* [[`4b873ee18b`](https://github.com/nodejs/node/commit/4b873ee18b)] - **test**: increased code coverage for proxySessionHandler (Justin Lee) [#23583](https://github.com/nodejs/node/pull/23583)
* [[`62c6e446bd`](https://github.com/nodejs/node/commit/62c6e446bd)] - **test**: fix assertion arguments order (seantcoyote) [#23584](https://github.com/nodejs/node/pull/23584)
* [[`99a7e25ba1`](https://github.com/nodejs/node/commit/99a7e25ba1)] - **test**: fix assert.strictEqual() parameter order in test-path-maklong.js (blakehall) [#23587](https://github.com/nodejs/node/pull/23587)
* [[`53fb82d6b1`](https://github.com/nodejs/node/commit/53fb82d6b1)] - **test**: fix argument order in assertions (Illescas, Ricardo) [#23589](https://github.com/nodejs/node/pull/23589)
* [[`59a221d2a0`](https://github.com/nodejs/node/commit/59a221d2a0)] - **test**: fix order of parameters to assert.strictEqual (Jason Nutter) [#23590](https://github.com/nodejs/node/pull/23590)
* [[`e806167fec`](https://github.com/nodejs/node/commit/e806167fec)] - **test**: removed unused variable in fs-watch-file-slow (Maki Toda) [#23548](https://github.com/nodejs/node/pull/23548)
* [[`0d9e54b3d6`](https://github.com/nodejs/node/commit/0d9e54b3d6)] - **test**: update strictEqual arguments order (Clinton Pahl) [#23552](https://github.com/nodejs/node/pull/23552)
* [[`c254e40b18`](https://github.com/nodejs/node/commit/c254e40b18)] - **test**: removed unused error variable in try catch (Murtaza H) [#23553](https://github.com/nodejs/node/pull/23553)
* [[`90467658ea`](https://github.com/nodejs/node/commit/90467658ea)] - **test**: reverse order of args in reconnect-error assert (Jackelin Herrera) [#23555](https://github.com/nodejs/node/pull/23555)
* [[`3604d78cd3`](https://github.com/nodejs/node/commit/3604d78cd3)] - **test**: added async-hook benchmark (peter) [#23556](https://github.com/nodejs/node/pull/23556)
* [[`4118e90b43`](https://github.com/nodejs/node/commit/4118e90b43)] - **test**: fix order of assert arguments in vm-new-script-this-context (Victor Poriazov) [#23558](https://github.com/nodejs/node/pull/23558)
* [[`2f38550458`](https://github.com/nodejs/node/commit/2f38550458)] - **test**: modernize test-crypto-domain (naris93) [#23559](https://github.com/nodejs/node/pull/23559)
* [[`7298f8a147`](https://github.com/nodejs/node/commit/7298f8a147)] - **test**: fix strictEqual assertion order on readline tests (Joe Grosspietsch) [#23561](https://github.com/nodejs/node/pull/23561)
* [[`bea0819126`](https://github.com/nodejs/node/commit/bea0819126)] - **test**: switch strictEqual parameters - actual first before expected (Chris Bautista) [#23537](https://github.com/nodejs/node/pull/23537)
* [[`bd3b52fc17`](https://github.com/nodejs/node/commit/bd3b52fc17)] - **test**: assert.strictEqual parameters ordered correctly (Justin denBroeder) [#23538](https://github.com/nodejs/node/pull/23538)
* [[`07d3f470da`](https://github.com/nodejs/node/commit/07d3f470da)] - **test**: fix assert.strictEqual() arguments order (Ivan Lukasevych) [#23539](https://github.com/nodejs/node/pull/23539)
* [[`ef2cbf826a`](https://github.com/nodejs/node/commit/ef2cbf826a)] - **test**: reverse the order of assertion statement arguments in pingpong test (Allan Zheng) [#23540](https://github.com/nodejs/node/pull/23540)
* [[`44b569c8b0`](https://github.com/nodejs/node/commit/44b569c8b0)] - **test**: added test for generateKeyPair (David Xue) [#23541](https://github.com/nodejs/node/pull/23541)
* [[`ea90776227`](https://github.com/nodejs/node/commit/ea90776227)] - **test**: swap expected and actual arguments in assert.strictEqual() (Erin Bush) [#23542](https://github.com/nodejs/node/pull/23542)
* [[`1f6c86d1ea`](https://github.com/nodejs/node/commit/1f6c86d1ea)] - **test**: fix assertions argument order (KelvinLawHF1) [#23544](https://github.com/nodejs/node/pull/23544)
* [[`0655229240`](https://github.com/nodejs/node/commit/0655229240)] - **test**: fix assertion argument order (Carl Richmond) [#23545](https://github.com/nodejs/node/pull/23545)
* [[`4518ca9c32`](https://github.com/nodejs/node/commit/4518ca9c32)] - **test**: refactor callback functions to arrow functions (Sean Healy) [#23546](https://github.com/nodejs/node/pull/23546)
* [[`c9afea9e79`](https://github.com/nodejs/node/commit/c9afea9e79)] - **test**: updating assertion and expect order in test-tls-client-verify.js (Eli Itah) [#23547](https://github.com/nodejs/node/pull/23547)
* [[`47b7f2ac44`](https://github.com/nodejs/node/commit/47b7f2ac44)] - **test**: use correct argument order for assert.strictEqual() (Oktavianus Ludiro) [#23527](https://github.com/nodejs/node/pull/23527)
* [[`1fd1e605be`](https://github.com/nodejs/node/commit/1fd1e605be)] - **test**: corrected the order of arguments in assert.strictEqual() (Diana Lee) [#23528](https://github.com/nodejs/node/pull/23528)
* [[`cb9fe73ab7`](https://github.com/nodejs/node/commit/cb9fe73ab7)] - **test**: fix assert.strictEqual() argument order (ssamuels0916) [#23529](https://github.com/nodejs/node/pull/23529)
* [[`1c220889e0`](https://github.com/nodejs/node/commit/1c220889e0)] - **test**: fix strictEqual assertion argument in test-tls-ecdh-auto (jaxyz) [#23530](https://github.com/nodejs/node/pull/23530)
* [[`d0a77f0a86`](https://github.com/nodejs/node/commit/d0a77f0a86)] - **test**: correct labelling of asserts errors (nofwayy) [#23531](https://github.com/nodejs/node/pull/23531)
* [[`ffab8ba33f`](https://github.com/nodejs/node/commit/ffab8ba33f)] - **test**: reorder asserts arguments (Marcos Frony) [#23534](https://github.com/nodejs/node/pull/23534)
* [[`69365ef25c`](https://github.com/nodejs/node/commit/69365ef25c)] - **test**: updating assertion on test so it fits the new method signature (garrik.leonardo@gmail.com) [#23536](https://github.com/nodejs/node/pull/23536)
* [[`9e6c983884`](https://github.com/nodejs/node/commit/9e6c983884)] - **test**: refactor functions to es6 (Michael Chen) [#23510](https://github.com/nodejs/node/pull/23510)
* [[`b06113aba1`](https://github.com/nodejs/node/commit/b06113aba1)] - **test**: replaced functions with arrow functions (edgarzapeka) [#23511](https://github.com/nodejs/node/pull/23511)
* [[`e4e89837db`](https://github.com/nodejs/node/commit/e4e89837db)] - **test**: corret assertion arg order in test-regress-GH-892.js (Elvis-Philip N) [#23513](https://github.com/nodejs/node/pull/23513)
* [[`05ce3946ee`](https://github.com/nodejs/node/commit/05ce3946ee)] - **test**: fix test-dgram-pingpong assertion arg order (David Ward) [#23514](https://github.com/nodejs/node/pull/23514)
* [[`4958e7ad34`](https://github.com/nodejs/node/commit/4958e7ad34)] - **test**: fix assert.strictEqual() argument order (Ben Schaaf) [#23515](https://github.com/nodejs/node/pull/23515)
* [[`1eea1aa513`](https://github.com/nodejs/node/commit/1eea1aa513)] - **test**: fix assert.strictEqual arg order in test-tls-ecdh-multiple.js (Takdeer Sodhan) [#23516](https://github.com/nodejs/node/pull/23516)
* [[`d5485ec90b`](https://github.com/nodejs/node/commit/d5485ec90b)] - **test**: use the correct parameter order on assert.strictEqual() (Tyler Vann-Campbell) [#23520](https://github.com/nodejs/node/pull/23520)
* [[`e9efac6dfd`](https://github.com/nodejs/node/commit/e9efac6dfd)] - **test**: fix assert order in test-vm-context (Lee Gray) [#23523](https://github.com/nodejs/node/pull/23523)
* [[`ba5cf7b2a9`](https://github.com/nodejs/node/commit/ba5cf7b2a9)] - **test**: switch arguments of assert() (Arne Schramm) [#23524](https://github.com/nodejs/node/pull/23524)
* [[`87eeb6b373`](https://github.com/nodejs/node/commit/87eeb6b373)] - **test**: swap assert argument order in test-vm-create-and-run-in-context.js (Pascal Lambert) [#23525](https://github.com/nodejs/node/pull/23525)
* [[`2cd0ef09ec`](https://github.com/nodejs/node/commit/2cd0ef09ec)] - **test**: fix order of assert.strictEqual() args to actual, expected (Joshua Belcher) [#23501](https://github.com/nodejs/node/pull/23501)
* [[`f6204c58c0`](https://github.com/nodejs/node/commit/f6204c58c0)] - **test**: fixed incorrect variable order in assert.strictEqual() (Daniyal Mokhammad) [#23502](https://github.com/nodejs/node/pull/23502)
* [[`fd3b1d115c`](https://github.com/nodejs/node/commit/fd3b1d115c)] - **test**: properly order test assertion variables (David Scott) [#23503](https://github.com/nodejs/node/pull/23503)
* [[`e087f2665c`](https://github.com/nodejs/node/commit/e087f2665c)] - **test**: modernize test-child-process-flush-stdio (Viacheslav Liakhov) [#23504](https://github.com/nodejs/node/pull/23504)
* [[`c377053e82`](https://github.com/nodejs/node/commit/c377053e82)] - **test**: put expected assert value in correct place (Jean-Francois Arseneau) [#23505](https://github.com/nodejs/node/pull/23505)
* [[`345974a8ad`](https://github.com/nodejs/node/commit/345974a8ad)] - **test**: fix argument order in assertions (Illescas, Ricardo) [#23506](https://github.com/nodejs/node/pull/23506)
* [[`8cc52b0bc0`](https://github.com/nodejs/node/commit/8cc52b0bc0)] - **test**: fix assertions args order in test/parallel/test-fs-chmod.js (Milton Sosa) [#23507](https://github.com/nodejs/node/pull/23507)
* [[`556293283a`](https://github.com/nodejs/node/commit/556293283a)] - **test**: fix strictEqual assertion arguments (Alejandro Oviedo Garcia) [#23508](https://github.com/nodejs/node/pull/23508)
* [[`bb8dd485c2`](https://github.com/nodejs/node/commit/bb8dd485c2)] - **test**: fix ordering of assertion values (Andrew MacCuaig)
* [[`5bc49f9c0c`](https://github.com/nodejs/node/commit/5bc49f9c0c)] - **test**: update function keywords to fat arrows (Robert Monks) [#23493](https://github.com/nodejs/node/pull/23493)
* [[`697359637a`](https://github.com/nodejs/node/commit/697359637a)] - **test**: reversed arguments in strictqual to reflect documentation (scabhi) [#23494](https://github.com/nodejs/node/pull/23494)
* [[`e0eb19b1d2`](https://github.com/nodejs/node/commit/e0eb19b1d2)] - **test**: modernized test to use arrow functions (Greg Goforth) [#23496](https://github.com/nodejs/node/pull/23496)
* [[`670770e275`](https://github.com/nodejs/node/commit/670770e275)] - **test**: use arrow functions in test-exception-handler (Jenna Zeigen) [#23498](https://github.com/nodejs/node/pull/23498)
* [[`ab052af697`](https://github.com/nodejs/node/commit/ab052af697)] - **test**: fix argument order in asserts (@CAYdenberg) [#23499](https://github.com/nodejs/node/pull/23499)
* [[`0eb5f13062`](https://github.com/nodejs/node/commit/0eb5f13062)] - **test**: modernizing test-dgram-listen-after-bind with arrow functions (chrisforrette) [#23500](https://github.com/nodejs/node/pull/23500)
* [[`945f9d728e`](https://github.com/nodejs/node/commit/945f9d728e)] - **test**: fix strictEqual argument order (Felix Schlenkrich) [#23490](https://github.com/nodejs/node/pull/23490)
* [[`3fc8c7aca8`](https://github.com/nodejs/node/commit/3fc8c7aca8)] - **test**: rename process.argv\[0\] to process.execPath, rename ex to err (Kayla Altepeter) [#23488](https://github.com/nodejs/node/pull/23488)
* [[`280aed1312`](https://github.com/nodejs/node/commit/280aed1312)] - **test**: fix assertion argument order (Carl Richmond) [#23489](https://github.com/nodejs/node/pull/23489)
* [[`b041922663`](https://github.com/nodejs/node/commit/b041922663)] - **test**: fix assertion order test-tls-server-verify (Carolina Pinzon) [#23549](https://github.com/nodejs/node/pull/23549)
* [[`147102372d`](https://github.com/nodejs/node/commit/147102372d)] - **test**: move tick.js from test/async-hooks to test/common (Artur Hayrapetyan) [#23551](https://github.com/nodejs/node/pull/23551)
* [[`39377bc58f`](https://github.com/nodejs/node/commit/39377bc58f)] - **test**: fix assertion order (Chris Nguyen) [#23533](https://github.com/nodejs/node/pull/23533)
* [[`e9962b9cf9`](https://github.com/nodejs/node/commit/e9962b9cf9)] - **test**: change to arrow functions in send-bad-arguments (Anna Zhao) [#23483](https://github.com/nodejs/node/pull/23483)
* [[`d70a0cd294`](https://github.com/nodejs/node/commit/d70a0cd294)] - **test**: removed unused variable (Michal Hynek) [#23481](https://github.com/nodejs/node/pull/23481)
* [[`a797923ba5`](https://github.com/nodejs/node/commit/a797923ba5)] - **test**: fix argument order for assert.strictEqual (Stacey) [#23485](https://github.com/nodejs/node/pull/23485)
* [[`6936f9cb14`](https://github.com/nodejs/node/commit/6936f9cb14)] - **test**: fix assert.strictEqual params order (Rock Hu) [#23480](https://github.com/nodejs/node/pull/23480)
* [[`b6e9f99910`](https://github.com/nodejs/node/commit/b6e9f99910)] - **test**: removed mustCallAsync from common and added inside testcase (Quinn Langille) [#23467](https://github.com/nodejs/node/pull/23467)
* [[`1408e323f9`](https://github.com/nodejs/node/commit/1408e323f9)] - **test**: remove unused "e" from catch in http2 test (Stephen Heitman) [#23476](https://github.com/nodejs/node/pull/23476)
* [[`b5c698d328`](https://github.com/nodejs/node/commit/b5c698d328)] - **test**: remove unused variable from catch (Paige Kato) [#23477](https://github.com/nodejs/node/pull/23477)
* [[`e527321a98`](https://github.com/nodejs/node/commit/e527321a98)] - **test**: inline common module boolean (ashleysimpson) [#23479](https://github.com/nodejs/node/pull/23479)
* [[`cbc140fb6a`](https://github.com/nodejs/node/commit/cbc140fb6a)] - **test**: swap the order arguments are passed to assert (Dylson Valente Neto) [#23580](https://github.com/nodejs/node/pull/23580)
* [[`f1997b7150`](https://github.com/nodejs/node/commit/f1997b7150)] - **test**: flip assertion arguments for make-callback/test.js (Tim Cheung) [#23470](https://github.com/nodejs/node/pull/23470)
* [[`ec675b8ea4`](https://github.com/nodejs/node/commit/ec675b8ea4)] - **test**: replace function with arrow function (Yitong) [#23474](https://github.com/nodejs/node/pull/23474)
* [[`923f37ff7c`](https://github.com/nodejs/node/commit/923f37ff7c)] - **test**: swap actual and expected in assertions (Yitong) [#23474](https://github.com/nodejs/node/pull/23474)
* [[`90504b97cd`](https://github.com/nodejs/node/commit/90504b97cd)] - **test**: correctly order assertion arguments (Emily Kolar) [#23473](https://github.com/nodejs/node/pull/23473)
* [[`2d2388d9dd`](https://github.com/nodejs/node/commit/2d2388d9dd)] - **test**: fix errors in test-buffer-alloc.js (Rich Trott) [#23645](https://github.com/nodejs/node/pull/23645)
* [[`5e68333ead`](https://github.com/nodejs/node/commit/5e68333ead)] - **test**: mark `test-http2-session-timeout` as flake on ARM (Refael Ackermann) [#23639](https://github.com/nodejs/node/pull/23639)
* [[`2d0532e7c1`](https://github.com/nodejs/node/commit/2d0532e7c1)] - **test**: update test-cluster-worker-events to use arrow functions (S. Everett Abbott) [#23469](https://github.com/nodejs/node/pull/23469)
* [[`ec8fbfb26a`](https://github.com/nodejs/node/commit/ec8fbfb26a)] - **test**: correct order for assert.strictEqual for inspector-helper test (Maggie Nolan) [#23468](https://github.com/nodejs/node/pull/23468)
* [[`722e0d4921`](https://github.com/nodejs/node/commit/722e0d4921)] - **test**: fix incorrect expectation order (Amie) [#23466](https://github.com/nodejs/node/pull/23466)
* [[`b35d234b12`](https://github.com/nodejs/node/commit/b35d234b12)] - **test**: remove unused e variable in catch statement (Denny Scott) [#23465](https://github.com/nodejs/node/pull/23465)
* [[`30c48fd296`](https://github.com/nodejs/node/commit/30c48fd296)] - **test**: correct assert test (Richard Markins) [#23463](https://github.com/nodejs/node/pull/23463)
* [[`7d0f50cc34`](https://github.com/nodejs/node/commit/7d0f50cc34)] - **test**: fix incorrect ordering of args in assert.strictEqual() (mdaum) [#23461](https://github.com/nodejs/node/pull/23461)
* [[`09a664431a`](https://github.com/nodejs/node/commit/09a664431a)] - **test**: swap assert.strictEqual args to actual, expected (epeden) [#23459](https://github.com/nodejs/node/pull/23459)
* [[`47784c47f4`](https://github.com/nodejs/node/commit/47784c47f4)] - **test**: fix assert.strictEqual argument order (andy addington) [#23457](https://github.com/nodejs/node/pull/23457)
* [[`ce7555ddeb`](https://github.com/nodejs/node/commit/ce7555ddeb)] - **test**: strictEqual correct order for http-information-processing test (Ivan Sieder) [#23456](https://github.com/nodejs/node/pull/23456)
* [[`4296837468`](https://github.com/nodejs/node/commit/4296837468)] - **test**: replace assert.throws w/ common.expectsError (Andrew Eisenberg) [#23454](https://github.com/nodejs/node/pull/23454)
* [[`aa63e5539e`](https://github.com/nodejs/node/commit/aa63e5539e)] - **test**: fix http local address test assertion (Danu Widatama) [#23451](https://github.com/nodejs/node/pull/23451)
* [[`3829e99b29`](https://github.com/nodejs/node/commit/3829e99b29)] - **test**: fix order of values in test assertions (Jared Haines) [#23450](https://github.com/nodejs/node/pull/23450)
* [[`1c36943b8d`](https://github.com/nodejs/node/commit/1c36943b8d)] - **test**: fix `assert.strictEqual` arguments in test/parallel/test-c-ares.js (jungkumseok) [#23448](https://github.com/nodejs/node/pull/23448)
* [[`db2be04eb8`](https://github.com/nodejs/node/commit/db2be04eb8)] - **test**: improve test coverage for fs module (garrik.leonardo@gmail.com) [#23601](https://github.com/nodejs/node/pull/23601)
* [[`a0468fe900`](https://github.com/nodejs/node/commit/a0468fe900)] - **test**: fix parameter order passed to strictEqual (Shannon) [#23577](https://github.com/nodejs/node/pull/23577)
* [[`0579784eab`](https://github.com/nodejs/node/commit/0579784eab)] - **test**: adding test coverage for SourceTextModule.evaluate (Kayla Altepeter) [#23595](https://github.com/nodejs/node/pull/23595)
* [[`208ee3e570`](https://github.com/nodejs/node/commit/208ee3e570)] - **test**: move some gc tests back to parallel/, unmark flaky (Anna Henningsen) [#23356](https://github.com/nodejs/node/pull/23356)
* [[`939a27e91b`](https://github.com/nodejs/node/commit/939a27e91b)] - **test**: improve test-gc-http-client-onerror (Denys Otrishko) [#23196](https://github.com/nodejs/node/pull/23196)
* [[`91bad82638`](https://github.com/nodejs/node/commit/91bad82638)] - **test**: improve test-gc-http-client-connaborted (Denys Otrishko) [#23193](https://github.com/nodejs/node/pull/23193)
* [[`bd88c9864f`](https://github.com/nodejs/node/commit/bd88c9864f)] - **test**: fix assert.strictEqual argument order (et4891) [#23518](https://github.com/nodejs/node/pull/23518)
* [[`f2c57e7e1c`](https://github.com/nodejs/node/commit/f2c57e7e1c)] - **test**: fixing assertion value order (Joe Sepi) [#23574](https://github.com/nodejs/node/pull/23574)
* [[`66eb35f1e6`](https://github.com/nodejs/node/commit/66eb35f1e6)] - **test**: rename common.ddCommand() (Rich Trott) [#23411](https://github.com/nodejs/node/pull/23411)
* [[`8561462005`](https://github.com/nodejs/node/commit/8561462005)] - **test**: refactor common.ddCommand() (Rich Trott) [#23411](https://github.com/nodejs/node/pull/23411)
* [[`0fa857f619`](https://github.com/nodejs/node/commit/0fa857f619)] - **test**: add logging to test-worker-memory (Rich Trott) [#23418](https://github.com/nodejs/node/pull/23418)
* [[`3c4d316d03`](https://github.com/nodejs/node/commit/3c4d316d03)] - **test**: add test for a vm indexed property (conectado) [#23318](https://github.com/nodejs/node/pull/23318)
* [[`e774d1b898`](https://github.com/nodejs/node/commit/e774d1b898)] - **test**: fix compiler warning in doc/api/addons.md (Daniel Bevenius) [#23323](https://github.com/nodejs/node/pull/23323)
* [[`c030854a54`](https://github.com/nodejs/node/commit/c030854a54)] - **test**: add WPT console-tests-historical (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* [[`bd7e57a023`](https://github.com/nodejs/node/commit/bd7e57a023)] - **test**: separate WPT console test from other test (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* [[`172e552655`](https://github.com/nodejs/node/commit/172e552655)] - **test**: add WPT console-label-conversion test (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* [[`0b61f3970e`](https://github.com/nodejs/node/commit/0b61f3970e)] - **test**: rename WPT console test (Rich Trott) [#23340](https://github.com/nodejs/node/pull/23340)
* [[`52b58a2ac5`](https://github.com/nodejs/node/commit/52b58a2ac5)] - **test**: fix broken test (cjihrig) [#23232](https://github.com/nodejs/node/pull/23232)
* [[`8e189794df`](https://github.com/nodejs/node/commit/8e189794df)] - **test**: remove skip of OS X bug (Rich Trott) [#22546](https://github.com/nodejs/node/pull/22546)
* [[`1f1675817c`](https://github.com/nodejs/node/commit/1f1675817c)] - **test**: check option start or end is not safe integer (Masashi Hirano) [#21704](https://github.com/nodejs/node/pull/21704)
* [[`60ef7d1a8f`](https://github.com/nodejs/node/commit/60ef7d1a8f)] - **test**: fix assertion in test-console (Luigi Pinca) [#20557](https://github.com/nodejs/node/pull/20557)
* [[`7db4281e52`](https://github.com/nodejs/node/commit/7db4281e52)] - **tls**: close StreamWrap and its stream correctly (Ouyang Yadong) [#23654](https://github.com/nodejs/node/pull/23654)
* [[`934eb7ec59`](https://github.com/nodejs/node/commit/934eb7ec59)] - **tls**: prevent multiple connection errors (cjihrig) [#23636](https://github.com/nodejs/node/pull/23636)
* [[`d1a23cc954`](https://github.com/nodejs/node/commit/d1a23cc954)] - **tls**: update try catch syntax (Matt Jiles) [#23484](https://github.com/nodejs/node/pull/23484)
* [[`318f1cdc99`](https://github.com/nodejs/node/commit/318f1cdc99)] - **tls**: make StreamWrap work correctly in "drain" callback (Ouyang Yadong) [#23294](https://github.com/nodejs/node/pull/23294)
* [[`dc33b3e811`](https://github.com/nodejs/node/commit/dc33b3e811)] - **tls**: update test & docs for ArrayBuffer/DataView (Beni von Cheni) [#23210](https://github.com/nodejs/node/pull/23210)
* [[`cdd58e6bd4`](https://github.com/nodejs/node/commit/cdd58e6bd4)] - **tools**: clarify commit message linting (Rich Trott) [#23742](https://github.com/nodejs/node/pull/23742)
* [[`40280e62a3`](https://github.com/nodejs/node/commit/40280e62a3)] - **tools**: do not lint commit message if var undefined (Rich Trott) [#23725](https://github.com/nodejs/node/pull/23725)
* [[`77b3666b84`](https://github.com/nodejs/node/commit/77b3666b84)] - **tools**: prefer filter to remove empty strings (Sakthipriyan Vairamani (thefourtheye)) [#23727](https://github.com/nodejs/node/pull/23727)
* [[`74ebfa379a`](https://github.com/nodejs/node/commit/74ebfa379a)] - **tools**: update ESLint to 5.7.0 (cjihrig) [#23629](https://github.com/nodejs/node/pull/23629)
* [[`8460df4334`](https://github.com/nodejs/node/commit/8460df4334)] - **tools**: update node-lint-md-cli-rollup (Rich Trott) [#23358](https://github.com/nodejs/node/pull/23358)
* [[`47af3a1bfd`](https://github.com/nodejs/node/commit/47af3a1bfd)] - **tools,icu**: read full ICU version info from file (Refael Ackermann) [#23269](https://github.com/nodejs/node/pull/23269)
* [[`74c4bb7e77`](https://github.com/nodejs/node/commit/74c4bb7e77)] - **tools,test**: add list of slow tests (Refael Ackermann) [#23251](https://github.com/nodejs/node/pull/23251)
* [[`5b79d55ce3`](https://github.com/nodejs/node/commit/5b79d55ce3)] - **tools,test**: cleanup and dedup code (Refael Ackermann) [#23251](https://github.com/nodejs/node/pull/23251)
* [[`1ef83c882b`](https://github.com/nodejs/node/commit/1ef83c882b)] - **trace_events**: destroy platform before tracing (Ali Ijaz Sheikh) [#22938](https://github.com/nodejs/node/pull/22938)
* [[`4b7cd4bd60`](https://github.com/nodejs/node/commit/4b7cd4bd60)] - **trace_events**: add trace category enabled tracking (James M Snell) [#22128](https://github.com/nodejs/node/pull/22128)
* [[`c85933cbd0`](https://github.com/nodejs/node/commit/c85933cbd0)] - **trace_events,async_hooks**: use intrinsic trace (James M Snell) [#22127](https://github.com/nodejs/node/pull/22127)
* [[`c834be0a06`](https://github.com/nodejs/node/commit/c834be0a06)] - ***Revert*** "**tty**: make \_read throw ERR\_TTY\_WRITABLE\_NOT\_READABLE" (Anna Henningsen) [#23053](https://github.com/nodejs/node/pull/23053)
* [[`f4e4ef5cad`](https://github.com/nodejs/node/commit/f4e4ef5cad)] - **util**: handle null prototype on inspect (Anto Aravinth) [#22331](https://github.com/nodejs/node/pull/22331)
* [[`849aaaeeb0`](https://github.com/nodejs/node/commit/849aaaeeb0)] - ***Revert*** "**util**: change util.inspect depth default" (Anna Henningsen) [#20017](https://github.com/nodejs/node/pull/20017)
* [[`85373aeb4c`](https://github.com/nodejs/node/commit/85373aeb4c)] - ***Revert*** "**util**: change %o depth default" (Anna Henningsen) [#20017](https://github.com/nodejs/node/pull/20017)
* [[`2f83ddc353`](https://github.com/nodejs/node/commit/2f83ddc353)] - **vm**: pass parsing\_context to ScriptCompiler::CompileFunctionInContext (Dara Hayes) [#23206](https://github.com/nodejs/node/pull/23206)
* [[`6487f07e0c`](https://github.com/nodejs/node/commit/6487f07e0c)] - **vm**: add dynamic import support (Gus Caplan) [#22381](https://github.com/nodejs/node/pull/22381)
* [[`7673de8f58`](https://github.com/nodejs/node/commit/7673de8f58)] - **worker**: remove delete MessagePort.prototype.hasRef (James Traver) [#23471](https://github.com/nodejs/node/pull/23471)
* [[`188ffcb960`](https://github.com/nodejs/node/commit/188ffcb960)] - **zlib**: refactor zlib internals (Anna Henningsen) [#23360](https://github.com/nodejs/node/pull/23360)
* [[`e0828635c5`](https://github.com/nodejs/node/commit/e0828635c5)] - **zlib**: generate error code names in C++ (Anna Henningsen) [#23413](https://github.com/nodejs/node/pull/23413)
